/*
*********************************************************************************************************
*
*	ģ : RA8875оƬģ
*	ļ : LCD_RA8875.c
*	     : V1.6
*	˵     : RA8875ײ
*	޸ļ¼ :
*		汾             ˵
*		V1.0    2012-08-07 armfly  װ
*		V1.1    2012-10-23 armfly  ƾκBUG߶ȿȼ󣩣SPI-4ӿģʽ
*								   2Dͼεĺæʵ⡣
*								   У׼4У׼
*		V1.2    2012-11-07 armfly  4У׼BUG
*		V1.3    2012-12-12 armfly  7߳
*		V1.4    2013-05-04 armfly  ӽͼģʽĺͷֱд RA8875_StartDirectDraw
*									RA8875_GetDispMemAddr, RA8875_QuitDirectDraw
*       V1.5    2013-06-12 armfly  ΪIAR澯ȥ s_WinXs_WinY, s_WinHeight,s_WinWidthǰ__IO
*		V1.6    2013-06-26 armfly  Ӻ  RA8875_CtrlGPO() KOUT0-KOUT3 ߵ״̬
*		V1.7    2013-06-26 armfly  Ӻ  RA8875_CtrlGPO() ͹
*		V1.8    2013-06-29 armfly  ޸ RA8875_GetPixel() BUGҪ2Ρ0x40ĴΪ겻
*		V1.9	2013-07-24 armfly  ޸ RA8875_DrawLine() , ʼֹͬʱ.⴦
*		V2.0	2013-09-22 armfly   RA8875Ӳ2DͼBUG޸ɺͻ⡣
*		V2.1    2013-09-26 armfly  MCUӿصĺ뵽 bsp_ra8875_port.c ļ
*		V2.2    2014-01-31 armfly   RA8875_DispBmpInFlash() ,ʾRA8875ҴFlashеBMPλͼ
*
*	Copyright (C), 2011-2012,  www.armfly.com
*
*********************************************************************************************************
*/

#include "bsp.h"

#include "bsp_ra8875_port.h"

#define FLASH_DUAL_SPEED_EN			/* ˫ģʽ MOSIMISOͬʱȡֿͼе. */

static __IO uint16_t s_usTouchX, s_usTouchY;	/* ADCֵ */
static __IO uint8_t s_ucRA8875Busy = 0;			/* æ־, ģͨ RA8875_IsBusy()жæ */

/* 浱ǰʾڵλúʹС⼸ RA8875_SetDispWin()  */
static uint16_t s_WinX = 0;
static uint16_t s_WinY = 0;
static uint16_t s_WinHeight = 272;
static uint16_t s_WinWidth = 480;

static void RA8875_WriteReg(uint8_t _ucRegAddr, uint8_t _ucRegValue);
static uint8_t RA8875_ReadReg(uint8_t _ucRegAddr);

static void RA8875_SetCursor(uint16_t _usX, uint16_t _usY);
static void RA8875_SetReadCursor(uint16_t _usX, uint16_t _usY);
static void RA8875_SetTextCursor(uint16_t _usX, uint16_t _usY);

static void BTE_SetTarBlock(uint16_t _usX, uint16_t _usY, uint16_t _usHeight, uint16_t _usWidth, uint8_t _ucLayer);
static void BTE_SetOperateCode(uint8_t _ucOperate);
static void BTE_Start(void);

/*
*********************************************************************************************************
*	  : RA8875_ReadID
*	˵: ȡLCDоƬID
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
uint16_t RA8875_ReadID(void)
{
	return RA8875_ReadReg(0x00);
}

/*
*********************************************************************************************************
*	  : RA8875_WriteReg
*	˵: дRA8875Ĵ. RA8875ļĴַݶ8bit
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
static void RA8875_WriteReg(uint8_t _ucRegAddr, uint8_t _ucRegValue)
{
	s_ucRA8875Busy = 1;				/* æ־ⴥжеĳʳͻ */

	RA8875_WriteCmd(_ucRegAddr);
	RA8875_WriteData(_ucRegValue);

	s_ucRA8875Busy = 0;
}

/*
*********************************************************************************************************
*	  : RA8875_WriteReg
*	˵: дRA8875Ĵ. RA8875ļĴַݶ8bit
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
static uint8_t RA8875_ReadReg(uint8_t _ucRegAddr)
{
	RA8875_WriteCmd(_ucRegAddr);
	return RA8875_ReadData();
}

/*
*********************************************************************************************************
*	  : RA8875_InitHard
*	˵: ʼRA8875⣬ӦڳʼϺٵ RA8875_SetBackLight()
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void RA8875_InitHard(void)
{
	uint8_t ucGPIX;

#ifdef IF_SPI_EN	   /* SPIӿģʽ */
	RA8875_InitSPI();
#endif

	/* ȡ RA8875 оƬGPIXŵĵƽ״̬1ʾ4.30ʾ7
	עǰΪ˱ͳһ̣LCDģӲʶƷʱԶʶ
	*/
	ucGPIX = RA8875_ReadReg(0xC7);

	if (ucGPIX == 1)	/* 	GPIX = 1 ʾ 4.3  480x272 */
	{
		/* ʼPLL.  ƵΪ25M */
		RA8875_WriteCmd(0x88);
		RA8875_Delaly1us();		/* ӳ1us */
		RA8875_WriteData(10);	/* PLLDIVM [7] = 0 ;  PLLDIVN [4:0] = 10 */

	    RA8875_Delaly1ms();

		RA8875_WriteCmd(0x89);
		RA8875_Delaly1us();		/* ӳ1us */
		RA8875_WriteData(2);		/* PLLDIVK[2:0] = 2, 4 */

		/* RA8875 ڲϵͳƵ (SYS_CLK) ǽ񵴵·PLL ·Ƶʼ㹫ʽ :
		  SYS_CLK = FIN * ( PLLDIVN [4:0] +1 ) / ((PLLDIVM+1 ) * ( 2^PLLDIVK [2:0] ))
		          = 25M * (10 + 1) / ((0 + 1) * (2 ^ 2))
				  = 68.75MHz
		*/

		/* REG[88h]REG[89h]趨Ϊ֤PLL ȶȴһΡƵʱ䡹(< 100us)*/
	    RA8875_Delaly1ms();

		/*
			ϵͳƼĴ pdf 18ҳ:

			bit3:2 ɫ趨 (Color Depth Setting)
				00b : 8-bpp ͨTFT ӿڣ i.e. 256 ɫ
				1xb : 16-bpp ͨTFT ӿڣ i.e. 65K ɫ	 ѡ

			bit1:0 MCUIF ѡ
				00b : 8-λMCU ӿڡ
				1xb : 16-λMCU ӿڡ ѡ
		*/
		#ifdef IF_SPI_EN
			RA8875_WriteReg(0x10, (1 <<3 ) | (0 << 1));	/* SPIӿʱ8λ65Kɫ */
		#else
			RA8875_WriteReg(0x10, (1 <<3 ) | (1 << 1));	/* 16λMCUڣ65Kɫ */
		#endif

		/* REG[04h] Pixel Clock Setting Register   PCSR
			bit7  PCLK Inversion
				0 : PDAT PCLK Ե (Rising Edge) ʱȡ
				1 : PDAT PCLK Ե½ (Falling Edge) ʱȡ
			bit1:0 PCLK Ƶ趨
				Pixel Clock  PCLK Ƶ趨
				00b: PCLK Ƶ= ϵͳƵڡ
				01b: PCLK Ƶ= 2 ϵͳƵڡ
				10b: PCLK Ƶ= 4 ϵͳƵڡ
				11b: PCLK Ƶ= 8 ϵͳƵڡ
		*/
	    RA8875_WriteReg(0x04, 0x82);    /* PCLK */
	    RA8875_Delaly1ms();

	    //Horizontal set
	    //HDWR//Horizontal Display Width Setting Bit[6:0]
	 	//Horizontal display width(pixels) = (HDWR + 1)*8
	    RA8875_WriteReg(0x14, 0x3B);
	    RA8875_WriteReg(0x15, 0x00);

	    //HNDR//Horizontal Non-Display Period Bit[4:0]
	    //Horizontal Non-Display Period (pixels) = (HNDR + 1)*8
		RA8875_WriteReg(0x16, 0x01);

	    //HSTR//HSYNC Start Position[4:0]
	    //HSYNC Start Position(PCLK) = (HSTR + 1)*8
		RA8875_WriteReg(0x17, 0x00);

	    //HPWR//HSYNC Polarity ,The period width of HSYNC.
	    //HSYNC Width [4:0]   HSYNC Pulse width(PCLK) = (HPWR + 1)*8
		RA8875_WriteReg(0x18, 0x05);

	    //Vertical set
	    //VDHR0 //Vertical Display Height Bit [7:0]
	    //Vertical pixels = VDHR + 1
		RA8875_WriteReg(0x19, 0x0F);

	    //VDHR1 //Vertical Display Height Bit [8]
	    //Vertical pixels = VDHR + 1
		RA8875_WriteReg(0x1A, 0x01);

	    //VNDR0 //Vertical Non-Display Period Bit [7:0]
	    //Vertical Non-Display area = (VNDR + 1)
		RA8875_WriteReg(0x1B, 0x02);

	    //VNDR1 //Vertical Non-Display Period Bit [8]
	    //Vertical Non-Display area = (VNDR + 1)
		RA8875_WriteReg(0x1C, 0x00);

	    //VSTR0 //VSYNC Start Position[7:0]
	    //VSYNC Start Position(PCLK) = (VSTR + 1)
		RA8875_WriteReg(0x1D, 0x07);

	    //VSTR1 //VSYNC Start Position[8]
	    //VSYNC Start Position(PCLK) = (VSTR + 1)
		RA8875_WriteReg(0x1E, 0x00);

	    //VPWR //VSYNC Polarity ,VSYNC Pulse Width[6:0]
	    //VSYNC Pulse Width(PCLK) = (VPWR + 1)
	    RA8875_WriteReg(0x1F, 0x09);


	    g_LcdHeight = LCD_43_HEIGHT;
		g_LcdWidth = LCD_43_WIDTH;
	}
	else	/* GPIX = 0 ʾ7(800x480) */
	{
	    g_LcdHeight = LCD_70_HEIGHT;
		g_LcdWidth = LCD_70_WIDTH;

		/* ʼPLL.  ƵΪ25M */
		RA8875_WriteCmd(0x88);
		RA8875_Delaly1us();		/* ӳ1us */
		RA8875_WriteData(12);	/* PLLDIVM [7] = 0 ;  PLLDIVN [4:0] = 10 */

	    RA8875_Delaly1ms();

		RA8875_WriteCmd(0x89);
		RA8875_Delaly1us();		/* ӳ1us */
		RA8875_WriteData(2);	/* PLLDIVK[2:0] = 2, 4 */

		/* RA8875 ڲϵͳƵ (SYS_CLK) ǽ񵴵·PLL ·Ƶʼ㹫ʽ :
		  SYS_CLK = FIN * ( PLLDIVN [4:0] +1 ) / ((PLLDIVM+1 ) * ( 2^PLLDIVK [2:0] ))
		          = 25M * (12 + 1) / ((0 + 1) * (2 ^ 2))
				  = 81.25MHz
		*/

		/* REG[88h]REG[89h]趨Ϊ֤PLL ȶȴһΡƵʱ䡹(< 100us)*/
	    RA8875_Delaly1ms();

		/*
			ϵͳƼĴ pdf 18ҳ:

			bit3:2 ɫ趨 (Color Depth Setting)
				00b : 8-bpp ͨTFT ӿڣ i.e. 256 ɫ
				1xb : 16-bpp ͨTFT ӿڣ i.e. 65K ɫ	 ѡ

			bit1:0 MCUIF ѡ
				00b : 8-λMCU ӿڡ
				1xb : 16-λMCU ӿڡ ѡ
		*/
		#ifdef IF_SPI_EN
			RA8875_WriteReg(0x10, (1 <<3 ) | (0 << 1));	/* SPIӿʱ8λ65Kɫ */
		#else
			RA8875_WriteReg(0x10, (1 <<3 ) | (1 << 1));	/* 16λMCUڣ65Kɫ */
		#endif

		/* REG[04h] Pixel Clock Setting Register (PCSR)
			bit7  PCLK Inversion
				0 : PDAT PCLK Ե (Rising Edge) ʱȡ
				1 : PDAT PCLK Ե½ (Falling Edge) ʱȡ
			bit1:0 PCLK Ƶ趨
				Pixel Clock ,PCLK Ƶ趨
				00b: PCLK Ƶ= ϵͳƵڡ
				01b: PCLK Ƶ= 2 ϵͳƵڡ
				10b: PCLK Ƶ= 4 ϵͳƵڡ
				11b: PCLK Ƶ= 8 ϵͳƵڡ
		*/
	    RA8875_WriteReg(0x04, 0x81);
	    RA8875_Delaly1ms();

	#if 1
		/* OTD9960 & OTA7001  */
		RA8875_WriteReg(0x14, 0x63);
		RA8875_WriteReg(0x15, 0x00);
		RA8875_WriteReg(0x16, 0x03);
		RA8875_WriteReg(0x17, 0x03);
		RA8875_WriteReg(0x18, 0x0B);
		RA8875_WriteReg(0x19, 0xDF);
		RA8875_WriteReg(0x1A, 0x01);
		RA8875_WriteReg(0x1B, 0x1F);
		RA8875_WriteReg(0x1C, 0x00);
		RA8875_WriteReg(0x1D, 0x16);
		RA8875_WriteReg(0x1E, 0x00);
		RA8875_WriteReg(0x1F, 0x01);

	#else	/* AT070TN92  setting */
	    //Horizontal set
	    //HDWR//Horizontal Display Width Setting Bit[6:0]
	 	//Horizontal display width(pixels) = (HDWR + 1)*8
	    RA8875_WriteReg(0x14, 0x4F);
	    RA8875_WriteReg(0x15, 0x05);

	    //HNDR//Horizontal Non-Display Period Bit[4:0]
	    //Horizontal Non-Display Period (pixels) = (HNDR + 1)*8
		RA8875_WriteReg(0x16, 0x0F);

	    //HSTR//HSYNC Start Position[4:0]
	    //HSYNC Start Position(PCLK) = (HSTR + 1)*8
		RA8875_WriteReg(0x17, 0x01);

	    //HPWR//HSYNC Polarity ,The period width of HSYNC.
	    //HSYNC Width [4:0]   HSYNC Pulse width(PCLK) = (HPWR + 1)*8
		RA8875_WriteReg(0x18, 0x00);

	    //Vertical set
	    //VDHR0 //Vertical Display Height Bit [7:0]
	    //Vertical pixels = VDHR + 1
		RA8875_WriteReg(0x19, 0xDF);

	    //VDHR1 //Vertical Display Height Bit [8]
	    //Vertical pixels = VDHR + 1
		RA8875_WriteReg(0x1A, 0x01);

	    //VNDR0 //Vertical Non-Display Period Bit [7:0]
	    //Vertical Non-Display area = (VNDR + 1)
		RA8875_WriteReg(0x1B, 0x0A);

	    //VNDR1 //Vertical Non-Display Period Bit [8]
	    //Vertical Non-Display area = (VNDR + 1)
		RA8875_WriteReg(0x1C, 0x00);

	    //VSTR0 //VSYNC Start Position[7:0]
	    //VSYNC Start Position(PCLK) = (VSTR + 1)
		RA8875_WriteReg(0x1D, 0x0E);

	    //VSTR1 //VSYNC Start Position[8]
	    //VSYNC Start Position(PCLK) = (VSTR + 1)
		RA8875_WriteReg(0x1E, 0x00);

	    //VPWR //VSYNC Polarity ,VSYNC Pulse Width[6:0]
	    //VSYNC Pulse Width(PCLK) = (VPWR + 1)
	    RA8875_WriteReg(0x1F, 0x01);
	#endif
	}

	/* TFT DISP  Ϊߣʹ. TFTģDISPӵRA8875оƬGP0X */
	RA8875_WriteReg(0xC7, 0x01);	/* DISP = 1 */

	/* LCD ʾ/رѶ (LCD Display on) */
	RA8875_WriteReg(0x01, 0x80);

	/* 	REG[40h] Memory Write Control Register 0 (MWCR0)

		Bit 7	ʾģʽ趨
			0 : ͼģʽ
			1 : ģʽ

		Bit 6	д/ڴд趨
			0 : 趨/ڴдΪʾ
			1 : 趨/ڴдΪʾ

		Bit 5	д/ڴд˸趨
			0 : α겻˸
			1 : α˸

		Bit 4   NA

		Bit 3-2  ͼģʽʱڴд뷽
			00b :  -> ңȻ -> ¡
			01b :  -> Ȼ -> ¡
			10b :  -> £Ȼ -> ҡ
			11b :  -> ϣȻ -> ҡ

		Bit 1 	ڴдԶӹ趨
			0 : ڴдʱλԶһ
			1 : ڴдʱλòԶһ

		Bit 0 ڴȡԶӹ趨
			0 : ڴȡʱλԶһ
			1 : ڴȡʱλòԶһ
	*/
	RA8875_WriteReg(0x40, 0x00);	/* ѡͼģʽ */


	/* 	REG[41h] Memory Write Control Register1 (MWCR1)
		дĿλãѡͼ1
	*/
	RA8875_WriteReg(0x41, 0x00);	/* ѡͼģʽ, ĿΪCGRAM */

	RA8875_SetDispWin(0, 0, g_LcdHeight, g_LcdWidth);

#ifdef IF_SPI_EN
	RA8875_HighSpeedSPI();		/* ϺлSPIģʽ */
#endif
}

/*
*********************************************************************************************************
*	  : BTE_SetTarBlock
*	˵: RA8875 BTEĿԼĿͼ
*	    :
*			uint16_t _usX : ˮƽ
*			uint16_t _usY : ֱ
*			uint16_t _usHeight : ߶
*			uint16_t _usWidth : 
*			uint8_t _ucLayer : 0 ͼ1 1 ͼ2
*	  ֵ: 
*********************************************************************************************************
*/
static void BTE_SetTarBlock(uint16_t _usX, uint16_t _usY, uint16_t _usHeight, uint16_t _usWidth, uint8_t _ucLayer)
{
	/*  */
	RA8875_WriteReg(0x58, _usX);
	RA8875_WriteReg(0x59, _usX >> 8);

	RA8875_WriteReg(0x5A, _usY);
	if (_ucLayer == 0)	/* ͼ2 */
	{
		RA8875_WriteReg(0x5B, _usY >> 8);
	}
	else
	{
		RA8875_WriteReg(0x5B, (1 << 7) | (_usY >> 8));	/* Bit7 ʾͼ㣬 0 ͼ1 1 ͼ2*/
	}

	/*  */
	RA8875_WriteReg(0x5C, _usWidth);
	RA8875_WriteReg(0x5D, _usWidth >> 8);

	/* ߶ */
	RA8875_WriteReg(0x5E, _usHeight);
	RA8875_WriteReg(0x5F, _usHeight >> 8);
}

/*
*********************************************************************************************************
*	  : BTE_SetOperateCode
*	˵: 趨BTE ͹դ
*	    : _ucOperate : 
*	  ֵ: 
*********************************************************************************************************
*/
static void BTE_SetOperateCode(uint8_t _ucOperate)
{
	/*  趨BTE ͹դ  */
	RA8875_WriteReg(0x51, _ucOperate);
}

/*
*********************************************************************************************************
*	  : RA8875_SetFrontColor
*	˵: 趨ǰɫ
*	    : ɫ
*	  ֵ: 
*********************************************************************************************************
*/
void RA8875_SetFrontColor(uint16_t _usColor)
{
	RA8875_WriteReg(0x63, (_usColor & 0xF800) >> 11);	/* R5  */
	RA8875_WriteReg(0x64, (_usColor & 0x07E0) >> 5);	/* G6 */
	RA8875_WriteReg(0x65, (_usColor & 0x001F));			/* B5 */
}

/*
*********************************************************************************************************
*	  : RA8875_SetBackColor
*	˵: 趨ɫ
*	    : ɫ
*	  ֵ: 
*********************************************************************************************************
*/
void RA8875_SetBackColor(uint16_t _usColor)
{
	RA8875_WriteReg(0x60, (_usColor & 0xF800) >> 11);	/* R5  */
	RA8875_WriteReg(0x61, (_usColor & 0x07E0) >> 5);	/* G6 */
	RA8875_WriteReg(0x62, (_usColor & 0x001F));			/* B5 */
}


/*
*********************************************************************************************************
*	  : BTE_Start
*	˵: BTE
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
static void BTE_Start(void)
{
	s_ucRA8875Busy = 1;
	/* RA8875_WriteReg(0x50, 0x80);  ʹΪڲѾ s_ucRA8875Busy ־ */
	RA8875_WriteCmd(0x50);	/* üĴַ */
	RA8875_WriteData(0x80);	/* дĴֵ */
}

/*
*********************************************************************************************************
*	  : BTE_Wait
*	˵: ȴBTE
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
static void BTE_Wait(void)
{
	while ((RA8875_ReadStatus() & 0x40) == 0x40);
	s_ucRA8875Busy = 0;
}

/*
*********************************************************************************************************
*	  : RA8875_IsBusy
*	˵: RA8875Ƿæ
*	    : 
*	  ֵ: 1 ʾæ 0 ʾ
*********************************************************************************************************
*/
uint8_t RA8875_IsBusy(void)
{
	if (s_ucRA8875Busy == 0)
	{
		return 0;
	}
	return 1;
}

/*
*********************************************************************************************************
*	  : RA8875_WaitBusy
*	˵: ȴRA8875
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void RA8875_WaitBusy(void)
{
	while ((RA8875_ReadStatus() & 0x80) == 0x80);
}

/*
*********************************************************************************************************
*	  : RA8875_Layer1Visable
*	˵: RA8875 ͼ1ʾ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void RA8875_Layer1Visable(void)
{
	/* 0x52 Ĵ Bit2:0
		ͼʾģʽ
		000b : ֻͼ1 ʾ
		001b : ֻͼ2 ʾ
		010b : ʾͼ1 ͼ2 Ľ/ģʽ
		011b : ʾͼ1 ͼ2 ͨ͸ģʽ
		100b : Boolean OR
		101b : Boolean AND
		110b : ģʽ (Floating window mode)
		111b :
	*/
	RA8875_WriteReg(0x52, RA8875_ReadReg(0x52) & 0xF8);	/* ֻͼ1 ʾ */
}

/*
*********************************************************************************************************
*	  : RA8875_Layer2Visable
*	˵: ֻʾͼ2
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void RA8875_Layer2Visable(void)
{
	/* 0x52 Ĵ Bit2:0
		ͼʾģʽ
		000b : ֻͼ1 ʾ
		001b : ֻͼ2 ʾ
		010b : ʾͼ1 ͼ2 Ľ/ģʽ
		011b : ʾͼ1 ͼ2 ͨ͸ģʽ
		100b : Boolean OR
		101b : Boolean AND
		110b : ģʽ (Floating window mode)
		111b :
	*/
	RA8875_WriteReg(0x52, (RA8875_ReadReg(0x52) & 0xF8) | 0x01);	/* ֻͼ2 ʾ */
}

/*
*********************************************************************************************************
*	  : RA8875_TouchInit
*	˵: ʼ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void RA8875_TouchInit(void)
{
	RA8875_WriteReg(0xF0, (1 << 2));	/* жλ */

	/*
		REG[71h] Touch Panel Control Register 1 (TPCR1)

		Bit7 N/A
		Bit6 ģʽ趨
			0 : Զģʽ
			1 : ֶģʽ
		Bit5 ADC οѹ(Vref)Դ趨
			0 : ڲοѹ
			1 : ⲿοѹADC οѹ׼λ= 1/2 VDD
		Bit4-3 N/A
		Bit2 жѶŵ·ѡ
			0: ر·
			1: ·
		Bit1-0 ֶģʽ֮ѡλ
			00b : ģʽؿƵԪģʽ
			01b : ⴥ¼ڴģʽⴥ¼ķ
				¼жϻɻ֪(REG[F1h]
				Bit2)
			10b : X ߢȡģʽڴģʽλõX ݻᱻ
				 REG[72h] REG[74h]
			11b : Y ߢȡģʽڴģʽλõY ݻᱻ
				REG[73h] and REG[74h]
	*/
	RA8875_WriteReg(0x71, (0 << 6) | (0 << 5) | (1 << 2));	/* ѡԶģʽ */

	/*
		REG[70h] Touch Panel Control Register 0 (TPCR0)

		Bit7 幦趨
			0 : رա
			1 : 
		Bit6-4 ȡʱ趨
			000b : ADC ȡʱΪ512 ϵͳƵڡ
			001b : ADC ȡʱΪ 1024 ϵͳƵڡ
			010b : ADC ȡʱΪ 2048 ϵͳƵڡ
			011b : ADC ȡʱΪ 4096 ϵͳƵڡ
			100b : ADC ȡʱΪ 8192 ϵͳƵڡ
			101b : ADC ȡʱΪ 16384 ϵͳƵڡ
			110b : ADC ȡʱΪ 32768 ϵͳƵڡ
			111b : ADC ȡʱΪ65536 ϵͳƵڡ
		Bit3 廽ģʽ
			0 : رմ¼ģʽ
			1 : ¼ɻ˯ģʽ
		Bit2-0 ADC Ƶ趨
			000b : ϵͳƵʡ
			001b : ϵͳƵ / 2
			010b : ϵͳƵ / 4
			011b : ϵͳƵ / 8
			100b : ϵͳƵ / 16
			101b : ϵͳƵ / 32
			110b : ϵͳƵ / 64
			111b : ϵͳƵ / 128

		ע : ADC Ƶ趨ܳ10MHz
	*/
	RA8875_WriteReg(0x70, (1 << 7) | (3 << 4) | (0 << 3) | (2 << 0));	/* ܣ */
}

/*
*********************************************************************************************************
*	  : RA8875_TouchReadX
*	˵: ȡXλADC   ʱжϷãҪĴʳͻ )
*	    : 
*	  ֵ: ADCֵ10Bit
*********************************************************************************************************
*/
uint16_t RA8875_TouchReadX(void)
{
	uint16_t usAdc;
	uint8_t ucRegValue;
	uint8_t ucReg74;

	/* ȡж¼־ */
	ucRegValue = RA8875_ReadReg(0xF1);
	if (ucRegValue & (1 << 2))
	{
		ucReg74 = RA8875_ReadReg(0x74);
		usAdc = RA8875_ReadReg(0x72);	/* Bit9-2 */
		usAdc <<= 2;
		usAdc += (ucReg74 & 0x03);

		s_usTouchX = usAdc;

		usAdc = RA8875_ReadReg(0x73);	/* Bit9-2 */
		usAdc <<= 2;
		usAdc += ((ucReg74 & 0x0C) >> 2);

		s_usTouchY = usAdc;
	}
	else
	{
		s_usTouchX = 0;
		s_usTouchY = 0;
	}

	/*
		bit2 д빦?? жλ
		0 : δ
		1 : жϡ
		ȡ?? ж״̬
		0 : δжϡ
		1 : жϡ
	*/

	/*
		ҪдĴΪúдbusy־
		RA8875_WriteReg(0xF1, (1 << 2));	  Ż´β.
	*/
	RA8875_WriteCmd(0xF1);
	RA8875_WriteData(1 << 2);

	return s_usTouchX;
}

/*
*********************************************************************************************************
*	  : RA8875_TouchReadY
*	˵: ȡYλADC  ȵ RA8875_TouchReadX()
*	    : 
*	  ֵ: ADCֵ10Bit
*********************************************************************************************************
*/
uint16_t RA8875_TouchReadY(void)
{
	return s_usTouchY;
}

/*
*********************************************************************************************************
*	  : RA8875_DispOn
*	˵: ʾ
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void RA8875_DispOn(void)
{
	RA8875_WriteReg(0x01, 0x80);
}

/*
*********************************************************************************************************
*	  : RA8875_DispOff
*	˵: رʾ
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void RA8875_DispOff(void)
{
	RA8875_WriteReg(0x01, 0x00);
}

/*
*********************************************************************************************************
*	  : RA8875_Sleep
*	˵: RA8875˯ģʽͬʱرʾ
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void RA8875_Sleep(void)
{
	RA8875_SetBackLight(0);		/* رձ */

	/* TFT DISP  Ϊߣʹ. TFTģDISPӵRA8875оƬGP0X */
	RA8875_WriteReg(0xC7, 0x00);	/* DISP = 0  */

	RA8875_WriteReg(0x01, 0x01);
	RA8875_WriteReg(0x01, 0x00);

	RA8875_WriteReg(0x01, 0x02);	/* RA8875 Sleep */
}

/*
*********************************************************************************************************
*	  : RA8875_PutPixel
*	˵: 1
*	    :
*			_usX,_usY : 
*			_usColor  :ɫ
*	  ֵ: 
*********************************************************************************************************
*/
void RA8875_PutPixel(uint16_t _usX, uint16_t _usY, uint16_t _usColor)
{
	/* չ 	RA8875_SetCursor(_usX, _usY);  */
	s_ucRA8875Busy = 1;

	RA8875_WriteCmd(0x46); RA8875_WriteData(_usX);
	RA8875_WriteCmd(0x47); RA8875_WriteData(_usX >> 8);
	RA8875_WriteCmd(0x48); RA8875_WriteData(_usY);
	RA8875_WriteCmd(0x49); RA8875_WriteData(_usY >> 8);

	RA8875_WriteCmd(0x02); 		/* 趨RA8875 ڴ(DDRAMCGRAM)ȡ/дģʽ */
	RA8875_WriteData16(_usColor);

	s_ucRA8875Busy = 0;
}

/*
*********************************************************************************************************
*	  : RA8875_GetPixel
*	˵: ȡ1
*	    :
*			_usX,_usY : 
*			_usColor  :ɫ
*	  ֵ: RGBɫֵ
*********************************************************************************************************
*/
uint16_t RA8875_GetPixel(uint16_t _usX, uint16_t _usY)
{
	uint16_t usRGB;

	RA8875_WriteReg(0x40, (1 << 0));	/* Ϊͼģʽȡ겻Զ1 */

	RA8875_SetReadCursor(_usX, _usY);	/* öȡλ */

	s_ucRA8875Busy = 1;

	RA8875_WriteCmd(0x02);
	usRGB = RA8875_ReadData16();	/* 1ζȡݶ */
	usRGB = RA8875_ReadData16();
	usRGB = RA8875_ReadData16();

	s_ucRA8875Busy = 0;

	return usRGB;
}

/*
*********************************************************************************************************
*	  : RA8875_ClrScr
*	˵: ɫֵ.RA8875֧Ӳɫ䡣úԵǰʾڽ. ʾ
*			 ڵλúʹС RA8875_SetDispWin() 
*	    :  _usColor : ɫ
*	  ֵ: 
*********************************************************************************************************
*/
void RA8875_ClrScr(uint16_t _usColor)
{
	/* Ҳͨ0x30-0x37Ĵûõǰʾ */

	/* ɫ, pdf 162ҳ
	˹ʹڽѡضǉ\ĳǰɫR8875 ĵɫ趨ΪBTE ǰɫ

	:
		1. 趨Ŀͼλ REG[58h], [59h], [5Ah], [5Bh]
		2. 趨BTE Ⱥ͸߶ REG[5Ch], [5Dh], [5Eh], [5Fh]
		3. 趨BTE ͹դ  REG[51h] Bit[3:0] = 0Ch
		4. 趨ǰɫ  REG[63h], [64h], [65h]
		5. BTE   REG[50h] Bit7 = 1
		6. ״̬ STSR Bit6ȷBTE Ƿ
	*/
	BTE_SetTarBlock(s_WinX, s_WinY, s_WinHeight, s_WinWidth, 0);	/* BTEλúͿȸ߶ԼĿͼ㣨01 */
	BTE_SetOperateCode(0x0C);		/* 趨BTE ͹դ  REG[51h] Bit[3:0] = 0Ch */
	RA8875_SetFrontColor(_usColor);	/* BTEǰɫ */
	BTE_Start();					/* BTE  */
	BTE_Wait();						/* ȴ */
}

/*
*********************************************************************************************************
*	  : RA8875_DispBmpInFlash
*	˵: ʾRA8875ҴFlashеBMPλͼ.
*			    λͼʽ: ϵɨ, ÿ2ֽ, RGB = 565 ʽ, λǰ.
*	    :
*			_usX, _usY : ͼƬ
*			_usHeight  :ͼƬ߶
*			_usWidth   :ͼƬ
*			_uiFlashAddr       :Flashַ
*	  ֵ: 
*********************************************************************************************************
*/
void RA8875_DispBmpInFlash(uint16_t _usX, uint16_t _usY, uint16_t _usHeight, uint16_t _usWidth,
	uint32_t _uiFlashAddr)
{
	/* pdf 179ҳ 7-10-1 ڴֱӴȡģʽ
		1. 趨ڷΧ (REG[30h] ~REG[37h])ڴдλ (REG[46h] ~REG[49h])
		2. 趨Serial Flash/ROM ̬ (REG[05h])
		3. 趨 ڴֱӴȡԴʼλ (REG[B0h] ~REG[B2h])
		4. 趨 ڴֱӴȡ (REG[B4h] REG[B5h])
		5. 趨 ڴֱӴȡ߶ (REG[B6h]  REG[B7h])
		6. 趨ڴֱӴȡԴͼƬ (REG[B8h]  REG[B9h])
		7. ڴֱӴȡΪģʽ (REG[BFh] bit 1)
		8. ڴֱӴȡʼѶҼڴֱӴȡæµѶ (REG[BFh] bit 0)
	*/
	RA8875_SetDispWin(_usX, _usY, _usHeight, _usWidth);	/* REG[30h] ~REG[37h]  REG[46h] ~REG[49h] */

	/* 05H  REG[05h] Serial Flash/ROM Configuration Register (SROC)
		7	Serial Flash/ROM I/F # ѡ
				0:ѡSerial Flash/ROM 0 ӿڡ[RA8875ͼоƬ 1 ӿ]
				1:ѡSerial Flash/ROM 1 ӿڡ
		6	Serial Flash/ROM Ѱַģʽ
				0: 24 λѰַģʽ
				λΪ0
		5	Serial Flash/ROM ģʽ
				0: ģʽ 0
				1: ģʽ 3
		4-3	Serial Flash /ROM ȡ (Read Cycle)
			00b: 4 bus ?? ޿ (No Dummy Cycle)
			01b: 5 bus ??1 byte ڡ
			1Xb: 6 bus ??2 byte ڡ
		2	Serial Flash /ROM ȡģʽ (Access Mode)
			0: ģʽ 
			1: DMA ģʽ
		1-0	Serial Flash /ROM I/F Data Latch ѡģʽ
			0Xb: һģʽ
			10b: ˫ģʽ0
			11b: ˫ģʽ1
	*/
#ifdef FLASH_DUAL_SPEED_EN			/* ˫ģʽ MOSIMISOͬʱȡ */
	RA8875_WriteReg(0x05, (1 << 7) | (0 << 6) | (1 << 5) | (0 << 3) | (1 << 2) | (2 << 0));
#else				/* ͨģʽ MISO ȡ */
	RA8875_WriteReg(0x05, (1 << 7) | (0 << 6) | (1 << 5) | (0 << 3) | (1 << 2) | (0 << 0));
#endif
	/*
		Serial Flash/ROM ƵƵ趨
			0xb: SFCL Ƶ = ϵͳƵƵ(DMA Ϊʹ״̬ɫΪ256 ɫSFCL Ƶ
				̶Ϊ=ϵͳƵƵ/ 2)
			10b: SFCL Ƶ =ϵͳƵƵ/ 2
			11b: SFCL Ƶ =ϵͳƵƵ/ 4

		TFT塣4.3ϵͳƵΪ 68MHz 7ϵͳƵΪ 81.25MHz

		8MFlashķٶ:SPI ʱƵ:80MHz(max.)
		˿Ϊ 1 Ƶ
	*/
	RA8875_WriteReg(0x06, (0 << 0));	/* SCLʱƵ */

	/* 趨Դַ
		B0H   DMA Դʼλ[7:0]
		B1H   DMA Դʼλ[15:8]
		B2H   DMA Դʼλ[23:16]
	*/
	RA8875_WriteReg(0xB0, (uint8_t)_uiFlashAddr);
	RA8875_WriteReg(0xB1, (uint8_t)(_uiFlashAddr >> 8));
	RA8875_WriteReg(0xB2, (uint8_t)(_uiFlashAddr >> 16));

	/*
		С
		B4   DMA [7:0]
		B5   DMA [9:8]
		B6   DMA ߶[7:0]
	    B7   DMA ߶[9:8]
	    B8   DMA ԴͼƬ[7:0]
	    B9   DMA ԴͼƬ[9:8]
	*/
	RA8875_WriteReg(0xB4, _usWidth);		/* DMA  */
	RA8875_WriteReg(0xB5, _usWidth >> 8);

	RA8875_WriteReg(0xB6, _usHeight);		/* DMA ߶ */
	RA8875_WriteReg(0xB7, _usHeight >> 8);

	RA8875_WriteReg(0xB8, _usWidth);		/* DMA ԴͼƬ */
	RA8875_WriteReg(0xB9, _usWidth >> 8);

	RA8875_WriteReg(0xBF, 1 << 1);			/* ѡģʽ */
	RA8875_WriteReg(0xBF, 1 << 1);			/* ѡģʽ */

	s_ucRA8875Busy = 1;
	RA8875_WriteReg(0xBF, (1 << 1) | (1 << 0));			/* DMA */
	while (RA8875_ReadReg(0xBF) & (1 << 0));	/* ȴ */
	RA8875_WaitBusy();
	s_ucRA8875Busy = 0;

	RA8875_QuitWinMode();					/* ˳Сڻͼģʽ */
}

/*
*********************************************************************************************************
*	  : RA8875_DrawBMP
*	˵: LCDʾһBMPλͼλͼɨ:ңϵ
*	    :
*			_usX, _usY : ͼƬ
*			_usHeight  :ͼƬ߶
*			_usWidth   :ͼƬ
*			_ptr       :ͼƬָ
*	  ֵ: 
*********************************************************************************************************
*/
void RA8875_DrawBMP(uint16_t _usX, uint16_t _usY, uint16_t _usHeight, uint16_t _usWidth, uint16_t *_ptr)
{
	uint32_t index = 0;
	const uint16_t *p;

	/* ͼƬλúʹС ʾ */
	RA8875_SetDispWin(_usX, _usY, _usHeight, _usWidth);

	s_ucRA8875Busy = 1;

	RA8875_WriteCmd(0x02); 		/* ׼дԴ */

	p = _ptr;
	for (index = 0; index < _usHeight * _usWidth; index++)
	{
		/*
			armfly : Ż, ͵չ
			RA8875_WriteRAM(_ptr[index]);

			˴ɿDMA
		*/
		RA8875_WriteData16(*p++);
	}
	s_ucRA8875Busy = 0;

	/* ˳ڻͼģʽ */
	RA8875_QuitWinMode();
}

/*
*********************************************************************************************************
*	  : RA8875_StartDirectDraw
*	˵: ʼֱӻͼģʽ.  ֧SPIģʽ֧8080ģʽ
*	    :
*			_usX, _usY : ʾڵ
*			_usHeight  : ʾڵĸ߶
*			_usWidth   : ʾڵĿ
*	  ֵ: 
*********************************************************************************************************
*/
void RA8875_StartDirectDraw(uint16_t _usX, uint16_t _usY, uint16_t _usHeight, uint16_t _usWidth)
{
	/* ͼƬλúʹС ʾ */
	RA8875_SetDispWin(_usX, _usY, _usHeight, _usWidth);

	s_ucRA8875Busy = 1;

	RA8875_WriteCmd(0x02); 		/* ׼дԴ */

	/* ֮Ӧóֱӻͼ */
}

/*
*********************************************************************************************************
*	  : RA8875_QuitDirectDraw
*	˵: ˳ͼģʽ.  ֧SPIģʽ֧8080ģʽ
*	    :
*			_usX, _usY : ʾڵ
*			_usHeight  : ʾڵĸ߶
*			_usWidth   : ʾڵĿ
*	  ֵ: 
*********************************************************************************************************
*/
void RA8875_QuitDirectDraw(void)
{
	s_ucRA8875Busy = 0;

	/* ˳ڻͼģʽ */
	RA8875_QuitWinMode();
}

/*
*********************************************************************************************************
*	  : RA8875_DrawLine
*	˵: RA8875Ӳܣ2仭һֱߡ
*	    :
*			_usX1, _usY1 :ʼ
*			_usX2, _usY2 :ֹY
*			_usColor     :ɫ
*	  ֵ: 
*********************************************************************************************************
*/
void RA8875_DrawLine(uint16_t _usX1 , uint16_t _usY1 , uint16_t _usX2 , uint16_t _usY2 , uint16_t _usColor)
{
	/* pdf 131ҳ
		RA8875 ֱ֧߻ͼܣʹԼ׻ٵMCU ͿTFT ģϻֱߡ
		ֱߵʼREG[91h~94h] REG[95h~98h]ֱߵɫREG[63h~65h]Ȼ
		ͼ趨REG[90h] Bit4 = 0, Bit0=0 REG[90h] Bit7 = 1RA8875 ͻὫֱߵͼд
		DDRAMԵTFT ģϾͿʾֱߡ
	*/

	if ((_usX1 == _usX2) && (_usY1 == _usY2))
	{
		RA8875_PutPixel(_usX1, _usY1, _usColor);
		return;
	}

	/*  */
	RA8875_WriteReg(0x91, _usX1);
	RA8875_WriteReg(0x92, _usX1 >> 8);
	RA8875_WriteReg(0x93, _usY1);
	RA8875_WriteReg(0x94, _usY1 >> 8);

	/* յ */
	RA8875_WriteReg(0x95, _usX2);
	RA8875_WriteReg(0x96, _usX2 >> 8);
	RA8875_WriteReg(0x97, _usY2);
	RA8875_WriteReg(0x98, _usY2 >> 8);

	RA8875_SetFrontColor(_usColor);	/* ֱߵɫ */

	s_ucRA8875Busy = 1;
//	RA8875_WriteReg(0x90, (1 << 7) | (0 << 4) | (0 << 0));/* ʼֱ */
	RA8875_WriteCmd(0x90);
	RA8875_WriteData((1 << 7) | (0 << 4) | (0 << 0));
//	while (RA8875_ReadReg(0x90) & (1 << 7));				/* ȴ */
	RA8875_WaitBusy();
	s_ucRA8875Busy = 0;
}

/*
*********************************************************************************************************
*	  : RA8875_DrawRect
*	˵: RA8875Ӳܻƾ
*	    :
*			_usX,_usY:Ͻǵ
*			_usHeight :εĸ߶
*			_usWidth  :εĿ
*			_usColor  :ɫ
*	  ֵ: 
*********************************************************************************************************
*/
void RA8875_DrawRect(uint16_t _usX, uint16_t _usY, uint16_t _usHeight, uint16_t _usWidth, uint16_t _usColor)
{
	/*
		RA8875 ַ֧λͼܣʹԼ׻ٵMCU ͿTFT ģϻΡ
	εʼREG[91h~94h]REG[95h~98h]εɫREG[63h~65h]Ȼ
	ͼ趨REG[90h] Bit4=1, Bit0=0 REG[90h] Bit7 = 1RA8875 ͻὫεͼд
	DDRAMԵTFT ģϾͿʾķΡ趨REG[90h] Bit5 = 1ɻһ
	ʵķ (Fill)

	 ---------------->---
	|(_usX_usY)        |
	V                    V  _usHeight
	|                    |
	 ---------------->---
		  _usWidth
	*/

	/*  */
	RA8875_WriteReg(0x91, _usX);
	RA8875_WriteReg(0x92, _usX >> 8);
	RA8875_WriteReg(0x93, _usY);
	RA8875_WriteReg(0x94, _usY >> 8);

	/* յ */
	RA8875_WriteReg(0x95, _usX + _usWidth - 1);
	RA8875_WriteReg(0x96, (_usX + _usWidth - 1) >> 8);
	RA8875_WriteReg(0x97, _usY + _usHeight - 1);
	RA8875_WriteReg(0x98, (_usY + _usHeight - 1) >> 8);

	RA8875_SetFrontColor(_usColor);	/* ɫ */

	s_ucRA8875Busy = 1;
//	RA8875_WriteReg(0x90, (1 << 7) | (0 << 5) | (1 << 4) | (0 << 0));	/* ʼ  */
	RA8875_WriteCmd(0x90);
	RA8875_WriteData((1 << 7) | (0 << 5) | (1 << 4) | (0 << 0));
//	while (RA8875_ReadReg(0x90) & (1 << 7));							/* ȴ */
	RA8875_WaitBusy();
	s_ucRA8875Busy = 0;
}

/*
*********************************************************************************************************
*	  : RA8875_FillRect
*	˵: RA8875ӲһΪɫ
*	    :
*			_usX,_usY:Ͻǵ
*			_usHeight :εĸ߶
*			_usWidth  :εĿ
*			_usColor  :ɫ
*	  ֵ: 
*********************************************************************************************************
*/
void RA8875_FillRect(uint16_t _usX, uint16_t _usY, uint16_t _usHeight, uint16_t _usWidth, uint16_t _usColor)
{
	/*
		RA8875 ַ֧λͼܣʹԼ׻ٵMCU ͿTFT ģϻΡ
	εʼREG[91h~94h]REG[95h~98h]εɫREG[63h~65h]Ȼ
	ͼ趨REG[90h] Bit4=1, Bit0=0 REG[90h] Bit7 = 1RA8875 ͻὫεͼд
	DDRAMԵTFT ģϾͿʾķΡ趨REG[90h] Bit5 = 1ɻһ
	ʵķ (Fill)

	 ---------------->---
	|(_usX_usY)        |
	V                    V  _usHeight
	|                    |
	 ---------------->---
		  _usWidth
	*/

	/*  */
	RA8875_WriteReg(0x91, _usX);
	RA8875_WriteReg(0x92, _usX >> 8);
	RA8875_WriteReg(0x93, _usY);
	RA8875_WriteReg(0x94, _usY >> 8);

	/* յ */
	RA8875_WriteReg(0x95, _usX + _usWidth - 1);
	RA8875_WriteReg(0x96, (_usX + _usWidth - 1) >> 8);
	RA8875_WriteReg(0x97, _usY + _usHeight - 1);
	RA8875_WriteReg(0x98, (_usY + _usHeight - 1) >> 8);

	RA8875_SetFrontColor(_usColor);	/* ɫ */

	s_ucRA8875Busy = 1;
//	RA8875_WriteReg(0x90, (1 << 7) | (1 << 5) | (1 << 4) | (0 << 0));	/* ʼ  */
	RA8875_WriteCmd(0x90);
	RA8875_WriteData((1 << 7) | (1 << 5) | (1 << 4) | (0 << 0));
//	while (RA8875_ReadReg(0x90) & (1 << 7));							/* ȴ */
	RA8875_WaitBusy();
	s_ucRA8875Busy = 0;
}

/*
*********************************************************************************************************
*	  : RA8875_DrawCircle
*	˵: һԲʿΪ1
*	    :
*			_usX,_usY  :Բĵ
*			_usRadius  :Բİ뾶
*			_usColor  :ɫ
*	  ֵ: 
*********************************************************************************************************
*/
void RA8875_DrawCircle(uint16_t _usX, uint16_t _usY, uint16_t _usRadius, uint16_t _usColor)
{
	/*
		RA8875 ֧ԲλͼܣʹԼ׻ٵMCU ͿTFT ģϻԲ趨
		ԲĵREG[99h~9Ch]Բİ뾶REG[9Dh]ԲɫREG[63h~65h]Ȼͼ
		REG[90h] Bit6 = 1RA8875 ͻὫԲͼдDDRAMԵTFT ģϾͿʾ
		Բ趨REG[90h] Bit5 = 1ɻһʵԲ (Fill)趨REG[90h] Bit5 = 0
		Բ (Not Fill
	*/
	/* Բİ뾶 */
	if (_usRadius > 255)
	{
		return;
	}

	/* Բ */
	RA8875_WriteReg(0x99, _usX);
	RA8875_WriteReg(0x9A, _usX >> 8);
	RA8875_WriteReg(0x9B, _usY);
	RA8875_WriteReg(0x9C, _usY >> 8);

	RA8875_WriteReg(0x9D, _usRadius);	/* Բİ뾶 */

	RA8875_SetFrontColor(_usColor);	/* ɫ */

	s_ucRA8875Busy = 1;
//	RA8875_WriteReg(0x90, (1 << 6) | (0 << 5));				/* ʼԲ,   */
	RA8875_WriteCmd(0x90);
	RA8875_WriteData( (1 << 6) | (0 << 5));
//	while (RA8875_ReadReg(0x90) & (1 << 6));				/* ȴ */
	RA8875_WaitBusy();
	s_ucRA8875Busy = 0;
}

/*
*********************************************************************************************************
*	  : RA8875_FillCircle
*	˵: һԲ
*	    :
*			_usX,_usY  :Բĵ
*			_usRadius  :Բİ뾶
*			_usColor   :ɫ
*	  ֵ: 
*********************************************************************************************************
*/
void RA8875_FillCircle(uint16_t _usX, uint16_t _usY, uint16_t _usRadius, uint16_t _usColor)
{
	/*
		RA8875 ֧ԲλͼܣʹԼ׻ٵMCU ͿTFT ģϻԲ趨
		ԲĵREG[99h~9Ch]Բİ뾶REG[9Dh]ԲɫREG[63h~65h]Ȼͼ
		REG[90h] Bit6 = 1RA8875 ͻὫԲͼдDDRAMԵTFT ģϾͿʾ
		Բ趨REG[90h] Bit5 = 1ɻһʵԲ (Fill)趨REG[90h] Bit5 = 0
		Բ (Not Fill
	*/
	/* Բİ뾶 */
	if (_usRadius > 255)
	{
		return;
	}

	/* Բ */
	RA8875_WriteReg(0x99, _usX);
	RA8875_WriteReg(0x9A, _usX >> 8);
	RA8875_WriteReg(0x9B, _usY);
	RA8875_WriteReg(0x9C, _usY >> 8);

	RA8875_WriteReg(0x9D, _usRadius);	/* Բİ뾶 */

	RA8875_SetFrontColor(_usColor);	/* ɫ */

	s_ucRA8875Busy = 1;
//	RA8875_WriteReg(0x90, (1 << 6) | (1 << 5));				/* ʼԲ,   */
	RA8875_WriteCmd(0x90);
	RA8875_WriteData((1 << 6) | (1 << 5));
//	while (RA8875_ReadReg(0x90) & (1 << 6));				/* ȴ */
	RA8875_WaitBusy();
	s_ucRA8875Busy = 0;
}

/*
*********************************************************************************************************
*	  : RA8875_SetFont
*	˵: ıģʽ塢о־
*	    :
*			_ucFontType : : RA_FONT_16, RA_FONT_24, RA_FONT_32
*			_ucLineSpace : о࣬صλ (0-31)
*			_ucCharSpace : ־࣬صλ (0-63)
*
*	  ֵ: 
*********************************************************************************************************
*/
void RA8875_SetFont(uint8_t _ucFontType, uint8_t _ucLineSpace, uint8_t _ucCharSpace)
{
	/*
		[29H]ģʽ£趨ּо (λ: ) 
		ֻе5bitЧ0-31
	*/
	if (_ucLineSpace >31)
	{
		_ucLineSpace = 31;
	}
	RA8875_WriteReg(0x29, _ucLineSpace);

	/*
		[2EH] ַࣨصλ0-63壨16*1624*2432*32
	*/
	if (_ucCharSpace > 63)
	{
		_ucCharSpace = 63;
	}
	if (_ucFontType > RA_FONT_32)
	{
		_ucFontType = RA_FONT_16;
	}
	RA8875_WriteReg(0x2E, (_ucCharSpace & 0x3F) | (_ucFontType << 6));
}

/*
*********************************************************************************************************
*	  : RA8875_SetFontZoom
*	˵: ıģʽֵķŴģʽ1X,2X,3X, 4X
*	    :
*			_ucHSize : ˮƽŴ0-3 ֱӦ X1X2X3X4
*			_ucVSize : ִ÷Ŵ0-3 ֱӦ X1X2X3X4
*		ö:RA_SIZE_X1RA_SIZE_X2RA_SIZE_X3RA_SIZE_X4
*	  ֵ: 
*********************************************************************************************************
*/
void RA8875_SetTextZoom(uint8_t _ucHSize, uint8_t _ucVSize)
{
	/*
		pdf 22ҳ		[22H]
		bit7 ڶ룬һ㲻ãȱʡ0
		bit6 ͨ͸һ㲻ãȱʡ0
		bit4 ת90һ㲻ãȱʡ0
		bit3-2 ˮƽŴ
		bit1-0 ֱŴ
	*/
	RA8875_WriteReg(0x22, ((_ucHSize & 0x03) << 2) | ( _ucVSize & 0x03));
}

/*
*********************************************************************************************************
*	  : RA8875_DispAscii
*	˵: ʾASCIIַַRA8875ڲROMеASCIIַ8*16ֺ֧.
*			ɫɫǷͨ͸ĺ
*			void RA8875_SetFrontColor(uint16_t _usColor);
*			void RA8875_SetBackColor(uint16_t _usColor);
*	    :  _usX, _usY : ʾλã꣩
*			 _ptr : AascIIַ0
*	  ֵ: 
*********************************************************************************************************
*/
void RA8875_DispAscii(uint16_t _usX, uint16_t _usY, char *_ptr)
{
	/*
		RA8875 ڽ8x16 ASCII ROMṩʹ߸ķʽض (Code) 
		֡ڽּ֧ISO/IEC 8859-1~4 ׼⣬ʹ߿͸REG[60h~62h] ѡ
		ǰɫԼ͸REG[63h~65h] ѡ񱳾ɫ.

		ISO/IEC 8859-1ֳLatin-1ŷԡǹʱ׼֯ISO/IEC 8859ĵһ8λַ
		ASCIIΪڿõ0xA0-0xFFķΧڣ192ĸţԹʹñŵĸʹá

		ISO/IEC 8859-2 Latin-2ŷԡǹʱ׼֯ISO/IEC 8859һ8λַ .
		ISO/IEC 8859-3 ŷַ
		ISO/IEC 8859-4 ŷַ
	*/

	/*
	(1) Text mode  REG[40h] bit7=1
	(2) Internal Font ROM Select   REG[21h] bit7=0, bit5=0
	(3) Font foreground and background color Select  REG[63h~65h], REG[60h~62h]
	(4) Write the font Code  CMD_WR[02h]    DATA_WR[font_code]
	*/

	RA8875_SetTextCursor(_usX, _usY);

	RA8875_WriteReg(0x40, (1 << 7));	/* Ϊıģʽ */

	/* ѡCGROM font; ѡڲCGROM; ڲCGROM ѡISO/IEC 8859-1. */
	RA8875_WriteReg(0x2F, 0x00);
	RA8875_WriteReg(0x21, (0 << 7) | (0 << 5) | (0 << 1) | (0 << 0));

	s_ucRA8875Busy = 1;


	RA8875_WriteCmd(0x02); 			/* 趨RA8875 ڴ(DDRAMCGRAM)ȡ/дģʽ */

	/* ʼѭַ */
	while (*_ptr != 0)
	{
		RA8875_WriteData(*_ptr);
		while ((RA8875_ReadStatus() & 0x80) == 0x80);	/* ȴڲд */
		_ptr++;
	}
	s_ucRA8875Busy = 0;

	RA8875_WriteReg(0x40, (0 << 7));	/* ԭΪͼģʽ */
}

/*
*********************************************************************************************************
*	  : RA8875_DispStr
*	˵: ʾַַRA8875ӵֿоƬֺ֧.
*			ɫɫǷͨ͸ĺ
*			void RA8875_SetFrontColor(uint16_t _usColor);
*			void RA8875_SetBackColor(uint16_t _usColor);
*	    :  _usX, _usY : ʾλã꣩
*			 _ptr : AascIIַ0
*	  ֵ: 
*********************************************************************************************************
*/
void RA8875_DispStr(uint16_t _usX, uint16_t _usY, char *_ptr)
{
	/*
		RA8875 ͸ʹ  Ϻͨ˾ (Genitop Inc) ⲿʽڴ (Font ROM)ָ֧
		д뵽DDRAM СRA8875 Ϻͨ˾ (Genitop Inc) ݵĲƷ :
		GT21L16TW/GT21H16T1W GT23L16U2W GT23L24T3Y/GT23H24T3Y GT23L24M1Z 
		 GT23L32S4W/GT23H32S4WЩ16x16, 24x24, 32x32  (Dot) 벻ͬ

		RA8875弯ɵֿоƬΪ ֿͨоƬ_GT23l32S4W

		GT23L32S4Wһں11X1215X16㡢24X2432X32ĺֿоƬ֧GB2312
		꺺֣йűίϷȨSCIIַиʽΪúšûַͨ룬ñ
		ṩķַоƬеĵַɴӸõַַϢ
	*/

	/* ıʾλãעıģʽдͼģʽдǲͬļĴ */
	RA8875_SetTextCursor(_usX, _usY);

	RA8875_WriteReg(0x40, (1 << 7));	/* Ϊıģʽ */

	/*
		Serial Flash/ROM ƵƵ趨
			0xb: SFCL Ƶ = ϵͳƵƵ(DMA Ϊ״̬ɫΪ256 ɫSFCL Ƶ
				̶Ϊ=ϵͳƵƵ/ 2)
			10b: SFCL Ƶ =ϵͳƵƵ/ 2
			11b: SFCL Ƶ =ϵͳƵƵ/ 4

		ϵͳƵΪ 68MHz

		GT23L32S4Wķٶ:SPI ʱƵ:20MHz(max.)

		Ҫ 4 Ƶ, 17MHz
	*/
	RA8875_WriteReg(0x06, (3 << 0));	/* Ϊıģʽ */

	/* ѡⲿROM */
	RA8875_WriteReg(0x21, (0 << 7) | (1 << 5));

	/* 05H  REG[05h] Serial Flash/ROM Configuration Register (SROC)
		7	Serial Flash/ROM I/F # ѡ
				0:ѡSerial Flash/ROM 0 ӿڡ[RA8875ֿоƬ 0 ӿ]
				1:ѡSerial Flash/ROM 1 ӿڡ
		6	Serial Flash/ROM Ѱַģʽ
				0: 24 λѰַģʽ
				λΪ0
		5	Serial Flash/ROM ģʽ
				0: ģʽ 0
				1: ģʽ 3
		4-3	Serial Flash /ROM ȡ (Read Cycle)
			00b: 4 bus ?? ޿ (No Dummy Cycle)
			01b: 5 bus ??1 byte ڡ
			1Xb: 6 bus ??2 byte ڡ
		2	Serial Flash /ROM ȡģʽ (Access Mode)
			0: ģʽ 
			1: DMA ģʽ
		1-0	Serial Flash /ROM I/F Data Latch ѡģʽ
			0Xb: һģʽ
			10b: ˫ģʽ0
			11b: ˫ģʽ1
	*/
	RA8875_WriteReg(0x05, (0 << 7) | (0 << 6) | (1 << 5) | (1 << 3) | (0 << 2) | (0 << 1));

	/*
		ⲿоƬͺΪ GT23L32S4W, ΪGB2312,

		Bit1:0 ASCIIַĸʽ:
			0 = NORMAL		 [ʻϸ, ͺֶ]
			1 = Arial		 [ʻ֣ͺֵײ]
			2 = Roman		 [ʻϸ, ͺֵײ]
			3 = Bold		 [,]
	 */
	RA8875_WriteReg(0x2F, (4 << 5) | (0 << 2) | (1 << 0));

	s_ucRA8875Busy = 1;
	RA8875_WriteCmd(0x02); 			/* 趨RA8875 ڴ(DDRAMCGRAM)ȡ/дģʽ */

	/* ʼѭַ */
	while (*_ptr != 0)
	{
		RA8875_WriteData(*_ptr);
		while ((RA8875_ReadStatus() & 0x80) == 0x80);
		_ptr++;
	}
	s_ucRA8875Busy = 0;

	RA8875_WriteReg(0x40, (0 << 7));	/* ԭΪͼģʽ */
}

/*
*********************************************************************************************************
*	  : RA8875_SetDispWin
*	˵: ʾڣ봰ʾģʽڴʾģʽдԴ棬Զ趨ڽе
*	    :
*		_usX : ˮƽ
*		_usY : ֱ
*		_usHeight: ڸ߶
*		_usWidth : ڿ
*	  ֵ: 
*********************************************************************************************************
*/
void RA8875_SetDispWin(uint16_t _usX, uint16_t _usY, uint16_t _usHeight, uint16_t _usWidth)
{

	uint16_t usTemp;

	/* ϵͳʾͼ: 
			 -----------------------------
			|(0,0)                        |
			|     --------->              |
			|         |                   |
			|         |                   |
			|         |                   |
			|         V                   |
			|     --------->              |
			|                    (479,271)|
			 -----------------------------

		Ͻ, ɨ跽ȴңٴϵ¡

		ҪʽҪ߼ת
	*/

	RA8875_WriteReg(0x30, _usX);
    RA8875_WriteReg(0x31, _usX >> 8);

	RA8875_WriteReg(0x32, _usY);
    RA8875_WriteReg(0x33, _usY >> 8);

	usTemp = _usWidth + _usX - 1;
	RA8875_WriteReg(0x34, usTemp);
    RA8875_WriteReg(0x35, usTemp >> 8);

	usTemp = _usHeight + _usY - 1;
	RA8875_WriteReg(0x36, usTemp);
    RA8875_WriteReg(0x37, usTemp >> 8);

	RA8875_SetCursor(_usX, _usY);

	/* 浱ǰϢԺɫЧ.
	һͨȡ0x30-0x37ĴõǰڣЧʽϵ */
	s_WinX = _usX;
	s_WinY = _usY;
	s_WinHeight = _usHeight;
	s_WinWidth = _usWidth;
}

/*
*********************************************************************************************************
*	  : RA8875_SetCursor
*	˵: дԴĹλãͼģʽ
*	    :  _usX : X; _usY: Y
*	  ֵ: 
*********************************************************************************************************
*/
static void RA8875_SetCursor(uint16_t _usX, uint16_t _usY)
{
	/* ڴд ע0x80-83 ǹͼε꡿ */
	RA8875_WriteReg(0x46, _usX);
	RA8875_WriteReg(0x47, _usX >> 8);
	RA8875_WriteReg(0x48, _usY);
	RA8875_WriteReg(0x49, _usY >> 8);
}

/*
*********************************************************************************************************
*	  : RA8875_SetCursor
*	˵: öԴĹλá ܶĿдͶͬļĴRA8875ǲͬġ
*	    :  _usX : X; _usY: Y
*	  ֵ: 
*********************************************************************************************************
*/
static void RA8875_SetReadCursor(uint16_t _usX, uint16_t _usY)
{
	/* ڴ */
	RA8875_WriteReg(0x4A, _usX);
	RA8875_WriteReg(0x4B, _usX >> 8);
	RA8875_WriteReg(0x4C, _usY);
	RA8875_WriteReg(0x4D, _usY >> 8);
}

/*
*********************************************************************************************************
*	  : RA8875_SetTextCursor
*	˵: ıдλ
*	    :  _usX : X; _usY: Y
*	  ֵ: 
*********************************************************************************************************
*/
static void RA8875_SetTextCursor(uint16_t _usX, uint16_t _usY)
{
	/* ڴ */
	RA8875_WriteReg(0x2A, _usX);
	RA8875_WriteReg(0x2B, _usX >> 8);
	RA8875_WriteReg(0x2C, _usY);
	RA8875_WriteReg(0x2D, _usY >> 8);
}

/*
*********************************************************************************************************
*	  : RA8875_QuitWinMode
*	˵: ˳ʾģʽΪȫʾģʽ
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void RA8875_QuitWinMode(void)
{
	RA8875_SetDispWin(0, 0, g_LcdHeight, g_LcdWidth);
}


/*
*********************************************************************************************************
*	  : RA8875_CtrlGPO
*	˵: GPO״̬ҲKOUT0-KOUT3״̬
*	    : _pin : 0-3, ֱӦ GPO0 GPO1 GPO2 GPO3
*			  _value : 0  1
*	  ֵ: 
*********************************************************************************************************
*/
void RA8875_CtrlGPO(uint8_t _pin, uint8_t _value)
{
	RA8875_WriteReg(0x13, _value << _pin);
}

/*
*********************************************************************************************************
*	  : RA8875_SetBackLight
*	˵: RA8875оƬPWM1ؼĴLCD
*	    :  _bright ȣ0255
*	  ֵ: 
*********************************************************************************************************
*/
void RA8875_SetBackLight(uint8_t _bright)
{
	if (_bright == 0)
	{
		/* رPWM, PWM1ȱʡLOW  */
		RA8875_WriteReg(0x8A, 0 << 6);
	}
	else if (_bright == BRIGHT_MAX)	/*  */
	{
		/* رPWM, PWM1ȱʡHIGH */
		RA8875_WriteReg(0x8A, 1 << 6);
	}
	else
	{
		/* ʹPWM1, ռձȵ */

		/* 	REG[8Ah] PWM1 Control Register (P1CR)

			Bit7 ȵ (PWM1) 趨
				0 : رգ״̬£PWM1 ׼λմ˻Bit6 
				1 : 

			Bit6 PWM1 رʱ׼λ
				0 : PWM رջ˯ģʽʱPWM1 ΪLow ״̬
				1 : PWM رջ˯ģʽʱPWM1 ΪHigh ״̬

			Bit5 

			Bit4 PWM1 ѡ
				0 : PWM1 ܡ
				1 : PWM1 ̶һƵΪⲿClock (Fin) Ƶ 1 /16 Clock

			Bit3-0  PWM1 ·ƵԴѡPWM_CLK	PWMƵʡ
				0000b : SYS_CLK / 1   , 1000b : SYS_CLK / 256
				0001b : SYS_CLK / 2   , 1001b : SYS_CLK / 512
				0010b : SYS_CLK / 4   , 1010b : SYS_CLK / 1024
				0011b : SYS_CLK / 8   , 1011b : SYS_CLK / 2048
				0100b : SYS_CLK / 16  , 1100b : SYS_CLK / 4096
				0101b : SYS_CLK / 32  , 1101b : SYS_CLK / 8192
				0110b : SYS_CLK / 64  , 1110b : SYS_CLK / 16384
				0111b : SYS_CLK / 128 , 1111b : SYS_CLK / 32768

				SYS_CLK ϵͳƵʣ SYS_CLK Ϊ20MHz Bit[3:0] =0001b ʱPWM1 ƵԴΪ10MHz
				ʵPWMƵʻҪ 256֧8λķֱʡ

				4.3(480*272)ģ飬SYS_CLK =  68.75MHz
				7.0(800*480)ģ飬SYS_CLK =  81.25MHz

				Ϊ˱ƵPWMƵʿѡ
				1 Ƶ100Hz
				2  20KHz

				磬Bit3-0Ϊ0011bʱ SYS_CLK / 8
					4.3 PWMƵΪ (68.75MHz / 8) / 256 = 33.56KHz
					7 PWMƵΪ (81.25MHz / 8) / 256 = 39.67KHz
		*/

		// RA8875_WriteReg(0x8A, (1 << 7) | 3);   57 3 ƵPWM, 4.3粻
		RA8875_WriteReg(0x8A, (1 << 7) | 12);

		/* REG[8Bh] PWM1 Duty Cycle Register (P1DCR) */
		RA8875_WriteReg(0x8B, _bright);
	}
}

/*****************************  www.armfly.com (END OF FILE) *********************************/
