/*
*********************************************************************************************************
*
*	ģ : ѹǿBMP085ģ
*	ļ : bsp_bmp085.c
*	     : V1.0
*	˵     : ʵBMP085ĵײơ
*
*	޸ļ¼ :
*		汾               ˵
*		V1.0    2013-02-01 armfly  ʽ
*
*	Copyright (C), 2013-2014,  www.armfly.com
*
*********************************************************************************************************
*/

/*
	Ӧ˵:BMP085ǰȵһ bsp_InitI2C()úI2CصGPIO.

	BMP085 BOSCH˾ĵһ߾ȡܺĵѹԾͿԴﵽ0.03hPa
	BMP085 ͨI2Cֱ΢
	ѹΧ300 ... 1100hPa9000...-500ף
			30kPa ... 110kPa

	ѹǿλ
		inHg Ӣ繯
		mmHg ׹
		mbar (=)
		hPa 
		kPa ǧ, 1kPa = 1000Pa
		MPa , 1MPa = 1000kPa = 1000000Pa

	1=1=3/4ˮ
	ںƽƽѹ ԼΪ1013.25˹760ˮֵҲΪ׼ѹ

	⻻㣺
		1׼ѹ=101 325˹
		1˹=9.8692326671601*10-6׼ѹ

	DocļСȫҪкθ߶ȼѹο.pdf

	   θ߶(m)  ѹǿ(kPa)
	     31.2         99.86
	     3.3          100.48
	ʯׯ   80.5         99.56
	̫ԭ     777.9        91.92
	ͺ 1063         88.94
	     41.6         100.07
	     92.8         99.47
	     236.8        97.79
	   171.7        98.51
	Ϻ     4.5          100.53
	Ͼ     8.9          100.4
	     41.7         100.05
	Ϸ     29.8         100.09
	     84           99.64
	     63.2         99.91
	ϲ     46.7         99.91
	     51.6         99.85
	人     23.3         100.17
	֣     110.4        99.17
	ɳ     44.9         99.94
	     6.6          100.45
	     72.2         99.6
	     259.1        97.32
	     1071.2       88.79
	     1891.4       80.8
	     3658.        65.23
	     396.9        95.92
	     1517.2       84.31
	ɶ     505.9        94.77
	     2261.2       77.35
	     1111.5       88.35
	³ľ 917.9        90.67

	     32           100.56
	̨     9            100.53

	ͷ     1.2          100.55   ͺΡ㶫ʡ
	     4507         58.9     ߺΡ

	߶Ϊ 8848    ൱0.3ѹ ,30.39KPa  ݴ顿

	ѹ¶ȼ㺣θ߶ȣֻǴ¹ϵο
	H = (RT/gM)*ln(p0/p)
		RΪ8.51
		TΪѧ¶ȣ£϶Ҫתѧ¶ȣ
		gΪٶ10
		MΪķ29
		P0Ϊ׼ѹ
		PΪҪĸ߶ȵѹ
		ʽƵ̽ϸӾͲƵˣԼӦûתġ


	ܽƵļ㹫ʽ
		P=100KPa   H*10kPa/km   H0,3km֮
		P=70kPa    H*8kPa/km    H3km,5km֮
		P=54kPa    H*6.5kPa/km   H5km,7km֮
		P=41kPa    H*5kPa/km   H7km,10km֮
		P=25kPa    H*3.5kPa/km   H10km,12km֮

*/

#include "bsp.h"

static void BMP085_WriteReg(uint8_t _ucRegAddr, uint8_t _ucRegValue);
static uint16_t BMP085_Read2Bytes(uint8_t _ucRegAddr);
static uint32_t BMP085_Read3Bytes(uint8_t _ucRegAddr);
static void BMP085_WaitConvert(void);

BMP085_T g_tBMP085;

/*
*********************************************************************************************************
*	  : bsp_InitBMP085
*	˵: ʼBMP085
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void bsp_InitBMP085(void)
{
	/* оƬڲУ׼ÿоƬͬBOSCHǰУ׼õݣ */
	g_tBMP085.AC1 = (int16_t)BMP085_Read2Bytes(0xAA);
	g_tBMP085.AC2 = (int16_t)BMP085_Read2Bytes(0xAC);
	g_tBMP085.AC3 = (int16_t)BMP085_Read2Bytes(0xAE);
	g_tBMP085.AC4 = (uint16_t)BMP085_Read2Bytes(0xB0);
	g_tBMP085.AC5 = (uint16_t)BMP085_Read2Bytes(0xB2);
	g_tBMP085.AC6 = (uint16_t)BMP085_Read2Bytes(0xB4);
	g_tBMP085.B1 =  (int16_t)BMP085_Read2Bytes(0xB6);
	g_tBMP085.B2 =  (int16_t)BMP085_Read2Bytes(0xB8);
	g_tBMP085.MB =  (int16_t)BMP085_Read2Bytes(0xBA);
	g_tBMP085.MC =  (int16_t)BMP085_Read2Bytes(0xBC);
	g_tBMP085.MD =  (int16_t)BMP085_Read2Bytes(0xBE);

	g_tBMP085.OSS = 0;	/* 0-3 */
}

/*
*********************************************************************************************************
*	  : BMP085_WriteReg
*	˵: дĴ
*	    : _ucOpecode : Ĵַ
*			  _ucRegData : Ĵ
*	  ֵ: 
*********************************************************************************************************
*/
static void BMP085_WriteReg(uint8_t _ucRegAddr, uint8_t _ucRegValue)
{
    i2c_Start();							/* ߿ʼź */

    i2c_SendByte(BMP085_SLAVE_ADDRESS);		/* 豸ַ+дź */
	i2c_WaitAck();

    i2c_SendByte(_ucRegAddr);				/* ͼĴַ */
	i2c_WaitAck();

    i2c_SendByte(_ucRegValue);				/* ͼĴֵ */
	i2c_WaitAck();

    i2c_Stop();                   			/* ֹͣź */
}

/*
*********************************************************************************************************
*	  : BMP085_Read2Bytes
*	˵: ȡBMP085Ĵֵ2ֽڡ¶ȼĴ
*	    : _ucRegAddr Ĵַ
*	  ֵ: Ĵֵ
*********************************************************************************************************
*/
static uint16_t BMP085_Read2Bytes(uint8_t _ucRegAddr)
{
	uint8_t ucData1;
	uint8_t ucData2;
	uint16_t usRegValue;

	i2c_Start();                  			/* ߿ʼź */
	i2c_SendByte(BMP085_SLAVE_ADDRESS);		/* 豸ַ+дź */
	i2c_WaitAck();
	i2c_SendByte(_ucRegAddr);				/* ͵ַ */
	i2c_WaitAck();

	i2c_Start();                  			/* ߿ʼź */
	i2c_SendByte(BMP085_SLAVE_ADDRESS + 1);/* 豸ַ+ź */
	i2c_WaitAck();

	ucData1 = i2c_ReadByte();       		/* ֽ */
	i2c_Ack();

	ucData2 = i2c_ReadByte();       		/* ֽ */
	i2c_NAck();
	i2c_Stop();                  			/* ֹͣź */

	usRegValue = (ucData1 << 8) + ucData2;

	return usRegValue;
}

/*
*********************************************************************************************************
*	  : BMP085_Read3Bytes
*	˵: ȡBMP085Ĵֵ3ֽ  ڶѹĴ
*	    : _ucRegAddr Ĵַ
*	  ֵ: Ĵֵ
*********************************************************************************************************
*/
static uint32_t BMP085_Read3Bytes(uint8_t _ucRegAddr)
{
	uint8_t ucData1;
	uint8_t ucData2;
	uint8_t ucData3;
	uint32_t uiRegValue;

	i2c_Start();                  			/* ߿ʼź */
	i2c_SendByte(BMP085_SLAVE_ADDRESS);		/* 豸ַ+дź */
	i2c_WaitAck();
	i2c_SendByte(_ucRegAddr);				/* ͵ַ */
	i2c_WaitAck();

	i2c_Start();                  			/* ߿ʼź */
	i2c_SendByte(BMP085_SLAVE_ADDRESS + 1);/* 豸ַ+ź */
	i2c_WaitAck();

	ucData1 = i2c_ReadByte();       		/* ֽ */
	i2c_Ack();

	ucData2 = i2c_ReadByte();       		/* мֽ */
	i2c_Ack();

	ucData3 = i2c_ReadByte();       		/* ͽ */
	i2c_NAck();
	i2c_Stop();                  			/* ֹͣź */

	uiRegValue = (ucData1 << 16) + (ucData2 << 8) + ucData3;

	return uiRegValue;
}

/*
*********************************************************************************************************
*	  : BMP085_WaitConvert
*	˵: ȴڲת
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
static void BMP085_WaitConvert(void)
{
	if (g_tBMP085.OSS == 0)
	{
		bsp_DelayMS(6);		/* 4.5ms  7.5ms  13.5ms   25.5ms */
	}
	else if (g_tBMP085.OSS == 1)
	{
		bsp_DelayMS(9);		/* 4.5ms  7.5ms  13.5ms   25.5ms */
	}
	else if (g_tBMP085.OSS == 2)
	{
		bsp_DelayMS(15);	/* 4.5ms  7.5ms  13.5ms   25.5ms */
	}
	else if (g_tBMP085.OSS == 3)
	{
		bsp_DelayMS(27);	/* 4.5ms  7.5ms  13.5ms   25.5ms */
	}
}

/*
*********************************************************************************************************
*	  : BMP085_ReadTempPress
*	˵: ȡBMP085¶ֵѹֵȫֱ g_tBMP085.Tempg_tBMP085.Press
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void BMP085_ReadTempPress(void)
{
	long UT, X1, X2, B5, T;
	long UP, X3, B3, B6, B7, p;
	unsigned long B4;

	/* ̼ pdf page 12 */

	/* ¶ԭʼֵ */
	BMP085_WriteReg(0xF4, 0x2E);
	BMP085_WaitConvert();	/* ȴת */
	UT = BMP085_Read2Bytes(0xF6);

	/* ѹԭʼֵ */
	BMP085_WriteReg(0xF4, 0x34 + (g_tBMP085.OSS << 6));
	BMP085_WaitConvert();	/* ȴת */
	UP = BMP085_Read3Bytes(0xF6) >> (8 - g_tBMP085.OSS);

	/* ʵ¶ȣλ 0.1϶ȣ */
	X1 = ((long)(UT - g_tBMP085.AC6) * g_tBMP085.AC5) >> 15;
	X2 = ((long)g_tBMP085.MC << 11) / (X1 + g_tBMP085.MD);
	B5 = X1 + X2;	/* ϵѹ¶Ȳ */
	T = (B5 + 8) >> 4;
	g_tBMP085.Temp = T;		/* ȫֱ */

	/* ʵѹֵλ Pa */
	B6 = B5 - 4000;
	X1 = (g_tBMP085.B2 * (B6 * B6) >> 12) >> 11;
	X2 = (g_tBMP085.AC2 * B6) >> 11;
	X3 = X1 + X2;
	B3 = (((((long)g_tBMP085.AC1) * 4 + X3) << g_tBMP085.OSS) + 2) >> 2;

	X1 = (g_tBMP085.AC3 * B6) >> 13;
	X2 = (g_tBMP085.B1 * ((B6 * B6) >> 12)) >> 16;
	X3 = ((X1 + X2) + 2) >> 2;
	B4 = (g_tBMP085.AC4 * (unsigned long)(X3 + 32768)) >> 15;

	B7 = ((unsigned long)(UP - B3) * (50000 >> g_tBMP085.OSS));
	if (B7 < 0x80000000)
	{
		p = (B7 << 1) / B4;
	}
	else
	{
		p = (B7 / B4) << 1;
	}

	X1 = (p >> 8) * (p >> 8);
	X1 = (X1 * 3038) >> 16;
	X2 = (-7357 * p) >> 16;
 	p =  p + ((X1 + X2 + 3791) >> 4);

	g_tBMP085.Press = p;		/* ȫֱ */
}

/*****************************  www.armfly.com (END OF FILE) *********************************/
