/*
*********************************************************************************************************
*
*	ģ : EEPROM 24xxģ
*	ļ : bsp_eeprom_24xx.c
*	     : V1.0
*	˵     : ʵ24xxϵEEPROMĶддҳдģʽдЧʡ
*
*	޸ļ¼ :
*		汾               ˵
*		V1.0    2013-02-01 armfly  ʽ
*
*	Copyright (C), 2013-2014,  www.armfly.com
*
*********************************************************************************************************
*/

/*
	Ӧ˵ʴEEPROMǰȵһ bsp_InitI2C()úI2CصGPIO.
*/

#include "bsp.h"

/*
*********************************************************************************************************
*	  : ee_CheckOk
*	˵: жϴEERPOMǷ
*	    :  
*	  ֵ: 1 ʾ 0 ʾ
*********************************************************************************************************
*/
uint8_t ee_CheckOk(void)
{
	if (i2c_CheckDevice(EE_DEV_ADDR) == 0)
	{
		return 1;
	}
	else
	{
		/* ʧܺмǷI2Cֹͣź */
		i2c_Stop();
		return 0;
	}
}


/*
*********************************************************************************************************
*	  : ee_ReadBytes
*	˵: ӴEEPROMַָʼȡ
*	    :  _usAddress : ʼַ
*			 _usSize : ݳȣλΪֽ
*			 _pReadBuf : ŶݵĻָ
*	  ֵ: 0 ʾʧܣ1ʾɹ
*********************************************************************************************************
*/
uint8_t ee_ReadBytes(uint8_t *_pReadBuf, uint16_t _usAddress, uint16_t _usSize)
{
	uint16_t i;

	/* ôEEPROM漴ȡָУȡֽ */

	/* 1I2Cź */
	i2c_Start();

	/* 2ֽڣ7bitǵַbit0Ƕдλ0ʾд1ʾ */
	i2c_SendByte(EE_DEV_ADDR | I2C_WR);	/* ˴дָ */

	/* 3ACK */
	if (i2c_WaitAck() != 0)
	{
		goto cmd_fail;	/* EEPROMӦ */
	}

	/* 4ֽڵַ24C02ֻ256ֽڣ1ֽھ͹ˣ24C04ϣô˴Ҫַ */
	if (EE_ADDR_BYTES == 1)
	{
		i2c_SendByte((uint8_t)_usAddress);
		if (i2c_WaitAck() != 0)
		{
			goto cmd_fail;	/* EEPROMӦ */
		}
	}
	else
	{
		i2c_SendByte(_usAddress >> 8);
		if (i2c_WaitAck() != 0)
		{
			goto cmd_fail;	/* EEPROMӦ */
		}

		i2c_SendByte(_usAddress);
		if (i2c_WaitAck() != 0)
		{
			goto cmd_fail;	/* EEPROMӦ */
		}
	}

	/* 6I2Cߡ濪ʼȡ */
	i2c_Start();

	/* 7ֽڣ7bitǵַbit0Ƕдλ0ʾд1ʾ */
	i2c_SendByte(EE_DEV_ADDR | I2C_RD);	/* ˴Ƕָ */

	/* 8ACK */
	if (i2c_WaitAck() != 0)
	{
		goto cmd_fail;	/* EEPROMӦ */
	}

	/* 9ѭȡ */
	for (i = 0; i < _usSize; i++)
	{
		_pReadBuf[i] = i2c_ReadByte();	/* 1ֽ */

		/* ÿ1ֽںҪAck һֽڲҪAckNack */
		if (i != _usSize - 1)
		{
			i2c_Ack();	/* мֽڶCPUACKź(SDA = 0) */
		}
		else
		{
			i2c_NAck();	/* 1ֽڶCPUNACKź(SDA = 1) */
		}
	}
	/* I2Cֹͣź */
	i2c_Stop();
	return 1;	/* ִгɹ */

cmd_fail: /* ִʧܺмǷֹͣźţӰI2C豸 */
	/* I2Cֹͣź */
	i2c_Stop();
	return 0;
}

/*
*********************************************************************************************************
*	  : ee_WriteBytes
*	˵: EEPROMַָдݣҳддЧ
*	    :  _usAddress : ʼַ
*			 _usSize : ݳȣλΪֽ
*			 _pWriteBuf : ŶݵĻָ
*	  ֵ: 0 ʾʧܣ1ʾɹ
*********************************************************************************************************
*/
uint8_t ee_WriteBytes(uint8_t *_pWriteBuf, uint16_t _usAddress, uint16_t _usSize)
{
	uint16_t i,m;
	uint16_t usAddr;

	/*
		дEEPROMȡֽܶڣÿдֻͬһpage
		24xx02page size = 8
		򵥵ĴΪֽдģʽÿд1ֽڣ͵ַ
		ΪдЧ: page wirte
	*/

	usAddr = _usAddress;
	for (i = 0; i < _usSize; i++)
	{
		/* ͵1ֽڻҳ׵ַʱҪ·źź͵ַ */
		if ((i == 0) || (usAddr & (EE_PAGE_SIZE - 1)) == 0)
		{
			/*ڣֹͣźţڲд*/
			i2c_Stop();

			/* ͨӦķʽжڲдǷ, һС 10ms
				CLKƵΪ200KHzʱѯΪ30
			*/
			for (m = 0; m < 1000; m++)
			{
				/* 1I2Cź */
				i2c_Start();

				/* 2ֽڣ7bitǵַbit0Ƕдλ0ʾд1ʾ */
				i2c_SendByte(EE_DEV_ADDR | I2C_WR);	/* ˴дָ */

				/* 3һʱӣжǷȷӦ */
				if (i2c_WaitAck() == 0)
				{
					break;
				}
			}
			if (m  == 1000)
			{
				goto cmd_fail;	/* EEPROMдʱ */
			}

			/* 4ֽڵַ24C02ֻ256ֽڣ1ֽھ͹ˣ24C04ϣô˴Ҫַ */
			if (EE_ADDR_BYTES == 1)
			{
				i2c_SendByte((uint8_t)usAddr);
				if (i2c_WaitAck() != 0)
				{
					goto cmd_fail;	/* EEPROMӦ */
				}
			}
			else
			{
				i2c_SendByte(usAddr >> 8);
				if (i2c_WaitAck() != 0)
				{
					goto cmd_fail;	/* EEPROMӦ */
				}

				i2c_SendByte(usAddr);
				if (i2c_WaitAck() != 0)
				{
					goto cmd_fail;	/* EEPROMӦ */
				}
			}
		}

		/* 6ʼд */
		i2c_SendByte(_pWriteBuf[i]);

		/* 7ACK */
		if (i2c_WaitAck() != 0)
		{
			goto cmd_fail;	/* EEPROMӦ */
		}

		usAddr++;	/* ַ1 */
	}

	/* ִгɹI2Cֹͣź */
	i2c_Stop();
	return 1;

cmd_fail: /* ִʧܺмǷֹͣźţӰI2C豸 */
	/* I2Cֹͣź */
	i2c_Stop();
	return 0;
}

/*****************************  www.armfly.com (END OF FILE) *********************************/
