/*
*********************************************************************************************************
*
*	ģ : GPSλģ
*	ļ : bsp_g_tGPS.c
*	     : V1.1
*	˵     : GPSЭ NMEA-0183Э, ԭ
*
*	޸ļ¼ :
*		汾               ˵
*		V1.0    2013-02-01 armfly  ʽ
*		V1.1    2014-02-04 armfly  ȫֱ־ʾ GPSģ鴮
*
*	Copyright (C), 2013-2014,  www.armfly.com
*
*********************************************************************************************************
*/

#include "bsp.h"

/* ꣬ʾGPSģתCOM1ڣͨԹ۲ԭʼ */
//#define DEBUG_GPS_TO_COM1

void Analyze0183(uint8_t *_ucaBuf, uint16_t _usLen);
int32_t StrToInt(char *_pStr);
int32_t StrToIntFix(char *_pStr, uint8_t _ucLen);
void HexToAscii(uint8_t *_ucpHex, uint8_t *_ucpAscII, uint8_t _ucLenasc);

GPS_T g_tGPS;

/*
*********************************************************************************************************
*	  : bsp_InitGPS
*	˵: GPS
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void bsp_InitGPS(void)
{
	/*
		GPS ģʹ UART ڷͶλ STM32, ÿӷһ

		ˣֻҪôڼɡ bsp_uart_fifo.c Ѿúôڣ˴
	*/

	g_tGPS.PositionOk = 0;  /* ΪЧ */
	g_tGPS.TimeOk = 0;  /* ΪЧ */
	
	g_tGPS.UartOk = 0;	/* ͨı־, ԺյУϸΪ1 */
}

/*
*********************************************************************************************************
*	  : gps_pro
*	˵: ѯGPSݰ뵽ִмɡȫֱ g_tGPS
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void gps_pro(void)
{
	uint8_t ucData;
	static uint8_t ucGpsHead = 0;
	static uint8_t ucaGpsBuf[512];
	static uint16_t usGpsPos = 0;

	/*  GPSģ鴮ڶȡ1ֽ comGetChar()  bsp_uart_fifo.c ʵ */
	while (1)
	{
		if (comGetChar(COM2, &ucData))
		{
			#ifdef DEBUG_GPS_TO_COM1
				/* յGPSģݰԭ ӡCOM1 ڣڸٵ */
				comSendChar(COM1, ucData);
			#endif

			if (ucGpsHead == 0)
			{
				if (ucData == '$')
				{
					ucGpsHead = 1;
					usGpsPos = 0;
				}
			}
			else
			{
				if (usGpsPos < sizeof(ucaGpsBuf))
				{
					ucaGpsBuf[usGpsPos++] = ucData;

					if ((ucData == '\r') || (ucData == '\n'))
					{
						Analyze0183(ucaGpsBuf, usGpsPos-1);
						ucGpsHead = 0;
						
						g_tGPS.UartOk = 1;	/* յȷ */
					}
				}
				else
				{
					ucGpsHead = 0;
				}

			}

			continue;	/* ܻݣ */
		}

		break;	/* ϣ˳ */
	}
}

/*
*********************************************************************************************************
*	  : CheckXor
*	˵: 0183ݰУǷȷ
*	    :  _ucaBuf  յ
*			 _usLen    ݳ
*	  ֵ: TRUE  FALSE.
*********************************************************************************************************
*/
uint8_t CheckXor(uint8_t *_ucaBuf, uint16_t _usLen)
{
	uint8_t ucXorSum;
	uint8_t ucaBuf[2];
	uint16_t i;

	if (_usLen < 3)
	{
		return FALSE;
	}

	/* ûУֽڣҲΪ */
	if (_ucaBuf[_usLen - 3] != '*')
	{
		return FALSE;
	}


	/* ַASCIIַ */
	for (i = 0; i < _usLen - 3; i++)
	{
		if ((_ucaBuf[i] & 0x80) || (_ucaBuf[i] == 0))
		{
			return FALSE;
		}
	}

	ucXorSum = _ucaBuf[0];
	for (i = 1; i < _usLen - 3; i++)
	{
		ucXorSum = ucXorSum ^ _ucaBuf[i];
	}

	HexToAscii(&ucXorSum, ucaBuf, 2);

	if (memcmp(&_ucaBuf[_usLen - 2], ucaBuf, 2) == 0)
	{
		return TRUE;
	}

	return FALSE;
}

/*
*********************************************************************************************************
*	  : gpsGPGGA
*	˵: 0183ݰе GPGGA ŵȫֱ
*	    :  _ucaBuf  յ
*			 _usLen    ݳ
*	  ֵ: 
*********************************************************************************************************
*/
/*
$GPGGA,092204.999,4250.5589,S,14718.5084,E,1,04,24.4,19.7,M,,,,0000*1F
ֶ0$GPGGAIDΪGlobal Positioning System Fix DataGGAGPSλϢ
ֶ1UTC ʱ䣬hhmmss.sssʱʽ
ֶ2γddmm.mmmmȷָʽǰλ0
ֶ3γNγSγ
ֶ4dddmm.mmmmȷָʽǰλ0
ֶ5EW
ֶ6GPS״̬0=δλ1=ǲֶλ2=ֶλ3=ЧPPS6=ڹ
ֶ7ʹõ00 - 12ǰλ0
ֶ8HDOPˮƽӣ0.5 - 99.9
ֶ9θ߶ȣ-9999.9 - 99999.9
ֶ10Դˮ׼ĸ߶
ֶ11ʱ䣨һνյźſʼǲֶλΪգ
ֶ12վID0000 - 1023ǰλ0ǲֶλΪգ
ֶ13Уֵ
*/
void gpsGPGGA(uint8_t *_ucaBuf, uint16_t _usLen)
{
	char *p;

	p = (char *)_ucaBuf;
	p[_usLen] = 0;

	/* ֶ1 UTC ʱ䣬hhmmss.sssʱʽ */
	p = strchr(p, ',');
	if (p == 0)
	{
		return;
	}
	p++;
	g_tGPS.Hour = StrToIntFix(p, 2);
	p += 2;
	g_tGPS.Min = StrToIntFix(p, 2);
	p += 2;
	g_tGPS.Sec = StrToIntFix(p, 2);
	p += 2;

	/* ֶ2 γddmm.mmmmȷָʽǰλ0 */
	p = strchr(p, ',');
	if (p == 0)
	{
		return;
	}
	p++;
	g_tGPS.WeiDu_Du = StrToIntFix(p, 2);
	p += 2;
	g_tGPS.WeiDu_Fen = StrToIntFix(p, 2) * 10000;
	p += 3;
	g_tGPS.WeiDu_Fen += StrToIntFix(p, 4);
	p += 4;

	/* ֶ3 γNγSγ */
	p = strchr(p, ',');
	if (p == 0)
	{
		return;
	}
	p++;
	if (*p == 'S')
	{
		g_tGPS.NS = 'S';
	}
	else if (*p == 'N')
	{
		g_tGPS.NS = 'N';
	}
	else
	{
		return;
	}

	/* ֶ4  dddmm.mmmmȷָʽǰλ0 */
	p = strchr(p, ',');
	if (p == 0)
	{
		return;
	}
	p++;
	g_tGPS.JingDu_Du = StrToIntFix(p, 3);
	p += 3;
	g_tGPS.JingDu_Fen = StrToIntFix(p, 2) * 10000;
	p += 3;
	g_tGPS.JingDu_Fen += StrToIntFix(p, 4);
	p += 4;

	/* ֶ5 EW */
	p = strchr(p, ',');
	if (p == 0)
	{
		return;
	}
	p++;
	if (*p == 'E')
	{
		g_tGPS.EW = 'E';
	}
	else if (*p == 'W')
	{
		g_tGPS.EW = 'W';
	}

	/* ֶ6 GPS״̬0=δλ1=ǲֶλ2=ֶλ3=ЧPPS6=ڹ */
	p = strchr(p, ',');
	if (p == 0)
	{
		return;
	}
	p++;
	if ((*p == '1') || (*p == '2'))
	{
		g_tGPS.PositionOk = 1;
	}
	else
	{
		g_tGPS.PositionOk = 0;
	}

	/* ֶ7ʹõ00 - 12ǰλ0 */
	p = strchr(p, ',');
	if (p == 0)
	{
		return;
	}
	p++;
	g_tGPS.ViewNumber = StrToInt(p);
	p += 2;

	/* ֶ8HDOPˮƽӣ0.5 - 99.9 */
	p = strchr(p, ',');
	if (p == 0)
	{
		return;
	}
	p++;
	g_tGPS.HDOP = StrToInt(p);

	/* ֶ9θ߶ȣ-9999.9 - 99999.9 */
	p = strchr(p, ',');
	if (p == 0)
	{
		return;
	}
	p++;
	g_tGPS.Altitude = StrToInt(p);

	/* ֶϢ */
}

/*
*********************************************************************************************************
*	  : gpsGPGSA
*	˵: 0183ݰе GPGSA ŵȫֱ
*	    :  _ucaBuf  յ
*			 _usLen    ݳ
*	  ֵ: 
*********************************************************************************************************
*/
/*
$GPGSA,A,3,01,20,19,13,,,,,,,,,40.4,24.4,32.2*0A
ֶ0$GPGSAIDΪGPS DOP and Active SatellitesGSAǰϢ
ֶ1λģʽA=Զֶ2D/3DM=ֶ2D/3D
ֶ2λͣ1=δλ2=2Dλ3=3Dλ
ֶ3PRN루α룩1ŵʹõPRNţ00ǰλ0
ֶ4PRN루α룩2ŵʹõPRNţ00ǰλ0
ֶ5PRN루α룩3ŵʹõPRNţ00ǰλ0
ֶ6PRN루α룩4ŵʹõPRNţ00ǰλ0
ֶ7PRN루α룩5ŵʹõPRNţ00ǰλ0
ֶ8PRN루α룩6ŵʹõPRNţ00ǰλ0
ֶ9PRN루α룩7ŵʹõPRNţ00ǰλ0
ֶ10PRN루α룩8ŵʹõPRNţ00ǰλ0
ֶ11PRN루α룩9ŵʹõPRNţ00ǰλ0
ֶ12PRN루α룩10ŵʹõPRNţ00ǰλ0
ֶ13PRN루α룩11ŵʹõPRNţ00ǰλ0
ֶ14PRN루α룩12ŵʹõPRNţ00ǰλ0
ֶ15PDOPۺλþӣ0.5 - 99.9
ֶ16HDOPˮƽӣ0.5 - 99.9
ֶ17VDOPֱӣ0.5 - 99.9
ֶ18Уֵ
*/
void gpsGPGSA(uint8_t *_ucaBuf, uint16_t _usLen)
{
	char *p;
	uint8_t i;

	p = (char *)_ucaBuf;
	p[_usLen] = 0;

	/* ֶ1 λģʽA=Զֶ2D/3DM=ֶ2D/3D */
	p = strchr(p, ',');
	if (p == 0)
	{
		return;
	}
	p++;
	g_tGPS.ModeAM = *p;

	/* ֶ2 λͣ1=δλ2=2Dλ3=3Dλ */
	p = strchr(p, ',');
	if (p == 0)
	{
		return;
	}
	p++;
	g_tGPS.Mode2D3D = *p;

	/* ֶ3 - ֶ14 1-12ŵʹõPRN */
	for (i = 0; i < 12; i++)
	{
		p = strchr(p, ',');
		if (p == 0)
		{
			return;
		}
		p++;
		g_tGPS.SateID[i] = StrToInt(p);
	}

	/* ֶ15PDOPۺλþӣ0.5 - 99.9 */
	p = strchr(p, ',');
	if (p == 0)
	{
		return;
	}
	p++;
	g_tGPS.PDOP = StrToInt(p);

	/* ֶ16HDOPˮƽӣ0.5 - 99.9 */
	p = strchr(p, ',');
	if (p == 0)
	{
		return;
	}
	p++;
	g_tGPS.HDOP = StrToInt(p);

	/* ֶ17VDOPֱӣ0.5 - 99.9 */
	p = strchr(p, ',');
	if (p == 0)
	{
		return;
	}
	p++;
	g_tGPS.VDOP = StrToInt(p);
}

/*
*********************************************************************************************************
*	  : gpsGPGSV
*	˵: 0183ݰе GPGSV ŵȫֱ
*	    :  _ucaBuf  յ
*			 _usLen    ݳ
*	  ֵ: 
*********************************************************************************************************
*/
/*
$GPGSV,3,1,10,20,78,331,45,01,59,235,47,22,41,069,,13,32,252,45*70

$GPGSV,2,1,07,07,79,048,42,02,51,062,43,26,36,256,42,27,27,138,42*71
$GPGSV,2,2,07,09,23,313,42,04,19,159,41,15,12,041,42*41

ֶ0$GPGSVIDΪGPS Satellites in ViewGSVɼϢ
ֶ1GSVĿ1 - 3
ֶ2GSVǱGSVĵڼ1 - 3
ֶ3ǰɼ00 - 12ǰλ0

ֶ4PRN 루α룩01 - 32ǰλ0
ֶ5ǣ00 - 90ȣǰλ0
ֶ6Ƿλǣ00 - 359ȣǰλ0
ֶ7ȣ0099dbHz

ֶ8PRN 루α룩01 - 32ǰλ0
ֶ9ǣ00 - 90ȣǰλ0
ֶ10Ƿλǣ00 - 359ȣǰλ0
ֶ11ȣ0099dbHz

ֶ12PRN 루α룩01 - 32ǰλ0
ֶ13ǣ00 - 90ȣǰλ0
ֶ14Ƿλǣ00 - 359ȣǰλ0
ֶ15ȣ0099dbHz
ֶ16Уֵ
*/
void gpsGPGSV(uint8_t *_ucaBuf, uint16_t _usLen)
{
//	uint8_t s_total = 0;	/* Ŀ */
	uint8_t s_no = 0;		/*  */
	uint8_t i;
	char *p;

	p = (char *)_ucaBuf;
	p[_usLen] = 0;

	/* ֶ1GSVĿ1 - 3 */
	p = strchr(p, ',');
	if (p == 0)
	{
		return;
	}
	p++;
//	s_total = StrToInt(p);

	/* ֶ2GSVǱGSVĵڼ1 - 3 */
	p = strchr(p, ',');
	if (p == 0)
	{
		return;
	}
	p++;
	s_no = StrToInt(p);

	/* ֶ3ǰɼ00 - 12ǰλ0 */
	p = strchr(p, ',');
	if (p == 0)
	{
		return;
	}
	p++;
	g_tGPS.ViewNumber = StrToInt(p);

	for (i = 0; i < 4; i++)
	{
		/* ֶ4PRN 루α룩01 - 32ǰλ0 */
		p = strchr(p, ',');
		if (p == 0)
		{
			return;
		}
		p++;
		g_tGPS.SateID[(s_no - 1) * 4 + i] = StrToInt(p);

		/* ֶ5ǣ00 - 90ȣǰλ0*/
		p = strchr(p, ',');
		if (p == 0)
		{
			return;
		}
		p++;
		g_tGPS.Elevation[(s_no - 1) * 4 + i] = StrToInt(p);

		/* ֶ6Ƿλǣ00 - 359ȣǰλ0 */
		p = strchr(p, ',');
		if (p == 0)
		{
			return;
		}
		p++;
		g_tGPS.Azimuth[(s_no - 1) * 4 + i] = StrToInt(p);

		/* ֶ7ȣ0099dbHz */
		p = strchr(p, ',');
		if (p == 0)
		{
			return;
		}
		p++;
		g_tGPS.SNR[(s_no - 1) * 4 + i] = StrToInt(p);
	}
}

/*
*********************************************************************************************************
*	  : gpsGPRMC
*	˵: 0183ݰе GPGSV ŵȫֱ
*	    :  _ucaBuf  յ
*			 _usLen    ݳ
*	  ֵ: 
*********************************************************************************************************
*/
/*
$GPRMC,024813.640,A,3158.4608,N,11848.3737,E,10.05,324.27,150706,,,A*50
ֶ0$GPRMCIDΪRecommended Minimum Specific GPS/TRANSIT DataRMCƼСλϢ
ֶ1UTCʱ䣬hhmmss.sssʽ
ֶ2״̬A=λV=δλ
ֶ3γddmm.mmmmȷָʽǰλ0
ֶ4γNγSγ
ֶ5dddmm.mmmmȷָʽǰλ0
ֶ6EW
ֶ7ٶȣڣKnots
ֶ8λǣ
ֶ9UTCڣDDMMYYʽ
ֶ10ƫǣ000 - 180ȣǰλ0
ֶ11ƫǷE=W=
ֶ16Уֵ
*/
void gpsGPRMC(uint8_t *_ucaBuf, uint16_t _usLen)
{
	char *p;

	p = (char *)_ucaBuf;
	p[_usLen] = 0;

	/* ֶ1 UTCʱ䣬hhmmss.sssʽ */
	p = strchr(p, ',');
	if (p == 0)
	{
		return;
	}
	p++;
	g_tGPS.Hour = StrToIntFix(p, 2);
	p += 2;
	g_tGPS.Min = StrToIntFix(p, 2);
	p += 2;
	g_tGPS.Sec = StrToIntFix(p, 2);
	p += 3;
	g_tGPS.mSec = StrToIntFix(p, 3);

	/* ֶ2 ״̬A=λV=δλ */
	p = strchr(p, ',');
	if (p == 0)
	{
		return;
	}
	p++;
	if (*p != 'A')
	{
		/* δλֱӷ */
		g_tGPS.PositionOk = 0;
		return;
	}
	g_tGPS.PositionOk = 1;
	p += 1;

	/* ֶ3 γddmm.mmmmȷָʽǰλ0 */
	p = strchr(p, ',');
	if (p == 0)
	{
		return;
	}
	p++;
	g_tGPS.WeiDu_Du = StrToIntFix(p, 2);
	p += 2;
	g_tGPS.WeiDu_Fen = StrToIntFix(p, 2) * 10000;
	p += 3;
	g_tGPS.WeiDu_Fen += StrToIntFix(p, 4);
	p += 4;

	/* ֶ4 γNγSγ*/
	p = strchr(p, ',');
	if (p == 0)
	{
		return;
	}
	p++;
	if (*p == 'S')
	{
		g_tGPS.NS = 'S';
	}
	else if (*p == 'N')
	{
		g_tGPS.NS = 'N';
	}
	else
	{
		return;
	}

	/* ֶ5 dddmm.mmmmȷָʽǰλ0 */
	p = strchr(p, ',');
	if (p == 0)
	{
		return;
	}
	p++;
	g_tGPS.JingDu_Du = StrToIntFix(p, 3);
	p += 3;
	g_tGPS.JingDu_Fen = StrToIntFix(p, 2) * 10000;
	p += 3;
	g_tGPS.JingDu_Fen += StrToIntFix(p, 4);
	p += 4;

	/* ֶ6EW */
	p = strchr(p, ',');
	if (p == 0)
	{
		return;
	}
	p++;
	if (*p == 'E')
	{
		g_tGPS.EW = 'E';
	}
	else if (*p == 'W')
	{
		g_tGPS.EW = 'W';
	}

	/* ֶ7ٶȣڣKnots  10.05,*/
	p = strchr(p, ',');
	if (p == 0)
	{
		return;
	}
	p++;
	g_tGPS.SpeedKnots = StrToInt(p);

	/* ֶ8λǣ ,324.27 */
	p = strchr(p, ',');
	if (p == 0)
	{
		return;
	}
	p++;
	g_tGPS.TrackDegTrue = StrToInt(p);

	/* ֶ9UTCڣDDMMYYʽ  150706 */
	p = strchr(p, ',');
	if (p == 0)
	{
		return;
	}
	p++;
	g_tGPS.Day = StrToIntFix(p, 2);
	p += 2;
	g_tGPS.Month = StrToIntFix(p, 2);
	p += 2;
	g_tGPS.Year = StrToIntFix(p, 2);
	p += 2;
}

/*
*********************************************************************************************************
*	  : gpsGPVTG
*	˵: 0183ݰе GPVTG ŵȫֱ
*	    :  _ucaBuf  յ
*			 _usLen    ݳ
*	  ֵ: 
*********************************************************************************************************
*/
/*
$GPVTG,89.68,T,,M,0.00,N,0.0,K*5F
ֶ0$GPVTGIDΪTrack Made Good and Ground SpeedVTGٶϢ
ֶ1˶Ƕȣ000 - 359ǰλ0
ֶ2T=汱ϵ
ֶ3˶Ƕȣ000 - 359ǰλ0
ֶ4M=űϵ
ֶ5ˮƽ˶ٶȣ0.00ǰλ0
ֶ6N=ڣKnots
ֶ7ˮƽ˶ٶȣ0.00ǰλ0
ֶ8K=/ʱkm/h
ֶ9Уֵ
*/
void gpsGPVTG(uint8_t *_ucaBuf, uint16_t _usLen)
{
	char *p;

	p = (char *)_ucaBuf;
	p[_usLen] = 0;

	/* ֶ1˶Ƕȣ000 - 359ǰλ0*/
	p = strchr(p, ',');
	if (p == 0)
	{
		return;
	}
	p++;
	g_tGPS.TrackDegTrue = StrToInt(p);

	/* ֶ2T=汱ϵ */
	p = strchr(p, ',');
	if (p == 0)
	{
		return;
	}
	p++;

	/* ֶ3˶Ƕȣ000 - 359ǰλ0 */
	p = strchr(p, ',');
	if (p == 0)
	{
		return;
	}
	p++;
	g_tGPS.TrackDegMag = StrToInt(p);

	/* ֶ4M=űϵ */
	p = strchr(p, ',');
	if (p == 0)
	{
		return;
	}
	p++;

	/* ֶ5ʣ000.0~999.9ڣǰ0Ҳ䣩 */
	p = strchr(p, ',');
	if (p == 0)
	{
		return;
	}
	p++;
	g_tGPS.SpeedKnots = StrToInt(p);

	/* ֶ6N=ڣKnots */
	p = strchr(p, ',');
	if (p == 0)
	{
		return;
	}
	p++;

	/* ֶ7ʣ0000.0~1851.8/Сʱǰ0Ҳ䣩 */
	p = strchr(p, ',');
	if (p == 0)
	{
		return;
	}
	p++;
	g_tGPS.SpeedKM = StrToInt(p);

	/* ֶ8K=/ʱkm/h	 */
}

/*
*********************************************************************************************************
*	  : gpsGPGLL
*	˵: 0183ݰе GPGLL ŵȫֱ
*	    :  _ucaBuf  յ
*			 _usLen    ݳ
*	  ֵ: 
*********************************************************************************************************
*/
/*
$GPGLL,4250.5589,S,14718.5084,E,092204.999,A*2D
ֶ0$GPGLLIDΪGeographic PositionGLLλϢ
ֶ1γddmm.mmmmȷָʽǰλ0
ֶ2γNγSγ
ֶ3dddmm.mmmmȷָʽǰλ0
ֶ4EW
ֶ5UTCʱ䣬hhmmss.sssʽ
ֶ6״̬A=λV=δλ
ֶ7Уֵ
*/
void gpsGPGLL(uint8_t *_ucaBuf, uint16_t _usLen)
{
	char *p;

	p = (char *)_ucaBuf;
	p[_usLen] = 0;

	/* ֶ1 γddmm.mmmmȷָʽǰλ0 */
	p = strchr(p, ',');
	if (p == 0)
	{
		return;
	}
	p++;
	g_tGPS.WeiDu_Du = StrToIntFix(p, 2);
	p += 2;
	g_tGPS.WeiDu_Fen = StrToIntFix(p, 2) * 10000;
	p += 3;
	g_tGPS.WeiDu_Fen += StrToIntFix(p, 4);
	p += 4;

	/* ֶ2 γNγSγ*/
	p = strchr(p, ',');
	if (p == 0)
	{
		return;
	}
	p++;
	if (*p == 'S')
	{
		g_tGPS.NS = 'S';
	}
	else if (*p == 'N')
	{
		g_tGPS.NS = 'N';
	}
	else
	{
		return;
	}

	/* ֶ3 dddmm.mmmmȷָʽǰλ0 */
	p = strchr(p, ',');
	if (p == 0)
	{
		return;
	}
	p++;
	g_tGPS.JingDu_Du = StrToIntFix(p, 3);
	p += 3;
	g_tGPS.JingDu_Fen = StrToIntFix(p, 2) * 10000;
	p += 3;
	g_tGPS.JingDu_Fen += StrToIntFix(p, 4);
	p += 4;

	/* ֶ4EW */
	p = strchr(p, ',');
	if (p == 0)
	{
		return;
	}
	p++;
	if (*p == 'E')
	{
		g_tGPS.EW = 'E';
	}
	else if (*p == 'W')
	{
		g_tGPS.EW = 'W';
	}

	/* ֶ5 UTCʱ䣬hhmmss.sssʽ */
	p = strchr(p, ',');
	if (p == 0)
	{
		return;
	}
	p++;
	g_tGPS.Hour = StrToIntFix(p, 2);
	p += 2;
	g_tGPS.Min = StrToIntFix(p, 2);
	p += 2;
	g_tGPS.Sec = StrToIntFix(p, 2);
	p += 2;

	/* ֶ6 ״̬A=λV=δλ */
	p = strchr(p, ',');
	if (p == 0)
	{
		return;
	}
	p++;
	if (*p != 'A')
	{
		/* δλֱӷ */
		return;
	}
}

/*
*********************************************************************************************************
*	  : Analyze0183
*	˵: 0183ݰ
*	    :  _ucaBuf  յ
*			 _usLen    ݳ
*	  ֵ: 
*********************************************************************************************************
*/
void Analyze0183(uint8_t *_ucaBuf, uint16_t _usLen)
{

	if (CheckXor(_ucaBuf, _usLen) != TRUE)
	{
		return;
	}

	if (memcmp(_ucaBuf, "GPGGA,", 6) == 0)
	{
		gpsGPGGA(_ucaBuf, _usLen);
	}
	else if (memcmp(_ucaBuf, "GPGSA,", 6) == 0)
	{
		gpsGPGSA(_ucaBuf, _usLen);
	}
	else if (memcmp(_ucaBuf, "GPGSV,", 6) == 0)
	{
		gpsGPGSV(_ucaBuf, _usLen);
	}
	else if (memcmp(_ucaBuf, "GPRMC,", 6) == 0)
	{
		gpsGPRMC(_ucaBuf, _usLen);
	}
	else if (memcmp(_ucaBuf, "GPVTG,", 6) == 0)
	{
		gpsGPVTG(_ucaBuf, _usLen);
	}
	else if (memcmp(_ucaBuf, "GPGLL,", 6) == 0)
	{
		gpsGPGLL(_ucaBuf, _usLen);
	}
}

/*
*********************************************************************************************************
*	  : StrToInt
*	˵: ASCIIַתʮ
*	    : _pStr :תASCII봮. ԶŻ0
*	  ֵ: ֵ
*********************************************************************************************************
*/
int32_t StrToInt(char *_pStr)
{
	uint8_t flag;
	char *p;
	uint32_t ulInt;
	uint8_t i;
	uint8_t ucTemp;

	p = _pStr;
	if (*p == '-')
	{
		flag = 1;	/*  */
		p++;
	}
	else
	{
		flag = 0;
	}

	ulInt = 0;
	for (i = 0; i < 15; i++)
	{
		ucTemp = *p;
		if (ucTemp == '.')	/* С㣬Զ1ֽ */
		{
			p++;
			ucTemp = *p;
		}
		if ((ucTemp >= '0') && (ucTemp <= '9'))
		{
			ulInt = ulInt * 10 + (ucTemp - '0');
			p++;
		}
		else
		{
			break;
		}
	}

	if (flag == 1)
	{
		return -ulInt;
	}
	return ulInt;
}

/*
*********************************************************************************************************
*	  : StrToIntFix
*	˵: ASCIIַתʮ, 
*	    : _pStr :תASCII봮. ԶŻ0
*			 _ucLen : ̶
*	  ֵ: ֵ
*********************************************************************************************************
*/
int32_t StrToIntFix(char *_pStr, uint8_t _ucLen)
{
	uint8_t flag;
	char *p;
	uint32_t ulInt;
	uint8_t i;
	uint8_t ucTemp;

	p = _pStr;
	if (*p == '-')
	{
		flag = 1;	/*  */
		p++;
		_ucLen--;
	}
	else
	{
		flag = 0;
	}

	ulInt = 0;
	for (i = 0; i < _ucLen; i++)
	{
		ucTemp = *p;
		if (ucTemp == '.')	/* С㣬Զ1ֽ */
		{
			p++;
			ucTemp = *p;
		}
		if ((ucTemp >= '0') && (ucTemp <= '9'))
		{
			ulInt = ulInt * 10 + (ucTemp - '0');
			p++;
		}
		else
		{
			break;
		}
	}

	if (flag == 1)
	{
		return -ulInt;
	}
	return ulInt;
}

/*
*********************************************************************************************************
*	  : HexToAscii
*	˵: hex0x1fת'1''f'. β0.
*	    : ucpHex 뻺ָ
*		     _ucpAscII ָ
*		    _ucLenasc ASCIIַ.
*	  ֵ: ֵ
*********************************************************************************************************
*/
void HexToAscii(uint8_t *_ucpHex, uint8_t *_ucpAscII, uint8_t _ucLenasc)
{
	uint8_t i;
	uint8_t ucTemp;

	for (i = 0; i < _ucLenasc; i++)
	{
		ucTemp = *_ucpHex;
		if ((i&0x01) == 0x00)
			ucTemp = ucTemp >> 4;
		else
		{
			ucTemp = ucTemp & 0x0f;
			_ucpHex++;
		}
		if (ucTemp < 0x0a)
			ucTemp += 0x30;
		else
			ucTemp += 0x37;
		_ucpAscII[i] = ucTemp;
	}
	//--------debug--------//
	_ucpAscII[i] = '\0';
	//--------end----------//
}

/*
*********************************************************************************************************
*	  : gps_FenToDu
*	˵: תΪȵС֣6λС ֻΪȡ
*	    : 
*	  ֵ: ضȵС֣ʮƣ
*********************************************************************************************************
*/
uint32_t gps_FenToDu(uint32_t _fen)
{
	uint32_t du;
	
	/* g_tGPS.WeiDu_Fen;	γȣ. 232475  С4λ  ʾ 23.2475 */
	
	du = (_fen * 100) / 60;
	
	return du;
}

/*
*********************************************************************************************************
*	  : gps_FenToMiao
*	˵: ֵСת
*	    : 
*	  ֵ:  
*********************************************************************************************************
*/
uint16_t gps_FenToMiao(uint32_t _fen)
{
	uint32_t miao;
	
	/* g_tGPS.WeiDu_Fen;	γȣ. 232475  С4λ  ʾ 23.2475 
		С 0.2475 * 60 = 14.85 Ϊ 15	
		
		
		2475 * 60 = 148500
		148500 / 10000 = 14;
		
		if ((148500 % 10000) >= 5000)
		{
			miao = 14 + 1
		}
	*/
	
	miao = ((_fen % 10000) * 60);
	
	if ((miao % 10000) >= 5000)
	{
		miao = miao / 10000 + 1;	/* 5 */
	}
	else
	{
		miao = miao / 10000;		/* 4 */
	}
		
	return miao;
}

/*
*********************************************************************************************************
*	  : StrToIntFix
*	˵: ASCIIַתʮ, 
*	    : _pStr :תASCII봮. ԶŻ0
*			 _ucLen : ̶
*	  ֵ: ֵ
*********************************************************************************************************
*/
void UTCDate(void)
{
	#if 0
	/* UTCʱ */
	{
		uint8_t ucaDays[]={31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};

		if (g_tParam.iUTCtime > 0)
		{
			g_tGPS.Hour += g_tParam.iUTCtime;
			if (g_tGPS.Hour > 23)
			{
				g_tGPS.Hour = g_tGPS.Hour - 24;
				g_tGPS.ucDay++;

				/* 2·Ϊ29 */
				if (IsLeapYear(g_tGPS.usYear))
				{
					ucaDays[1] = 29;
				}
				else
				{
					ucaDays[1] = 28;
				}

				if (g_tGPS.ucDay > ucaDays[g_tGPS.ucMonth - 1])
				{
					g_tGPS.ucDay = 1;

					g_tGPS.ucMonth++;

					if (g_tGPS.ucMonth > 12)
					{
						g_tGPS.usYear++;
					}
				}
			}

		}
		else if (g_tParam.iUTCtime < 0)
		{
			int iHour;

			iHour = g_tGPS.Hour;
			iHour += g_tParam.iUTCtime;

			if (iHour < 0)
			{
				g_tGPS.Hour = 24 + iHour;

				if (g_tGPS.ucDay == 1)
				{
					if (g_tGPS.ucMonth == 1)
					{
						g_tGPS.usYear--;
						g_tGPS.ucMonth = 12;
						g_tGPS.ucDay = 31;
					}
					else
					{
						if (g_tGPS.ucMonth == 3)
						{
							g_tGPS.ucMonth = 2;

							/* 2·Ϊ29 */
							if (IsLeapYear(g_tGPS.usYear))
							{
								g_tGPS.ucDay = 29;
							}
							else
							{
								g_tGPS.ucDay = 28;
							}
						}
						else
						{
							g_tGPS.ucMonth--;

							g_tGPS.ucDay = ucaDays[g_tGPS.ucMonth];
						}
					}
				}
				else
				{
					g_tGPS.ucDay--;
				}
			}
			else
			{
				g_tGPS.Hour = iHour;
			}
		}
	}
	#endif
}


/*
GPSϵÿһʱͻ᷵һʽݣݸʽΪ

$Ϣͣxxxxxxxxxxxxx

ÿпͷַǡ$ϢͣݣԶŷָһ£

    $GPRMC,080655.00,A,4546.40891,N,12639.65641,E,1.045,328.42,170809,,,A*60



ϢΪ

GPGSVɼϢ

GPGLLλϢ

GPRMCƼСλϢ

GPVTGٶϢ

GPGGAGPSλϢ

GPGSAǰϢ



1 GPS DOP and Active SatellitesGSAǰϢ

$GPGSA,<1>,<2>,<3>,<3>,,,,,<3>,<3>,<3>,<4>,<5>,<6>,<7>

<1>ģʽ M = ֶ A = Զ
<2>λʽ 1 = δλ 2 = άλ 3 = άλ
<3>PRN ֣01  32 ʹеǱţɽ12Ϣ
<4> PDOPλþӣ0.5~99.9
<5> HDOPˮƽӣ0.5~99.9
<6> VDOPֱӣ0.5~99.9
<7> Checksum.(λ).

2 GPS Satellites in ViewGSVɼϢ

$GPGSV, <1>,<2>,<3>,<4>,<5>,<6>,<7>,?<4>,<5>,<6>,<7>,<8>

<1> GSV
<2> GSVı
<3> ɼǵ00  12
<4> Ǳţ 01  32
<5>ǣ 00  90 ȡ
<6>Ƿλǣ 000  359 ȡʵֵ
<7>ѶȣC/No 00  99 dBޱδյѶš
<8>Checksum.(λ).
<4>,<5>,<6>,<7>ǻظ֣ÿĿǡϢڴһг֣δʹãЩֶλհס


3Global Positioning System Fix DataGGAGPSλϢ
$GPGGA,<1>,<2>,<3>,<4>,<5>,<6>,<7>,<8>,<9>,M,<10>,M,<11>,<12>*hh

<1> UTCʱ䣬hhmmssʱ룩ʽ
<2> γddmm.mmmmȷ֣ʽǰ0Ҳ䣩
<3> γȰN򣩻Sϰ
<4> dddmm.mmmmȷ֣ʽǰ0Ҳ䣩
<5> ȰEW
<6> GPS״̬0=δλ1=ǲֶλ2=ֶλ6=ڹ
<7> ʹýλõ00~12ǰ0Ҳ䣩
<8> HDOPˮƽӣ0.5~99.9
<9> θ߶ȣ-9999.9~99999.9
<10> Դˮ׼ĸ߶
<11> ʱ䣨һνյźſʼǲֶλΪգ
<12> վID0000~1023ǰ0Ҳ䣬ǲֶλΪգ


4Recommended Minimum Specific GPS/TRANSIT DataRMCƼλϢ
$GPRMC,<1>,<2>,<3>,<4>,<5>,<6>,<7>,<8>,<9>,<10>,<11>,<12>*hh

<1> UTCʱ䣬hhmmssʱ룩ʽ
<2> λ״̬A=ЧλV=Чλ
<3> γddmm.mmmmȷ֣ʽǰ0Ҳ䣩
<4> γȰN򣩻Sϰ
<5> dddmm.mmmmȷ֣ʽǰ0Ҳ䣩
<6> ȰEW
<7> ʣ000.0~999.9ڣǰ0Ҳ䣩
<8> 溽000.0~359.9ȣ汱Ϊο׼ǰ0Ҳ䣩
<9> UTCڣddmmyy꣩ʽ
<10> ƫǣ000.0~180.0ȣǰ0Ҳ䣩
<11> ƫǷEW
<12> ģʽָʾNMEA0183 3.00汾A=λD=֣E=㣬N=Ч


5 Track Made Good and Ground SpeedVTGٶϢ
$GPVTG,<1>,T,<2>,M,<3>,N,<4>,K,<5>*hh

<1> 汱Ϊο׼ĵ溽000~359ȣǰ0Ҳ䣩
<2> ԴűΪο׼ĵ溽000~359ȣǰ0Ҳ䣩
<3> ʣ000.0~999.9ڣǰ0Ҳ䣩
<4> ʣ0000.0~1851.8/Сʱǰ0Ҳ䣩
<5> ģʽָʾNMEA0183 3.00汾A=λD=֣E=㣬N=Ч

*/


/* ʵ人 GPS
$GPGGA,064518.046,,,,,0,00,,,M,0.0,M,,0000*5A
$GPGLL,,,,,064518.046,V,N*76
$GPGSA,A,1,,,,,,,,,,,,,,,*1E
$GPGSV,3,1,12,18,56,351,,22,51,026,,14,51,206,21,19,48,285,*78
$GPGSV,3,2,12,26,38,041,,24,37,323,,03,37,281,,09,31,097,*78
$GPGSV,3,3,12,21,17,122,,25,13,176,,31,13,054,,20,00,266,*7A
$GPRMC,064518.046,V,,,,,,,250213,,,N*46
$GPVTG,,T,,M,,N,,K,N*2C

//̵
$GPGGA,161037.000,3030.6548,N,11402.4568,E,1,04,5.2,51.1,M,-15.5,M,,0000*42
$GPGSA,A,3,05,12,02,25,,,,,,,,,6.0,5.2,2.9*3B
$GPGSV,3,1,10,02,49,314,31,05,37,225,41,12,33,291,32,25,09,318,33*7C
$GPGSV,3,2,10,10,85,027,18,04,57,019,18,17,45,123,20,13,26,075,*7F
$GPGSV,3,3,10,23,14,050,23,40,18,253,33*71
$GPRMC,161037.000,A,3030.6548,N,11402.4568,E,0.00,,010613,,,A*71
$GPVTG,,T,,M,0.00,N,0.0,K,A*13

//2
$GPGGA,165538.000,3030.6519,N,11402.4480,E,2,05,1.9,39.5,M,-15.5,M,6.8,0000*68
$GPGSA,A,3,26,05,25,12,02,,,,,,,,2.7,1.9,2.0*3A
$GPGSV,3,1,11,10,63,029,18,02,58,344,23,05,55,247,46,04,50,053,26*75
$GPGSV,3,2,11,12,31,265,39,17,27,139,22,13,22,053,23,25,17,301,37*78
$GPGSV,3,3,11,26,11,180,43,23,04,036,,40,18,253,33*4A
$GPRMC,165538.000,A,3030.6519,N,11402.4480,E,0.00,71.87,010613,,,D*5E
$GPVTG,71.87,T,,M,0.00,N,0.0,K,D*31
$GPGGA,165539.000,3030.6519,N,11402.4480,E,2,05,1.9,39.5,M,-15.5,M,7.8,0000*68
$GPRMC,

ȷ : 30 30 65

3030.6519 = 30 + 30.6519֣ 60ƣ 
30.6519   --> 30.6519 / 60 = 0.510865ȡ  30.510865

*/

/*****************************  www.armfly.com (END OF FILE) *********************************/
