/*
*********************************************************************************************************
*
*	ģ : ΪGPRSģMG323
*	ļ : bsp_mg323.c
*	     : V1.0
*	˵     : װMG323ģصAT
*
*	޸ļ¼ :
*		汾               ˵
*		V1.0    2013-02-01 armfly  ʽ
*
*	Copyright (C), 2013-2014,  www.armfly.com
*
*********************************************************************************************************
*/

#include "bsp.h"

/*
	STM32-V5 ߷䣺
	GPRS_TERM_ON    PB15
*/

/*
	AT+CIND=<mode>[,<mode>[,<mode>...]] ָʾ¼Ƿϱ
		+CIND: 5,99,1,0,1,0,0,0,4

	AT+CREG?  ѯǰ״̬

	AT+CSQ ѯź

	AT+CIMI ѯSIM IMSI š

	AT+CIND? ȡǰָʾ״̬

	ATA 
	ATH Ҷ

	AT^SWSPATH=<n>  лƵͨ
*/

/* ڶӦRCCʱ */
#define RCC_TERM_ON 	RCC_AHB1Periph_GPIOI
#define PORT_TERM_ON	GPIOI
#define PIN_TERM_ON		GPIO_Pin_0

#define RCC_RESET 		RCC_AHB1Periph_GPIOB
#define PORT_RESET		GPIOB
#define PIN_RESET		GPIO_Pin_7

/* STM32MG323TERM_ONż1NPNܣҪ */
#define TERM_ON_1()		GPIO_ResetBits(PORT_TERM_ON, PIN_TERM_ON);
#define TERM_ON_0()		GPIO_SetBits(PORT_TERM_ON, PIN_TERM_ON);

/* STM32MG323RESETż1NPNܣҪ. MG323RESETǵ帴λ */
#define MG_RESET_1()	GPIO_ResetBits(PORT_RESET, PIN_RESET);
#define MG_RESET_0()	GPIO_SetBits(PORT_RESET, PIN_RESET);

/*
*********************************************************************************************************
*	  : bsp_InitMG323
*	˵: ģصGPIO,  ú bsp_Init() á
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void bsp_InitMG323(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;

	/* GPIOʱ */
	RCC_AHB1PeriphClockCmd(RCC_TERM_ON | RCC_RESET, ENABLE);

	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;		/* Ϊ */
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;		/* Ϊģʽ */
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;	/* 費ʹ */
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;	/* IOٶ */

	GPIO_InitStructure.GPIO_Pin = PIN_TERM_ON;
	GPIO_Init(PORT_TERM_ON, &GPIO_InitStructure);

	GPIO_InitStructure.GPIO_Pin = PIN_RESET;
	GPIO_Init(PORT_RESET, &GPIO_InitStructure);

	/* CPUĴѾ bsp_uart_fifo.c е bsp_InitUart()  */
	
	TERM_ON_0();
	MG_RESET_1();
}

/*
*********************************************************************************************************
*	  : MG323_PrintRxData
*	˵: ӡSTM32MG323յݵCOM1ڣҪڸٵ
*	    : _ch : յ
*	  ֵ: 
*********************************************************************************************************
*/
void MG323_PrintRxData(uint8_t _ch)
{
	#ifdef MG323_TO_COM1_EN
		comSendChar(COM1, _ch);		/* յݴӡԴ1 */
	#endif
}

/*
*********************************************************************************************************
*	  : MG323_PowerOn
*	˵: MG323ģϵ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void MG323_PowerOn(void)
{
	comClearRxFifo(COM_MG323);	/* 㴮ڽջ */
	
	MG323_Reset();

	/*
		MG323ֲᣬģϵӳ250msȻ TERM_ONΪ͵ƽ 750ms ֮Ϊߣɿʱ
	*/
	TERM_ON_1();
	bsp_DelayMS(250);

	TERM_ON_0();
	bsp_DelayMS(750);
	TERM_ON_1();	

	/* ȴģϵ磬жǷյ ^SYSSTART */
	MG323_WaitResponse("^SYSSTART", 5000);
}

/*
*********************************************************************************************************
*	  : MG323_PowerOn
*	˵: MG323ģϵ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void MG323_Reset(void)
{
	/*
		MG323ֲᣬ
		RESET ܽʵģӲλģʱͨ
		RESET ܽ  10 ms ģӲλ
	*/
	MG_RESET_0();
	bsp_DelayMS(20);
	MG_RESET_1();
	
	bsp_DelayMS(10);
}


/*
*********************************************************************************************************
*	  : MG323_PowerOff
*	˵: MG323ģػ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void MG323_PowerOff(void)
{
	/* Ӳػ */
	TERM_ON_0();

	/* Ҳػ */
	//MG323_SendAT("AT^SMSO");
}

/*
*********************************************************************************************************
*	  : MG323_WaitResponse
*	˵: ȴMG323ָӦַ. ȴ OK
*	    : _pAckStr : Ӧַ Ȳó255
*			 _usTimeOut : ִгʱ0ʾһֱȴ. >ʾʱʱ䣬λ1ms
*	  ֵ: 1 ʾɹ  0 ʾʧ
*********************************************************************************************************
*/
uint8_t MG323_WaitResponse(char *_pAckStr, uint16_t _usTimeOut)
{
	uint8_t ucData;
	uint8_t ucRxBuf[256];
	uint16_t pos = 0;
	uint32_t len;
	uint8_t ret;

	len = strlen(_pAckStr);
	if (len > 255)
	{
		return 0;
	}

	/* _usTimeOut == 0 ʾ޵ȴ */
	if (_usTimeOut > 0)
	{
		bsp_StartTimer(MG323_TMR_ID, _usTimeOut);		/* ʹʱ3Ϊʱ */
	}
	while (1)
	{
		bsp_Idle();				/* CPUִеĲ  bsp.c  bsp.h ļ */

		if (_usTimeOut > 0)
		{
			if (bsp_CheckTimer(MG323_TMR_ID))
			{
				ret = 0;	/* ʱ */
				break;
			}
		}

		if (comGetChar(COM_MG323, &ucData))
		{
			MG323_PrintRxData(ucData);		/* յݴӡԴ1 */

			if (ucData == '\n')
			{
				if (pos > 0)	/* 2յس */
				{
					if (memcmp(ucRxBuf, _pAckStr,  len) == 0)
					{
						ret = 1;	/* յָӦݣسɹ */
						break;
					}
					else
					{
						pos = 0;
					}
				}
				else
				{
					pos = 0;
				}
			}
			else
			{
				if (pos < sizeof(ucRxBuf))
				{
					/* ֻɼַ */
					if (ucData >= ' ')
					{
						ucRxBuf[pos++] = ucData;
					}
				}
			}
		}
	}
	return ret;
}

/*
*********************************************************************************************************
*	  : MG323_ReadResponse
*	˵: ȡMG323Ӧַúַ䳬ʱжϽ ҪATͺ
*	    : _pBuf : ģ鷵صַ
*			  _usBufSize : 󳤶
*			 _usTimeOut : ִгʱ0ʾһֱȴ. >0 ʾʱʱ䣬λ1ms
*	  ֵ: 0 ʾ󣨳ʱ  > 0 ʾӦݳ
*********************************************************************************************************
*/
uint16_t MG323_ReadResponse(char *_pBuf, uint16_t _usBufSize, uint16_t _usTimeOut)
{
	uint8_t ucData;
	uint16_t pos = 0;
	uint8_t ret;
	uint8_t status = 0;		/* ״̬ */

	/* _usTimeOut == 0 ʾ޵ȴ */
	if (_usTimeOut > 0)
	{
		bsp_StartTimer(MG323_TMR_ID, _usTimeOut);		/* ʹʱΪʱ */
	}
	while (1)
	{
		bsp_Idle();				/* CPUִеĲ  bsp.c  bsp.h ļ */

		if (status == 2)		/* ڽЧӦ׶Σַͨ䳬ʱжݽ */
		{
			if (bsp_CheckTimer(MG323_TMR_ID))
			{
				_pBuf[pos]	 = 0;	/* β0 ںʶַ */
				ret = pos;		/* ɹ ݳ */
				break;
			}
		}
		else
		{
			if (_usTimeOut > 0)
			{
				if (bsp_CheckTimer(MG323_TMR_ID))
				{
					ret = 0;	/* ʱ */
					break;
				}
			}
		}
		
		if (comGetChar(COM_MG323, &ucData))
		{			
			MG323_PrintRxData(ucData);		/* յݴӡԴ1 */

			switch (status)
			{
				case 0:			/* ַ */
					if (ucData == AT_CR)		/* ַǻسʾ AT */
					{
						_pBuf[pos++] = ucData;		/* յ */
						status = 2;	 /* ΪյģӦ */
					}
					else	/* ַ A ʾ AT */
					{
						status = 1;	 /* ͵ATַӦݣֱ CRַ */
					}
					break;
					
				case 1:			/* ATԽ׶, . ȴ */
					if (ucData == AT_CR)
					{
						status = 2;
					}
					break;
					
				case 2:			/* ʼģӦ */
					/* ֻҪյģӦַַ䳬ʱжϽʱܳʱ */
					bsp_StartTimer(MG323_TMR_ID, 5);
					if (pos < _usBufSize - 1)
					{
						_pBuf[pos++] = ucData;		/* յ */
					}
					break;
			}
		}
	}
	return ret;
}

/*
*********************************************************************************************************
*	  : MG323_SendAT
*	˵: GSMģ鷢AT ԶATַ<CR>ַ
*	    : _Str : ATַĩβĻس<CR>. ַ0
*	  ֵ: 
*********************************************************************************************************
*/
void MG323_SendAT(char *_Cmd)
{
	comSendBuf(COM_MG323, (uint8_t *)_Cmd, strlen(_Cmd));
	comSendBuf(COM_MG323, "\r", 1);
}

/*
*********************************************************************************************************
*	  : MG323_SetAutoReport
*	˵: ¼Զϱ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void MG323_SetAutoReport(void)
{
	MG323_SendAT("AT+CIND=1,1,1,1,1,1,1,1,1");
}

/*
*********************************************************************************************************
*	  : MG323_SwitchPath
*	˵: лƵͨ
*	    : ch  0ʾ1·ƵINTMIC, INTEAR)  1ʾ2·ƵEXTMIC,EXTEAR)
*	  ֵ: 
*********************************************************************************************************
*/
void MG323_SwitchPath(uint8_t ch)
{
	if (ch == 0)
	{
		MG323_SendAT("AT^SWSPATH=0");
	}
	else
	{
		MG323_SendAT("AT^SWSPATH=1");
	}
}

/*
*********************************************************************************************************
*	  : MG323_SetEarVolume
*	˵: ö
*	    : _ucVolume :  0 ʾ1-5 ʾС54ȱʡ
*	  ֵ: 
*********************************************************************************************************
*/
void MG323_SetEarVolume(uint8_t _ucVolume)
{
	char CmdBuf[32];

	sprintf(CmdBuf, "AT+CLVL=%d", _ucVolume);
	MG323_SendAT(CmdBuf);
}

/*
*********************************************************************************************************
*	  : MG323_SetMicGain
*	˵: MIC  .    ú·ͨãֻм绰ǰʹá
*	    : _iGain : 档 -12 С1213ʾ
*	  ֵ: 
*********************************************************************************************************
*/
void MG323_SetMicGain(int16_t _iGain)
{
	char CmdBuf[32];

	sprintf(CmdBuf, "AT+CMIC=%d", _iGain);
	MG323_SendAT(CmdBuf);
}


/*
*********************************************************************************************************
*	  : MG323_DialTel
*	˵: 绰
*	    : _pTel 绰ַ
*	  ֵ: 
*********************************************************************************************************
*/
void MG323_DialTel(char *_pTel)
{
	char CmdBuf[64];

	sprintf(CmdBuf, "ATD%s;", _pTel);
	MG323_SendAT(CmdBuf);
}

/*
*********************************************************************************************************
*	  : MG323_Hangup
*	˵: Ҷϵ绰
*	    : _pTel 绰ַ
*	  ֵ: 
*********************************************************************************************************
*/
void MG323_Hangup(void)
{
	MG323_SendAT("ATH");
}

/*
*********************************************************************************************************
*	  : MG323_GetHardInfo
*	˵: ȡģӲϢ.  ATI Ӧ
*	    : ŽĽṹָ
*	  ֵ: 1 ʾɹ 0 ʾʧ
*********************************************************************************************************
*/
uint8_t MG323_GetHardInfo(MG_HARD_INFO_T *_pInfo)
{
	/*
		ATI
		Manufacture: HUAWEI
		Model: MG323
		Revision: 12.210.10.05.00
		IMEI: 351869045435933
		+GCAP: +CGSM
		
		OK	
	*/	
	char buf[255];
	uint16_t len, i, begin, num;
	uint8_t status = 0;	
	
	comClearRxFifo(COM_MG323);	/* 㴮ڽջ */	
	
	MG323_SendAT("ATI");		/*  ATI  */
	
	len = MG323_ReadResponse(buf, sizeof(buf), 300);	/* ʱ 300ms */
	if (len == 0)
	{
		return 0;		
	}
	
	_pInfo->Manfacture[0] = 0;
	_pInfo->Model[0] = 0;
	_pInfo->Revision[0] = 0;
	_pInfo->IMEI[0] = 0;
	
	for (i = 2; i < len; i++)
	{
		if (buf[i] == ':')
		{
			i += 2;
			begin = i;
		}
		if (buf[i] == AT_CR)
		{
			num = i - begin;
			
			if (status == 0)
			{
				if (num >= sizeof(_pInfo->Manfacture))
				{
					num = sizeof(_pInfo->Manfacture) - 1;
				}
				memcpy(_pInfo->Manfacture, &buf[begin], num);
				_pInfo->Manfacture[num] = 0;
			}
			else if (status == 1)
			{
				if (num >= sizeof(_pInfo->Model))
				{
					num = sizeof(_pInfo->Model) - 1;
				}				
				memcpy(_pInfo->Model, &buf[begin], num);
				_pInfo->Model[num] = 0;
			}
			else if (status == 2)
			{
				if (num >= sizeof(_pInfo->Revision))
				{
					num = sizeof(_pInfo->Revision) - 1;
				}				
				memcpy(_pInfo->Revision, &buf[begin], num);
				_pInfo->Revision[num] = 0;
			}
			else if (status == 3)
			{
				if (num >= sizeof(_pInfo->IMEI))
				{
					num = sizeof(_pInfo->IMEI) - 1;
				}					
				memcpy(_pInfo->IMEI, &buf[begin], num);
				_pInfo->IMEI[num] = 0;
				break;
			}
			status++;	
		}
	}
	return 1;
}

/*
*********************************************************************************************************
*	  : MG323_GetNetStatus
*	˵: ѯǰ״̬
*	    : 
*	  ֵ: ״̬, CREG_NO_REG, CREG_LOCAL_OK ȡ
*********************************************************************************************************
*/
uint8_t MG323_GetNetStatus(void)
{
	/*
		AT+CREG?
		+CREG: 0,1
		
		OK				
	*/	
	char buf[128];
	uint16_t len, i;
	uint8_t status;
	
	comClearRxFifo(COM_MG323);	/* 㴮ڽջ */	
	
	MG323_SendAT("AT+CREG?");	/*  AT  */
	
	len = MG323_ReadResponse(buf, sizeof(buf), 200);	/* ʱ 200ms */
	if (len == 0)
	{
		return 0;		
	}
	
	for (i = 2; i < len; i++)
	{
		if (buf[i] == ',')
		{
			i++;
			
			status = buf[i] - '0';
		}
	}
	return status;
}


/*****************************  www.armfly.com (END OF FILE) *********************************/
