/*
*********************************************************************************************************
*
*	ģ : SPIӿڴFLASH дģ
*	ļ : bsp_spi_flash.c
*	     : V1.0
*	˵     : ֧ SST25VF016BMX25L1606E  W25Q64BVSSIG
*			   SST25VF016B дAAIָдЧʡ
*
*			   ȱʡʹSTM32F4ӲSPI1ӿڣʱƵΪ 42MHz Ƶʹã
*
*	޸ļ¼ :
*		汾               ˵
*		V1.0    2013-02-01 armfly  ʽ
*
*	Copyright (C), 2013-2014,  www.armfly.com
*
*********************************************************************************************************
*/

#include "bsp.h"

/*
	STM32F4XX ʱӼ.
		HCLK = 168M
		PCLK1 = HCLK / 4 = 42M
		PCLK2 = HCLK / 2 = 84M

		SPI2SPI3  PCLK1, ʱ42M
		SPI1        PCLK2, ʱ84M

		STM32F4 ֵ֧SPIʱΪ 37.5 Mbits/S, ҪƵ
*/

#ifdef STM32_X3		/*  STM32-X3  */
	/*
		STM32-X3 ߷䣺 FlashͺΪ W25Q64BVSSIG (80MHz)
		PB12 = CS
		PB13 = SCK
		PB14 = MISO
		PB15 = MOSI

		STM32ӲSPIӿ = SPI2
	*/
	#define SPI_FLASH			SPI2

	#define ENABLE_SPI_RCC() 	RCC_APB2PeriphClockCmd(RCC_APB2Periph_SPI2, ENABLE)

	#define SPI_BAUD			SPI_BaudRatePrescaler_1		/* ѡ2Ƶʱ, SCKʱ = 21M */

	/* Ƭѡõѡ  */
	#define SF_CS_LOW()			GPIOB->BSRRH = GPIO_Pin_12

	/* Ƭѡø߲ѡ */
	#define SF_CS_HIGH()		GPIOB->BSRRL = GPIO_Pin_12
#else
	/*
		STM32-V5 ߷䣺  FlashͺΪ W25Q64BVSSIG (80MHz)
		PB3/SPI3_SCK/SPI1_SCK
		PB4/SPI3_MISO/SPI1_MISO
		PB5/SPI3_MOSI/SPI1_MOSI
		PF8/SF_CS

		STM32ӲSPIӿ = SPI3  SPI1

		SPI1ʱԴ84M, SPI3ʱԴ42MΪ˻øٶȣѡSPI1
	*/
	//#define SPI_FLASH			SPI3
	#define SPI_FLASH			SPI1

	//#define ENABLE_SPI_RCC() 	RCC_APB1PeriphClockCmd(RCC_APB1Periph_SPI3, ENABLE)
	#define ENABLE_SPI_RCC() 	RCC_APB2PeriphClockCmd(RCC_APB2Periph_SPI1, ENABLE)

	/*
		SPIʱ2Ƶֲ֧Ƶ
		SPI12ƵʱSCKʱ = 42M4ƵʱSCKʱ = 21M
		SPI3, 2ƵʱSCKʱ = 21M
	*/
	#define SPI_BAUD			SPI_BaudRatePrescaler_4

	/* ƬѡGPIO˿  */
	#define SF_CS_GPIO			GPIOF
	#define SF_CS_PIN			GPIO_Pin_8
#endif

/* Ƭѡõѡ  */
#define SF_CS_LOW()       SF_CS_GPIO->BSRRH = SF_CS_PIN

/* Ƭѡø߲ѡ */
#define SF_CS_HIGH()      SF_CS_GPIO->BSRRL = SF_CS_PIN

#define CMD_AAI       0xAD  	/* AAI ָ(FOR SST25VF016B) */
#define CMD_DISWR	  0x04		/* ֹд, ˳AAI״̬ */
#define CMD_EWRSR	  0x50		/* д״̬Ĵ */
#define CMD_WRSR      0x01  	/* д״̬Ĵ */
#define CMD_WREN      0x06		/* дʹ */
#define CMD_READ      0x03  	/*  */
#define CMD_RDSR      0x05		/* ״̬Ĵ */
#define CMD_RDID      0x9F		/* ID */
#define CMD_SE        0x20		/*  */
#define CMD_BE        0xC7		/*  */
#define DUMMY_BYTE    0xA5		/* Ϊֵڶ */

#define WIP_FLAG      0x01		/* ״̬Ĵеڱ̱־WIP) */

SFLASH_T g_tSF;

void sf_ReadInfo(void);
static uint8_t sf_SendByte(uint8_t _ucValue);
static void sf_WriteEnable(void);
static void sf_WriteStatus(uint8_t _ucValue);
static void sf_WaitForWriteEnd(void);
static uint8_t sf_NeedErase(uint8_t * _ucpOldBuf, uint8_t *_ucpNewBuf, uint16_t _uiLen);
static uint8_t sf_CmpData(uint32_t _uiSrcAddr, uint8_t *_ucpTar, uint32_t _uiSize);
static uint8_t sf_AutoWritePage(uint8_t *_ucpSrc, uint32_t _uiWrAddr, uint16_t _usWrLen);

static void bsp_CfgSPIForSFlash(void);

static uint8_t s_spiBuf[4*1024];	/* дȶpage޸Ļpageд */

/*
*********************************************************************************************************
*	  : bsp_InitSpiFlash
*	˵: ʼFlashӲӿڣSTM32SPIʱӡGPIO)
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void bsp_InitSFlash(void)
{

#ifdef STM32_X3		/*  STM32-X3  */
	/*
		STM32-X4 ߷䣺 FlashͺΪ W25Q64BVSSIG (80MHz)
		PB12 = CS
		PB13 = SCK
		PB14 = MISO
		PB15 = MOSI

		STM32ӲSPIӿ = SPI2
	*/
	{
		GPIO_InitTypeDef GPIO_InitStructure;

		/* ʹGPIO ʱ */
		RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOB, ENABLE);

		/*  SCK, MISO  MOSI Ϊù */
		GPIO_PinAFConfig(GPIOB, GPIO_PinSource13, GPIO_AF_SPI2);
		GPIO_PinAFConfig(GPIOB, GPIO_PinSource14, GPIO_AF_SPI2);
		GPIO_PinAFConfig(GPIOB, GPIO_PinSource15, GPIO_AF_SPI2);

		GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
		GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
		GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
		GPIO_InitStructure.GPIO_PuPd  = GPIO_PuPd_DOWN;

		GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12 | GPIO_Pin_13 | GPIO_Pin_14;
		GPIO_Init(GPIOB, &GPIO_InitStructure);

		/* ƬѡΪģʽ */
		SF_CS_HIGH();		/* Ƭѡøߣѡ */
		GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
		GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
		GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
		GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
		GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12;
		GPIO_Init(GPIOB, &GPIO_InitStructure);
	}
#else
	/*
		STM32-V5 ߷䣺  FlashͺΪ W25Q64BVSSIG (80MHz)
		PB3/SPI3_SCK
		PB4/SPI3_MISO
		PB5/SPI3_MOSI
		PF8/SF_CS

		STM32ӲSPIӿ = SPI3
	*/
	{
		GPIO_InitTypeDef GPIO_InitStructure;

		/* ʹGPIO ʱ */
		RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOB | RCC_AHB1Periph_GPIOF, ENABLE);

		/*  SCK, MISO  MOSI Ϊù */
		//GPIO_PinAFConfig(GPIOB, GPIO_PinSource3, GPIO_AF_SPI3);
		//GPIO_PinAFConfig(GPIOB, GPIO_PinSource4, GPIO_AF_SPI3);
		//GPIO_PinAFConfig(GPIOB, GPIO_PinSource5, GPIO_AF_SPI3);
		/*  SCK, MISO  MOSI Ϊù */
		GPIO_PinAFConfig(GPIOB, GPIO_PinSource3, GPIO_AF_SPI1);
		GPIO_PinAFConfig(GPIOB, GPIO_PinSource4, GPIO_AF_SPI1);
		GPIO_PinAFConfig(GPIOB, GPIO_PinSource5, GPIO_AF_SPI1);

		GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
		GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
		GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
		GPIO_InitStructure.GPIO_PuPd  = GPIO_PuPd_DOWN;

		GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3 | GPIO_Pin_4 | GPIO_Pin_5;
		GPIO_Init(GPIOB, &GPIO_InitStructure);

		/* ƬѡΪģʽ */
		SF_CS_HIGH();		/* Ƭѡøߣѡ */
		GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
		GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
		GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
		GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
		GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8;
		GPIO_Init(GPIOF, &GPIO_InitStructure);
	}
#endif

	/* SPIӲڷʴFlash */
	bsp_CfgSPIForSFlash();

	sf_ReadInfo();				/* ԶʶоƬͺ */

	SF_CS_LOW();				/* ʽʹܴFlashƬѡ */
	sf_SendByte(CMD_DISWR);		/* ͽֹд,ʹд */
	SF_CS_HIGH();				/* ʽܴFlashƬѡ */

	sf_WaitForWriteEnd();		/* ȴFlashڲ */

	sf_WriteStatus(0);			/* BLOCKд */
}

/*
*********************************************************************************************************
*	  : bsp_CfgSPIForSFlash
*	˵: STM32ڲSPIӲĹģʽٶȵȲڷSPIӿڵĴFlash
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
static void bsp_CfgSPIForSFlash(void)
{
	SPI_InitTypeDef  SPI_InitStructure;

	/* SPIʱ */
	ENABLE_SPI_RCC();

	/* SPIӲ */
	SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;	/* ݷ2ȫ˫ */
	SPI_InitStructure.SPI_Mode = SPI_Mode_Master;		/* STM32SPIģʽ ģʽ */
	SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;	/* λ  8λ */
	/* SPI_CPOLSPI_CPHAʹþʱӺݲλϵ
	   : ߿Ǹߵƽ,2أز)
	*/
	SPI_InitStructure.SPI_CPOL = SPI_CPOL_High;			/* ʱز */
	SPI_InitStructure.SPI_CPHA = SPI_CPHA_2Edge;		/* ʱӵĵ2ز */
	SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;			/* ƬѡƷʽ */

	/* òԤƵϵ */
	SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BAUD;

	SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;	/* λ򣺸λȴ */
	SPI_InitStructure.SPI_CRCPolynomial = 7;			/* CRCʽĴλΪ7̲ */
	SPI_Init(SPI_FLASH, &SPI_InitStructure);

	SPI_Cmd(SPI_FLASH, DISABLE);			/* ȽֹSPI  */

	SPI_Cmd(SPI_FLASH, ENABLE);				/* ʹSPI  */
}

/*
*********************************************************************************************************
*	  : sf_EraseSector
*	˵: ָ
*	    :  _uiSectorAddr : ַ
*	  ֵ: 
*********************************************************************************************************
*/
void sf_EraseSector(uint32_t _uiSectorAddr)
{
	sf_WriteEnable();								/* дʹ */

	/*  */
	SF_CS_LOW();									/* ʹƬѡ */
	sf_SendByte(CMD_SE);								/* Ͳ */
	sf_SendByte((_uiSectorAddr & 0xFF0000) >> 16);	/* ַĸ8bit */
	sf_SendByte((_uiSectorAddr & 0xFF00) >> 8);		/* ַм8bit */
	sf_SendByte(_uiSectorAddr & 0xFF);				/* ַ8bit */
	SF_CS_HIGH();									/* Ƭѡ */

	sf_WaitForWriteEnd();							/* ȴFlashڲд */
}

/*
*********************************************************************************************************
*	  : sf_EraseChip
*	˵: оƬ
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void sf_EraseChip(void)
{
	sf_WriteEnable();								/* дʹ */

	/*  */
	SF_CS_LOW();									/* ʹƬѡ */
	sf_SendByte(CMD_BE);							/* Ƭ */
	SF_CS_HIGH();									/* Ƭѡ */

	sf_WaitForWriteEnd();							/* ȴFlashڲд */
}

/*
*********************************************************************************************************
*	  : sf_PageWrite
*	˵: һpageдֽڡֽڸܳҳС4K)
*	    :  	_pBuf : Դ
*				_uiWriteAddr Ŀ׵ַ
*				_usSize ݸܳҳС
*	  ֵ: 
*********************************************************************************************************
*/
void sf_PageWrite(uint8_t * _pBuf, uint32_t _uiWriteAddr, uint16_t _usSize)
{
	uint32_t i, j;

	if (g_tSF.ChipID == SST25VF016B_ID)
	{
		/* AAIָҪݸż */
		if ((_usSize < 2) && (_usSize % 2))
		{
			return ;
		}

		sf_WriteEnable();								/* дʹ */

		SF_CS_LOW();									/* ʹƬѡ */
		sf_SendByte(CMD_AAI);							/* AAI(ַԶӱ) */
		sf_SendByte((_uiWriteAddr & 0xFF0000) >> 16);	/* ַĸ8bit */
		sf_SendByte((_uiWriteAddr & 0xFF00) >> 8);		/* ַм8bit */
		sf_SendByte(_uiWriteAddr & 0xFF);				/* ַ8bit */
		sf_SendByte(*_pBuf++);							/* ͵1 */
		sf_SendByte(*_pBuf++);							/* ͵2 */
		SF_CS_HIGH();									/* Ƭѡ */

		sf_WaitForWriteEnd();							/* ȴFlashڲд */

		_usSize -= 2;									/* ʣֽ */

		for (i = 0; i < _usSize / 2; i++)
		{
			SF_CS_LOW();								/* ʹƬѡ */
			sf_SendByte(CMD_AAI);						/* AAI(ַԶӱ) */
			sf_SendByte(*_pBuf++);						/*  */
			sf_SendByte(*_pBuf++);						/*  */
			SF_CS_HIGH();								/* Ƭѡ */
			sf_WaitForWriteEnd();						/* ȴFlashڲд */
		}

		/* д״̬ */
		SF_CS_LOW();
		sf_SendByte(CMD_DISWR);
		SF_CS_HIGH();

		sf_WaitForWriteEnd();							/* ȴFlashڲд */
	}
	else	/* for MX25L1606E  W25Q64BV */
	{
		for (j = 0; j < _usSize / 256; j++)
		{
			sf_WriteEnable();								/* дʹ */

			SF_CS_LOW();									/* ʹƬѡ */
			sf_SendByte(0x02);								/* AAI(ַԶӱ) */
			sf_SendByte((_uiWriteAddr & 0xFF0000) >> 16);	/* ַĸ8bit */
			sf_SendByte((_uiWriteAddr & 0xFF00) >> 8);		/* ַм8bit */
			sf_SendByte(_uiWriteAddr & 0xFF);				/* ַ8bit */

			for (i = 0; i < 256; i++)
			{
				sf_SendByte(*_pBuf++);					/*  */
			}

			SF_CS_HIGH();								/* ֹƬѡ */

			sf_WaitForWriteEnd();						/* ȴFlashڲд */

			_uiWriteAddr += 256;
		}

		/* д״̬ */
		SF_CS_LOW();
		sf_SendByte(CMD_DISWR);
		SF_CS_HIGH();

		sf_WaitForWriteEnd();							/* ȴFlashڲд */
	}
}

/*
*********************************************************************************************************
*	  : sf_ReadBuffer
*	˵: ȡֽڡֽڸܳоƬ
*	    :  	_pBuf : Դ
*				_uiReadAddr ׵ַ
*				_usSize ݸ, ԴPAGE_SIZE,ǲܳоƬ
*	  ֵ: 
*********************************************************************************************************
*/
void sf_ReadBuffer(uint8_t * _pBuf, uint32_t _uiReadAddr, uint32_t _uiSize)
{
	/* ȡݳΪ0߳Flashַռ䣬ֱӷ */
	if ((_uiSize == 0) ||(_uiReadAddr + _uiSize) > g_tSF.TotalSize)
	{
		return;
	}

	/*  */
	SF_CS_LOW();									/* ʹƬѡ */
	sf_SendByte(CMD_READ);							/* Ͷ */
	sf_SendByte((_uiReadAddr & 0xFF0000) >> 16);	/* ַĸ8bit */
	sf_SendByte((_uiReadAddr & 0xFF00) >> 8);		/* ַм8bit */
	sf_SendByte(_uiReadAddr & 0xFF);				/* ַ8bit */
	while (_uiSize--)
	{
		*_pBuf++ = sf_SendByte(DUMMY_BYTE);			/* һֽڲ洢pBufָԼ1 */
	}
	SF_CS_HIGH();									/* Ƭѡ */
}

/*
*********************************************************************************************************
*	  : sf_CmpData
*	˵: ȽFlash.
*	    :  	_ucpTar : ݻ
*				_uiSrcAddr Flashַ
*				_uiSize ݸ, ԴPAGE_SIZE,ǲܳоƬ
*	  ֵ: 0 = , 1 = 
*********************************************************************************************************
*/
static uint8_t sf_CmpData(uint32_t _uiSrcAddr, uint8_t *_ucpTar, uint32_t _uiSize)
{
	uint8_t ucValue;

	/* ȡݳΪ0߳Flashַռ䣬ֱӷ */
	if ((_uiSrcAddr + _uiSize) > g_tSF.TotalSize)
	{
		return 1;
	}

	if (_uiSize == 0)
	{
		return 0;
	}

	SF_CS_LOW();									/* ʹƬѡ */
	sf_SendByte(CMD_READ);							/* Ͷ */
	sf_SendByte((_uiSrcAddr & 0xFF0000) >> 16);		/* ַĸ8bit */
	sf_SendByte((_uiSrcAddr & 0xFF00) >> 8);		/* ַм8bit */
	sf_SendByte(_uiSrcAddr & 0xFF);					/* ַ8bit */
	while (_uiSize--)
	{
		/* һֽ */
		ucValue = sf_SendByte(DUMMY_BYTE);
		if (*_ucpTar++ != ucValue)
		{
			SF_CS_HIGH();
			return 1;
		}
	}
	SF_CS_HIGH();
	return 0;
}

/*
*********************************************************************************************************
*	  : sf_NeedErase
*	˵: ждPAGEǰǷҪȲ
*	    :   _ucpOldBuf  
*			   _ucpNewBuf  
*			   _uiLen ݸܳҳС
*	  ֵ: 0 : Ҫ 1 Ҫ
*********************************************************************************************************
*/
static uint8_t sf_NeedErase(uint8_t * _ucpOldBuf, uint8_t *_ucpNewBuf, uint16_t _usLen)
{
	uint16_t i;
	uint8_t ucOld;

	/*
	㷨1old , new 
	      old    new
		  1101   0101
	~     1111
		= 0010   0101

	㷨2: old 󷴵Ľ new λ
		  0010   old
	&	  0101   new
		 =0000

	㷨3: Ϊ0,ʾ. ʾҪ
	*/

	for (i = 0; i < _usLen; i++)
	{
		ucOld = *_ucpOldBuf++;
		ucOld = ~ucOld;

		/* עд: if (ucOld & (*_ucpNewBuf++) != 0) */
		if ((ucOld & (*_ucpNewBuf++)) != 0)
		{
			return 1;
		}
	}
	return 0;
}

/*
*********************************************************************************************************
*	  : sf_AutoWritePage
*	˵: д1PAGEУ,ȷдΡԶɲ
*	    :  	_pBuf : Դ
*				_uiWriteAddr Ŀ׵ַ
*				_usSize ݸܳҳС
*	  ֵ: 0 :  1  ɹ
*********************************************************************************************************
*/
static uint8_t sf_AutoWritePage(uint8_t *_ucpSrc, uint32_t _uiWrAddr, uint16_t _usWrLen)
{
	uint16_t i;
	uint16_t j;					/* ʱ */
	uint32_t uiFirstAddr;		/* ַ */
	uint8_t ucNeedErase;		/* 1ʾҪ */
	uint8_t cRet;

	/* Ϊ0ʱ,ֱΪɹ */
	if (_usWrLen == 0)
	{
		return 1;
	}

	/* ƫƵַоƬ˳ */
	if (_uiWrAddr >= g_tSF.TotalSize)
	{
		return 0;
	}

	/* ݳȴ˳ */
	if (_usWrLen > g_tSF.PageSize)
	{
		return 0;
	}

	/* FLASHеûб仯,дFLASH */
	sf_ReadBuffer(s_spiBuf, _uiWrAddr, _usWrLen);
	if (memcmp(s_spiBuf, _ucpSrc, _usWrLen) == 0)
	{
		return 1;
	}

	/* жǷҪȲ */
	/* ޸Ϊݣλ 1->0  0->0, ,Flash */
	ucNeedErase = 0;
	if (sf_NeedErase(s_spiBuf, _ucpSrc, _usWrLen))
	{
		ucNeedErase = 1;
	}

	uiFirstAddr = _uiWrAddr & (~(g_tSF.PageSize - 1));

	if (_usWrLen == g_tSF.PageSize)		/* д */
	{
		for	(i = 0; i < g_tSF.PageSize; i++)
		{
			s_spiBuf[i] = _ucpSrc[i];
		}
	}
	else						/* д */
	{
		/* Ƚݶ */
		sf_ReadBuffer(s_spiBuf, uiFirstAddr, g_tSF.PageSize);

		/* ݸ */
		i = _uiWrAddr & (g_tSF.PageSize - 1);
		memcpy(&s_spiBuf[i], _ucpSrc, _usWrLen);
	}

	/* д֮У飬ȷд3 */
	cRet = 0;
	for (i = 0; i < 3; i++)
	{

		/* ޸Ϊݣλ 1->0  0->0, ,Flash */
		if (ucNeedErase == 1)
		{
			sf_EraseSector(uiFirstAddr);		/* 1 */
		}

		/* һPAGE */
		sf_PageWrite(s_spiBuf, uiFirstAddr, g_tSF.PageSize);

		if (sf_CmpData(_uiWrAddr, _ucpSrc, _usWrLen) == 0)
		{
			cRet = 1;
			break;
		}
		else
		{
			if (sf_CmpData(_uiWrAddr, _ucpSrc, _usWrLen) == 0)
			{
				cRet = 1;
				break;
			}

			/* ʧܺӳһʱ */
			for (j = 0; j < 10000; j++);
		}
	}

	return cRet;
}

/*
*********************************************************************************************************
*	  : sf_WriteBuffer
*	˵: д1У,ȷдΡԶɲ
*	    :  	_pBuf : Դ
*				_uiWrAddr Ŀ׵ַ
*				_usSize ݸܳҳС
*	  ֵ: 1 : ɹ 0  ʧ
*********************************************************************************************************
*/
uint8_t sf_WriteBuffer(uint8_t* _pBuf, uint32_t _uiWriteAddr, uint16_t _usWriteSize)
{
	uint16_t NumOfPage = 0, NumOfSingle = 0, Addr = 0, count = 0, temp = 0;

	Addr = _uiWriteAddr % g_tSF.PageSize;
	count = g_tSF.PageSize - Addr;
	NumOfPage =  _usWriteSize / g_tSF.PageSize;
	NumOfSingle = _usWriteSize % g_tSF.PageSize;

	if (Addr == 0) /* ʼַҳ׵ַ  */
	{
		if (NumOfPage == 0) /* ݳСҳС */
		{
			if (sf_AutoWritePage(_pBuf, _uiWriteAddr, _usWriteSize) == 0)
			{
				return 0;
			}
		}
		else 	/* ݳȴڵҳС */
		{
			while (NumOfPage--)
			{
				if (sf_AutoWritePage(_pBuf, _uiWriteAddr, g_tSF.PageSize) == 0)
				{
					return 0;
				}
				_uiWriteAddr +=  g_tSF.PageSize;
				_pBuf += g_tSF.PageSize;
			}
			if (sf_AutoWritePage(_pBuf, _uiWriteAddr, NumOfSingle) == 0)
			{
				return 0;
			}
		}
	}
	else  /* ʼַҳ׵ַ  */
	{
		if (NumOfPage == 0) /* ݳСҳС */
		{
			if (NumOfSingle > count) /* (_usWriteSize + _uiWriteAddr) > SPI_FLASH_PAGESIZE */
			{
				temp = NumOfSingle - count;

				if (sf_AutoWritePage(_pBuf, _uiWriteAddr, count) == 0)
				{
					return 0;
				}

				_uiWriteAddr +=  count;
				_pBuf += count;

				if (sf_AutoWritePage(_pBuf, _uiWriteAddr, temp) == 0)
				{
					return 0;
				}
			}
			else
			{
				if (sf_AutoWritePage(_pBuf, _uiWriteAddr, _usWriteSize) == 0)
				{
					return 0;
				}
			}
		}
		else	/* ݳȴڵҳС */
		{
			_usWriteSize -= count;
			NumOfPage =  _usWriteSize / g_tSF.PageSize;
			NumOfSingle = _usWriteSize % g_tSF.PageSize;

			if (sf_AutoWritePage(_pBuf, _uiWriteAddr, count) == 0)
			{
				return 0;
			}

			_uiWriteAddr +=  count;
			_pBuf += count;

			while (NumOfPage--)
			{
				if (sf_AutoWritePage(_pBuf, _uiWriteAddr, g_tSF.PageSize) == 0)
				{
					return 0;
				}
				_uiWriteAddr +=  g_tSF.PageSize;
				_pBuf += g_tSF.PageSize;
			}

			if (NumOfSingle != 0)
			{
				if (sf_AutoWritePage(_pBuf, _uiWriteAddr, NumOfSingle) == 0)
				{
					return 0;
				}
			}
		}
	}
	return 1;	/* ɹ */
}

/*
*********************************************************************************************************
*	  : sf_ReadID
*	˵: ȡID
*	    :  
*	  ֵ: 32bitID (8bit0ЧIDλΪ24bit
*********************************************************************************************************
*/
uint32_t sf_ReadID(void)
{
	uint32_t uiID;
	uint8_t id1, id2, id3;

	SF_CS_LOW();									/* ʹƬѡ */
	sf_SendByte(CMD_RDID);								/* ͶID */
	id1 = sf_SendByte(DUMMY_BYTE);					/* IDĵ1ֽ */
	id2 = sf_SendByte(DUMMY_BYTE);					/* IDĵ2ֽ */
	id3 = sf_SendByte(DUMMY_BYTE);					/* IDĵ3ֽ */
	SF_CS_HIGH();									/* Ƭѡ */

	uiID = ((uint32_t)id1 << 16) | ((uint32_t)id2 << 8) | id3;

	return uiID;
}

/*
*********************************************************************************************************
*	  : sf_ReadInfo
*	˵: ȡID,
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void sf_ReadInfo(void)
{
	/* ԶʶFlashͺ */
	{
		g_tSF.ChipID = sf_ReadID();	/* оƬID */

		switch (g_tSF.ChipID)
		{
			case SST25VF016B_ID:
				strcpy(g_tSF.ChipName, "SST25VF016B");
				g_tSF.TotalSize = 2 * 1024 * 1024;	/*  = 2M */
				g_tSF.PageSize = 4 * 1024;			/* ҳС = 4K */
				break;

			case MX25L1606E_ID:
				strcpy(g_tSF.ChipName, "MX25L1606E");
				g_tSF.TotalSize = 2 * 1024 * 1024;	/*  = 2M */
				g_tSF.PageSize = 4 * 1024;			/* ҳС = 4K */
				break;

			case W25Q64BV_ID:
				strcpy(g_tSF.ChipName, "W25Q64BV");
				g_tSF.TotalSize = 8 * 1024 * 1024;	/*  = 8M */
				g_tSF.PageSize = 4 * 1024;			/* ҳС = 4K */
				break;

			default:
				strcpy(g_tSF.ChipName, "Unknow Flash");
				g_tSF.TotalSize = 2 * 1024 * 1024;
				g_tSF.PageSize = 4 * 1024;
				break;
		}
	}
}

/*
*********************************************************************************************************
*	  : sf_SendByte
*	˵: һֽڣͬʱMISO߲ص
*	    :  _ucByte : ͵ֵֽ
*	  ֵ: MISO߲ص
*********************************************************************************************************
*/
static uint8_t sf_SendByte(uint8_t _ucValue)
{
	/* ȴϸδ */
	while (SPI_I2S_GetFlagStatus(SPI_FLASH, SPI_I2S_FLAG_TXE) == RESET);

	/* ͨSPIӲ1ֽ */
	SPI_I2S_SendData(SPI_FLASH, _ucValue);

	/* ȴһֽ */
	while (SPI_I2S_GetFlagStatus(SPI_FLASH, SPI_I2S_FLAG_RXNE) == RESET);

	/* شSPI߶ */
	return SPI_I2S_ReceiveData(SPI_FLASH);
}

/*
*********************************************************************************************************
*	  : sf_WriteEnable
*	˵: дʹ
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
static void sf_WriteEnable(void)
{
	SF_CS_LOW();									/* ʹƬѡ */
	sf_SendByte(CMD_WREN);								/*  */
	SF_CS_HIGH();									/* Ƭѡ */
}

/*
*********************************************************************************************************
*	  : sf_WriteStatus
*	˵: д״̬Ĵ
*	    :  _ucValue : ״̬Ĵֵ
*	  ֵ: 
*********************************************************************************************************
*/
static void sf_WriteStatus(uint8_t _ucValue)
{

	if (g_tSF.ChipID == SST25VF016B_ID)
	{
		/* 1ʹд״̬Ĵ */
		SF_CS_LOW();									/* ʹƬѡ */
		sf_SendByte(CMD_EWRSR);							/*  д״̬Ĵ */
		SF_CS_HIGH();									/* Ƭѡ */

		/* 2д״̬Ĵ */
		SF_CS_LOW();									/* ʹƬѡ */
		sf_SendByte(CMD_WRSR);							/*  д״̬Ĵ */
		sf_SendByte(_ucValue);							/* ݣ״̬Ĵֵ */
		SF_CS_HIGH();									/* Ƭѡ */
	}
	else
	{
		SF_CS_LOW();									/* ʹƬѡ */
		sf_SendByte(CMD_WRSR);							/*  д״̬Ĵ */
		sf_SendByte(_ucValue);							/* ݣ״̬Ĵֵ */
		SF_CS_HIGH();									/* Ƭѡ */
	}
}

/*
*********************************************************************************************************
*	  : sf_WaitForWriteEnd
*	˵: ѭѯķʽȴڲд
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
static void sf_WaitForWriteEnd(void)
{
	SF_CS_LOW();									/* ʹƬѡ */
	sf_SendByte(CMD_RDSR);							/*  ״̬Ĵ */
	while((sf_SendByte(DUMMY_BYTE) & WIP_FLAG) == SET);	/* ж״̬Ĵæ־λ */
	SF_CS_HIGH();									/* Ƭѡ */
}

/*****************************  www.armfly.com (END OF FILE) *********************************/
