/*
*********************************************************************************************************
*
*	ģ : TM7705 ģ(2ͨPGA16λADC)
*	ļ : bsp_tm7705.c
*	     : V1.0
*	˵     : TM7705ģCPU֮SPIӿڡ֧ӲSPIӿںSPIӿڡ
*			  ͨл
*
*	޸ļ¼ :
*		汾               ˵
*		V1.0    2013-10-20  armfly  ʽ
*
*	Copyright (C), 2013-2014,  www.armfly.com
*
*********************************************************************************************************
*/

#include "bsp.h"

#define SOFT_SPI		/* бʾʹGPIOģSPIӿ */
//#define HARD_SPI		/* бʾʹCPUӲSPIӿ */

/* ͨ1ͨ2,뻺壬 */
#define __CH1_GAIN_BIPOLAR_BUF	(GAIN_1 | UNIPOLAR | BUF_EN)
#define __CH2_GAIN_BIPOLAR_BUF	(GAIN_1 | UNIPOLAR | BUF_EN)

/*
	TM7705ģֱӲ嵽STM32-V5nRF24L01ģĸӿϡ

    TM7705ģ   STM32F407
      SCK   ------  PB3/SPI3_SCK
      DOUT  ------  PB4/SPI3_MISO
      DIN   ------  PB5/SPI3_MOSI
      CS    ------  PF7/NRF24L01_CSN
      DRDY  ------  PH7/NRF24L01_IRQ
      RST   ------  PA4/NRF905_TX_EN/NRF24L01_CE/DAC1_OUT	(λ RESET)
*/

#if !defined(SOFT_SPI) && !defined(HARD_SPI)
 	#error "Please define SPI Interface mode : SOFT_SPI or HARD_SPI"
#endif

#ifdef SOFT_SPI		/* SPI */
	/* GPIO˿ */
	#define RCC_SCK 	RCC_AHB1Periph_GPIOB
	#define PORT_SCK	GPIOB
	#define PIN_SCK		GPIO_Pin_3

	#define RCC_DIN 	RCC_AHB1Periph_GPIOB
	#define PORT_DIN	GPIOB
	#define PIN_DIN		GPIO_Pin_5

	#define RCC_DOUT 	RCC_AHB1Periph_GPIOB
	#define PORT_DOUT	GPIOB
	#define PIN_DOUT	GPIO_Pin_4

	#define RCC_CS 		RCC_AHB1Periph_GPIOF
	#define PORT_CS		GPIOF
	#define PIN_CS		GPIO_Pin_7

	#define RCC_DRDY 	RCC_AHB1Periph_GPIOH
	#define PORT_DRDY	GPIOH
	#define PIN_DRDY	GPIO_Pin_7

	#define RCC_RESET 	RCC_AHB1Periph_GPIOA
	#define PORT_RESET	GPIOA
	#define PIN_RESET	GPIO_Pin_4

	/* 01ĺ */
	#define RESET_0()	GPIO_ResetBits(PORT_RESET, PIN_RESET)
	#define RESET_1()	GPIO_SetBits(PORT_RESET, PIN_RESET)

	#define CS_0()		GPIO_ResetBits(PORT_CS, PIN_CS)
	#define CS_1()		GPIO_SetBits(PORT_CS, PIN_CS)

	#define SCK_0()		GPIO_ResetBits(PORT_SCK, PIN_SCK)
	#define SCK_1()		GPIO_SetBits(PORT_SCK, PIN_SCK)

	#define DI_0()		GPIO_ResetBits(PORT_DIN, PIN_DIN)
	#define DI_1()		GPIO_SetBits(PORT_DIN, PIN_DIN)

	#define DO_IS_HIGH()	(GPIO_ReadInputDataBit(PORT_DOUT, PIN_DOUT) == Bit_SET)

	#define DRDY_IS_LOW()	(GPIO_ReadInputDataBit(PORT_DRDY, PIN_DRDY) == Bit_RESET)
#endif

#ifdef HARD_SPI		/* ӲSPI */
	;
#endif

/* ͨżĴbit */
enum
{
	/* Ĵѡ  RS2 RS1 RS0  */
	REG_COMM	= 0x00,	/* ͨżĴ */
	REG_SETUP	= 0x10,	/* üĴ */
	REG_CLOCK	= 0x20,	/* ʱӼĴ */
	REG_DATA	= 0x30,	/* ݼĴ */
	REG_ZERO_CH1	= 0x60,	/* CH1 ƫƼĴ */
	REG_FULL_CH1	= 0x70,	/* CH1 ̼Ĵ */
	REG_ZERO_CH2	= 0x61,	/* CH2 ƫƼĴ */
	REG_FULL_CH2	= 0x71,	/* CH2 ̼Ĵ */

	/* д */
	WRITE 		= 0x00,	/* д */
	READ 		= 0x08,	/*  */

	/* ͨ */
	CH_1		= 0,	/* AIN1+  AIN1- */
	CH_2		= 1,	/* AIN2+  AIN2- */
	CH_3		= 2,	/* AIN1-  AIN1- */
	CH_4		= 3		/* AIN1-  AIN2- */
};

/* üĴbit */
enum
{
	MD_NORMAL		= (0 << 6),	/* ģʽ */
	MD_CAL_SELF		= (1 << 6),	/* У׼ģʽ */
	MD_CAL_ZERO		= (2 << 6),	/* У׼0̶ģʽ */
	MD_CAL_FULL		= (3 << 6),	/* У׼̶ģʽ */

	GAIN_1			= (0 << 3),	/*  */
	GAIN_2			= (1 << 3),	/*  */
	GAIN_4			= (2 << 3),	/*  */
	GAIN_8			= (3 << 3),	/*  */
	GAIN_16			= (4 << 3),	/*  */
	GAIN_32			= (5 << 3),	/*  */
	GAIN_64			= (6 << 3),	/*  */
	GAIN_128		= (7 << 3),	/*  */

	/* ˫ԻǵԶıκźŵ״ֻ̬ıݵĴתϵУ׼ */
	BIPOLAR			= (0 << 2),	/* ˫ */
	UNIPOLAR		= (1 << 2),	/*  */

	BUF_NO			= (0 << 1),	/* ޻壨ڲ) */
	BUF_EN			= (1 << 1),	/* л (ڲ) */

	FSYNC_0			= 0,
	FSYNC_1			= 1		/*  */
};

/* ʱӼĴbit */
enum
{
	CLKDIS_0	= 0x00,		/* ʱʹ Ӿʱʹܲ񵴣 */
	CLKDIS_1	= 0x10,		/* ʱӽֹ ⲿṩʱʱøλԽֹMCK_OUTʱʡ */

	/*
		2.4576MHzCLKDIV=0 Ϊ 4.9152MHz CLKDIV=1 CLK Ӧ 0
		1MHz CLKDIV=0  2MHz   CLKDIV=1 CLK λӦ  1
	*/
	CLK_4_9152M = 0x08,
	CLK_2_4576M = 0x00,
	CLK_1M 		= 0x04,
	CLK_2M 		= 0x0C,

	FS_50HZ		= 0x00,
	FS_60HZ		= 0x01,
	FS_250HZ	= 0x02,
	FS_500HZ	= 0x04,

	/*
		ʮšӳӦTM7705 ȵķ
			ʹʱΪ 2.4576MHz ʱǿҽ齫ʱӼĴΪ 84H,ʱΪ10Hz,ÿ0.1S һݡ
			ʹʱΪ 1MHz ʱǿҽ齫ʱӼĴΪ80H, ʱΪ4Hz, ÿ0.25S һ
	*/
	ZERO_0		= 0x00,
	ZERO_1		= 0x80
};

static void TM7705_SyncSPI(void);
static void TM7705_Send8Bit(uint8_t _data);
static uint8_t TM7705_Recive8Bit(void);
static void TM7705_WriteByte(uint8_t _data);
static void TM7705_Write3Byte(uint32_t _data);
static uint8_t TM7705_ReadByte(void);
static uint16_t TM7705_Read2Byte(void);
static uint32_t TM7705_Read3Byte(void);
static void TM7705_WaitDRDY(void);
static void TM7705_ResetHard(void);
static void TM7705_Delay(void);

uint8_t g_TM7705_OK = 0;	/* ȫֱ־ʾTM7705оƬǷ  */

/*
*********************************************************************************************************
*	  : uint8_t
*	˵: STM32GPIOSPIӿڣ TM7705
*	    : 
*	  ֵ: 0 ʾʧ; 1 ʾɹ
*********************************************************************************************************
*/
void bsp_InitTM7705(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;

#ifdef SOFT_SPI		/* SPI */
	CS_1();
	SCK_1();
	DI_1();

	/* GPIOʱ */
	RCC_AHB1PeriphClockCmd(RCC_SCK | RCC_DIN | RCC_DOUT | RCC_CS | RCC_DRDY | RCC_RESET, ENABLE);

	/* üIO */
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;		/* Ϊ */
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;		/* Ϊģʽ */
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;	/* 費ʹ */
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;	/* IOٶ */

	GPIO_InitStructure.GPIO_Pin = PIN_SCK;
	GPIO_Init(PORT_SCK, &GPIO_InitStructure);

	GPIO_InitStructure.GPIO_Pin = PIN_DIN;
	GPIO_Init(PORT_DIN, &GPIO_InitStructure);

	GPIO_InitStructure.GPIO_Pin = PIN_CS;
	GPIO_Init(PORT_CS, &GPIO_InitStructure);

	GPIO_InitStructure.GPIO_Pin = PIN_RESET;
	GPIO_Init(PORT_RESET, &GPIO_InitStructure);

	/* GPIOΪģʽ(ʵCPUλ״̬) */
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;		/* Ϊ */
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;		/* Ϊģʽ */
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;	/*  */
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;	/* IOٶ */

	GPIO_InitStructure.GPIO_Pin = PIN_DOUT;
	GPIO_Init(PORT_DOUT, &GPIO_InitStructure);

	GPIO_InitStructure.GPIO_Pin = PIN_DRDY;
	GPIO_Init(PORT_DRDY, &GPIO_InitStructure);

#endif

	bsp_DelayMS(10);

	TM7705_ResetHard();		/* Ӳλ */

	/*
		ڽӿжʧ£DIN ߵƽд㹻ʱ䣨 32ʱڣ
		TM7705 صĬ״̬
	*/
	bsp_DelayMS(5);

	TM7705_SyncSPI();		/* ͬSPIӿʱ */

	bsp_DelayMS(5);
	
	/* λ֮, ʱӼĴӦ 0x05 */
	{						
		if (TM7705_ReadReg(REG_CLOCK) == 0x05)
		{
			g_TM7705_OK = 1;
		}
		else
		{
			g_TM7705_OK = 0;
		}
	}	

	/* ʱӼĴ */
	TM7705_WriteByte(REG_CLOCK | WRITE | CH_1);			/* дͨżĴһдʱӼĴ */

	TM7705_WriteByte(CLKDIS_0 | CLK_4_9152M | FS_50HZ);	/* ˢ50Hz */
	//TM7705_WriteByte(CLKDIS_0 | CLK_4_9152M | FS_500HZ);	/* ˢ500Hz */

	/* ÿϵһУ׼ */
	TM7705_CalibSelf(1);	/* ڲУ׼ CH1 */
	bsp_DelayMS(5);
}

/*
*********************************************************************************************************
*	  : TM7705_Delay
*	˵: CLK֮ӳ٣ʱӳ. STM32F407  168MƵ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
static void TM7705_Delay(void)
{
	uint16_t i;

	for (i = 0; i < 5; i++);
}

/*
*********************************************************************************************************
*	  : TM7705_ResetHard
*	˵: Ӳλ TM7705оƬ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
static void TM7705_ResetHard(void)
{
	RESET_1();
	bsp_DelayMS(1);
	RESET_0();
	bsp_DelayMS(2);
	RESET_1();
	bsp_DelayMS(1);
}

/*
*********************************************************************************************************
*	  : TM7705_SyncSPI
*	˵: ͬTM7705оƬSPIӿʱ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
static void TM7705_SyncSPI(void)
{
	/* AD7705нӿʧ临λλҪʱ500usٷ */
	CS_0();
	TM7705_Send8Bit(0xFF);
	TM7705_Send8Bit(0xFF);
	TM7705_Send8Bit(0xFF);
	TM7705_Send8Bit(0xFF);
	CS_1();
}

/*
*********************************************************************************************************
*	  : TM7705_Send8Bit
*	˵: SPI߷8bitݡ CSơ
*	    : _data : 
*	  ֵ: 
*********************************************************************************************************
*/
static void TM7705_Send8Bit(uint8_t _data)
{
	uint8_t i;

	for(i = 0; i < 8; i++)
	{
		if (_data & 0x80)
		{
			DI_1();
		}
		else
		{
			DI_0();
		}
		SCK_0();
		_data <<= 1;
		TM7705_Delay();
		SCK_1();
		TM7705_Delay();
	}
}

/*
*********************************************************************************************************
*	  : TM7705_Recive8Bit
*	˵: SPI߽8bitݡ CSơ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
static uint8_t TM7705_Recive8Bit(void)
{
	uint8_t i;
	uint8_t read = 0;

	for (i = 0; i < 8; i++)
	{
		SCK_0();
		TM7705_Delay();
		read = read<<1;
		if (DO_IS_HIGH())
		{
			read++;
		}
		SCK_1();
		TM7705_Delay();
	}
	return read;
}

/*
*********************************************************************************************************
*	  : TM7705_WriteByte
*	˵: д1ֽڡCS
*	    : _data Ҫд
*	  ֵ: 
*********************************************************************************************************
*/
static void TM7705_WriteByte(uint8_t _data)
{
	CS_0();
	TM7705_Send8Bit(_data);
	CS_1();
}

/*
*********************************************************************************************************
*	  : TM7705_Write3Byte
*	˵: д3ֽڡCS
*	    : _data Ҫд
*	  ֵ: 
*********************************************************************************************************
*/
static void TM7705_Write3Byte(uint32_t _data)
{
	CS_0();
	TM7705_Send8Bit((_data >> 16) & 0xFF);
	TM7705_Send8Bit((_data >> 8) & 0xFF);
	TM7705_Send8Bit(_data);
	CS_1();
}

/*
*********************************************************************************************************
*	  : TM7705_ReadByte
*	˵: ADоƬȡһ֣16λ
*	    : 
*	  ֵ: ȡ֣16λ
*********************************************************************************************************
*/
static uint8_t TM7705_ReadByte(void)
{
	uint8_t read;

	CS_0();
	read = TM7705_Recive8Bit();
	CS_1();

	return read;
}

/*
*********************************************************************************************************
*	  : TM7705_Read2Byte
*	˵: 2ֽ
*	    : 
*	  ֵ: ȡݣ16λ
*********************************************************************************************************
*/
static uint16_t TM7705_Read2Byte(void)
{
	uint16_t read;

	CS_0();
	read = TM7705_Recive8Bit();
	read <<= 8;
	read += TM7705_Recive8Bit();
	CS_1();

	return read;
}

/*
*********************************************************************************************************
*	  : TM7705_Read3Byte
*	˵: 3ֽ
*	    : 
*	  ֵ: ȡݣ24bit) 8λ̶Ϊ0.
*********************************************************************************************************
*/
static uint32_t TM7705_Read3Byte(void)
{
	uint32_t read;

	CS_0();
	read = TM7705_Recive8Bit();
	read <<= 8;
	read += TM7705_Recive8Bit();
	read <<= 8;
	read += TM7705_Recive8Bit();
	CS_1();
	return read;
}

/*
*********************************************************************************************************
*	  : TM7705_WaitDRDY
*	˵: ȴڲɡ У׼ʱϳҪȴ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
static void TM7705_WaitDRDY(void)
{
	uint32_t i;

	/* ʼʱδ⵽оƬٷأӰӦٶ */
	if (g_TM7705_OK == 0)
	{
		return;
	}
	
	for (i = 0; i < 4000000; i++)
	{
		if (DRDY_IS_LOW())
		{
			break;
		}
	}
	if (i >= 4000000)
	{
		printf("TM7705_WaitDRDY() Time Out ...\r\n");		/* . Ŵ */
	}
}

/*
*********************************************************************************************************
*	  : TM7705_WriteReg
*	˵: дָļĴ
*	    :  _RegID : ĴID
*			  _RegValue : Ĵֵ 8λļĴȡ32λβεĵ8bit
*	  ֵ: 
*********************************************************************************************************
*/
void TM7705_WriteReg(uint8_t _RegID, uint32_t _RegValue)
{
	uint8_t bits;

	switch (_RegID)
	{
		case REG_COMM:		/* ͨżĴ */
		case REG_SETUP:		/* üĴ 8bit */
		case REG_CLOCK:		/* ʱӼĴ 8bit */
			bits = 8;
			break;

		case REG_ZERO_CH1:	/* CH1 ƫƼĴ 24bit */
		case REG_FULL_CH1:	/* CH1 ̼Ĵ 24bit */
		case REG_ZERO_CH2:	/* CH2 ƫƼĴ 24bit */
		case REG_FULL_CH2:	/* CH2 ̼Ĵ 24bit*/
			bits = 24;
			break;

		case REG_DATA:		/* ݼĴ 16bit */
		default:
			return;
	}

	TM7705_WriteByte(_RegID | WRITE);	/* дͨżĴ, ָһдָдĸĴ */

	if (bits == 8)
	{
		TM7705_WriteByte((uint8_t)_RegValue);
	}
	else	/* 24bit */
	{
		TM7705_Write3Byte(_RegValue);
	}
}

/*
*********************************************************************************************************
*	  : TM7705_ReadReg
*	˵: дָļĴ
*	    :  _RegID : ĴID
*			  _RegValue : Ĵֵ 8λļĴȡ32λβεĵ8bit
*	  ֵ: ļĴֵ 8λļĴȡ32λβεĵ8bit
*********************************************************************************************************
*/
uint32_t TM7705_ReadReg(uint8_t _RegID)
{
	uint8_t bits;
	uint32_t read;

	switch (_RegID)
	{
		case REG_COMM:		/* ͨżĴ */
		case REG_SETUP:		/* üĴ 8bit */
		case REG_CLOCK:		/* ʱӼĴ 8bit */
			bits = 8;
			break;

		case REG_ZERO_CH1:	/* CH1 ƫƼĴ 24bit */
		case REG_FULL_CH1:	/* CH1 ̼Ĵ 24bit */
		case REG_ZERO_CH2:	/* CH2 ƫƼĴ 24bit */
		case REG_FULL_CH2:	/* CH2 ̼Ĵ 24bit*/
			bits = 24;
			break;

		case REG_DATA:		/* ݼĴ 16bit */
		default:
			return 0xFFFFFFFF;
	}

	TM7705_WriteByte(_RegID | READ);	/* дͨżĴ, ָһдָдĸĴ */

	if (bits == 16)
	{
		read = TM7705_Read2Byte();
	}
	else if (bits == 8)
	{
		read = TM7705_ReadByte();
	}
	else	/* 24bit */
	{
		read = TM7705_Read3Byte();
	}
	return read;
}

/*
*********************************************************************************************************
*	  : TM7705_CalibSelf
*	˵: У׼. ڲԶ̽AIN+ AIN-У׼0λڲ̽ӵVref У׼λ˺ִй̽ϳ
*			  ʵԼ 180ms
*	    :  _ch : ADCͨ12
*	  ֵ: 
*********************************************************************************************************
*/
void TM7705_CalibSelf(uint8_t _ch)
{
	if (_ch == 1)
	{
		/* У׼CH1 */
		TM7705_WriteByte(REG_SETUP | WRITE | CH_1);	/* дͨżĴһдüĴͨ1 */
		TM7705_WriteByte(MD_CAL_SELF | __CH1_GAIN_BIPOLAR_BUF | FSYNC_0);/* У׼ */
		TM7705_WaitDRDY();	/* ȴڲ --- ʱϳԼ180ms */
	}
	else if (_ch == 2)
	{
		/* У׼CH2 */
		TM7705_WriteByte(REG_SETUP | WRITE | CH_2);	/* дͨżĴһдüĴͨ2 */
		TM7705_WriteByte(MD_CAL_SELF | __CH2_GAIN_BIPOLAR_BUF | FSYNC_0);	/* У׼ */
		TM7705_WaitDRDY();	/* ȴڲ  --- ʱϳԼ180ms */
	}
}

/*
*********************************************************************************************************
*	  : TM7705_SytemCalibZero
*	˵: ϵͳУ׼λ. 뽫AIN+ AIN-̽ӺִиúУ׼ӦƲУ׼
*			 ִϺ󡣿ͨ TM7705_ReadReg(REG_ZERO_CH1)   TM7705_ReadReg(REG_ZERO_CH2) ȡУ׼
*	    : _ch : ADCͨ12
*	  ֵ: 
*********************************************************************************************************
*/
void TM7705_SytemCalibZero(uint8_t _ch)
{
	if (_ch == 1)
	{
		/* У׼CH1 */
		TM7705_WriteByte(REG_SETUP | WRITE | CH_1);	/* дͨżĴһдüĴͨ1 */
		TM7705_WriteByte(MD_CAL_ZERO | __CH1_GAIN_BIPOLAR_BUF | FSYNC_0);/* У׼ */
		TM7705_WaitDRDY();	/* ȴڲ */
	}
	else if (_ch == 2)
	{
		/* У׼CH2 */
		TM7705_WriteByte(REG_SETUP | WRITE | CH_2);	/* дͨżĴһдüĴͨ1 */
		TM7705_WriteByte(MD_CAL_ZERO | __CH2_GAIN_BIPOLAR_BUF | FSYNC_0);	/* У׼ */
		TM7705_WaitDRDY();	/* ȴڲ */
	}
}

/*
*********************************************************************************************************
*	  : TM7705_SytemCalibFull
*	˵: ϵͳУ׼λ. 뽫AIN+ AIN-ѹԴִиúУ׼ӦƲУ׼
*			 ִϺ󡣿ͨ TM7705_ReadReg(REG_FULL_CH1)   TM7705_ReadReg(REG_FULL_CH2) ȡУ׼
*	    :  _ch : ADCͨ12
*	  ֵ: 
*********************************************************************************************************
*/
void TM7705_SytemCalibFull(uint8_t _ch)
{
	if (_ch == 1)
	{
		/* У׼CH1 */
		TM7705_WriteByte(REG_SETUP | WRITE | CH_1);	/* дͨżĴһдüĴͨ1 */
		TM7705_WriteByte(MD_CAL_FULL | __CH1_GAIN_BIPOLAR_BUF | FSYNC_0);/* У׼ */
		TM7705_WaitDRDY();	/* ȴڲ */
	}
	else if (_ch == 2)
	{
		/* У׼CH2 */
		TM7705_WriteByte(REG_SETUP | WRITE | CH_2);	/* дͨżĴһдüĴͨ1 */
		TM7705_WriteByte(MD_CAL_FULL | __CH2_GAIN_BIPOLAR_BUF | FSYNC_0);	/* У׼ */
		TM7705_WaitDRDY();	/* ȴڲ */
	}
}

/*
*********************************************************************************************************
*	  : TM7705_ReadAdc1
*	˵: ͨ12ADC
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
uint16_t TM7705_ReadAdc(uint8_t _ch)
{
	uint8_t i;
	uint16_t read = 0;

	/* Ϊ˱ͨлɶʧЧ2 */
	for (i = 0; i < 2; i++)
	{
		TM7705_WaitDRDY();		/* ȴDRDYΪ0 */

		if (_ch == 1)
		{
			TM7705_WriteByte(0x38);
		}
		else if (_ch == 2)
		{
			TM7705_WriteByte(0x39);
		}

		read = TM7705_Read2Byte();
	}
	return read;
}

/*****************************  www.armfly.com (END OF FILE) *********************************/
