/*
*********************************************************************************************************
*
*	ģ : ж+FIFOģ
*	ļ : bsp_uart_fifo.c
*	     : V1.0
*	˵     : ôж+FIFOģʽʵֶڵͬʱ
*	޸ļ¼ :
*		汾             ˵
*		V1.0    2013-02-01 armfly  ʽ
*		V1.1    2013-06-09 armfly  FiFoṹTxCountԱжϻ;  FiFoĺ
*
*	
*
*********************************************************************************************************
*/

#include "bsp.h"


/* ÿڽṹ */
#if UART1_FIFO_EN == 1
	static UART_T g_tUart1;
	static uint8_t g_TxBuf1[UART1_TX_BUF_SIZE];		/* ͻ */
	static uint8_t g_RxBuf1[UART1_RX_BUF_SIZE];		/* ջ */
#endif

#if UART2_FIFO_EN == 1
	static UART_T g_tUart2;
	static uint8_t g_TxBuf2[UART2_TX_BUF_SIZE];		/* ͻ */
	static uint8_t g_RxBuf2[UART2_RX_BUF_SIZE];		/* ջ */
#endif

#if UART3_FIFO_EN == 1
	static UART_T g_tUart3;
	static uint8_t g_TxBuf3[UART3_TX_BUF_SIZE];		/* ͻ */
	static uint8_t g_RxBuf3[UART3_RX_BUF_SIZE];		/* ջ */
#endif

#if UART4_FIFO_EN == 1
	static UART_T g_tUart4;
	static uint8_t g_TxBuf4[UART4_TX_BUF_SIZE];		/* ͻ */
	static uint8_t g_RxBuf4[UART4_RX_BUF_SIZE];		/* ջ */
#endif

#if UART5_FIFO_EN == 1
	static UART_T g_tUart5;
	static uint8_t g_TxBuf5[UART5_TX_BUF_SIZE];		/* ͻ */
	static uint8_t g_RxBuf5[UART5_RX_BUF_SIZE];		/* ջ */
#endif

#if UART6_FIFO_EN == 1
	static UART_T g_tUart6;
	static uint8_t g_TxBuf6[UART6_TX_BUF_SIZE];		/* ͻ */
	static uint8_t g_RxBuf6[UART6_RX_BUF_SIZE];		/* ջ */
#endif

static void UartVarInit(void);

static void InitHardUart(void);
static void UartSend(UART_T *_pUart, uint8_t *_ucaBuf, uint16_t _usLen);
static uint8_t UartGetChar(UART_T *_pUart, uint8_t *_pByte);
static void UartIRQ(UART_T *_pUart);
static void ConfigUartNVIC(void);

/*
*********************************************************************************************************
*	  : bsp_InitUart
*	˵: ʼӲȫֱֵ.
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void bsp_InitUart(void)
{
	UartVarInit();		/* ȳʼȫֱ,Ӳ */

	InitHardUart();		/* ôڵӲ(ʵ) */

	ConfigUartNVIC();	/* ôж */
}

/*
*********************************************************************************************************
*	  : ComToUart
*	˵: COM˿ںתΪUARTָ
*	    : _ucPort: ˿ں(COM1 - COM6)
*	  ֵ: uartָ
*********************************************************************************************************
*/
UART_T *ComToUart(COM_PORT_E _ucPort)
{
	if (_ucPort == COM1)
	{
		#if UART1_FIFO_EN == 1
			return &g_tUart1;
		#else
			return 0;
		#endif
	}
	else if (_ucPort == COM2)
	{
		#if UART2_FIFO_EN == 1
			return &g_tUart2;
		#else
			return;
		#endif
	}
	else if (_ucPort == COM3)
	{
		#if UART3_FIFO_EN == 1
			return &g_tUart3;
		#else
			return 0;
		#endif
	}
	else if (_ucPort == COM4)
	{
		#if UART4_FIFO_EN == 1
			return &g_tUart4;
		#else
			return 0;
		#endif
	}
	else if (_ucPort == COM5)
	{
		#if UART5_FIFO_EN == 1
			return &g_tUart5;
		#else
			return 0;
		#endif
	}
	else if (_ucPort == COM6)
	{
		#if UART6_FIFO_EN == 1
			return &g_tUart6;
		#else
			return 0;
		#endif
	}
	else
	{
		/* κδ */
		return 0;
	}
}

/*
*********************************************************************************************************
*	  : comSendBuf
*	˵: 򴮿ڷһݡݷŵͻأжϷں̨ɷ
*	    : _ucPort: ˿ں(COM1 - COM6)
*			  _ucaBuf: ͵ݻ
*			  _usLen : ݳ
*	  ֵ: 
*********************************************************************************************************
*/
void comSendBuf(COM_PORT_E _ucPort, uint8_t *_ucaBuf, uint16_t _usLen)
{
	UART_T *pUart;

	pUart = ComToUart(_ucPort);
	if (pUart == 0)
	{
		return;
	}

	if (pUart->SendBefor != 0)
	{
		pUart->SendBefor();		/* RS485ͨţнRS485Ϊģʽ */
	}

	UartSend(pUart, _ucaBuf, _usLen);
}

/*
*********************************************************************************************************
*	  : comSendChar
*	˵: 򴮿ڷ1ֽڡݷŵͻأжϷں̨ɷ
*	    : _ucPort: ˿ں(COM1 - COM6)
*			  _ucByte: ͵
*	  ֵ: 
*********************************************************************************************************
*/
void comSendChar(COM_PORT_E _ucPort, uint8_t _ucByte)
{
	comSendBuf(_ucPort, &_ucByte, 1);
}

/*
*********************************************************************************************************
*	  : comGetChar
*	˵: Ӵڻȡ1ֽڣݾ
*	    : _ucPort: ˿ں(COM1 - COM6)
*			  _pByte: յݴַ
*	  ֵ: 0 ʾ, 1 ʾȡЧֽ
*********************************************************************************************************
*/
uint8_t comGetChar(COM_PORT_E _ucPort, uint8_t *_pByte)
{
	UART_T *pUart;

	pUart = ComToUart(_ucPort);
	if (pUart == 0)
	{
		return 0;
	}

	return UartGetChar(pUart, _pByte);
}

/*
*********************************************************************************************************
*	  : comClearTxFifo
*	˵: 㴮ڷͻ
*	    : _ucPort: ˿ں(COM1 - COM6)
*	  ֵ: 
*********************************************************************************************************
*/
void comClearTxFifo(COM_PORT_E _ucPort)
{
	UART_T *pUart;

	pUart = ComToUart(_ucPort);
	if (pUart == 0)
	{
		return;
	}

	pUart->usTxWrite = 0;
	pUart->usTxRead = 0;
	pUart->usTxCount = 0;
}

/*
*********************************************************************************************************
*	  : comClearRxFifo
*	˵: 㴮ڽջ
*	    : _ucPort: ˿ں(COM1 - COM6)
*	  ֵ: 
*********************************************************************************************************
*/
void comClearRxFifo(COM_PORT_E _ucPort)
{
	UART_T *pUart;

	pUart = ComToUart(_ucPort);
	if (pUart == 0)
	{
		return;
	}

	pUart->usRxWrite = 0;
	pUart->usRxRead = 0;
	pUart->usRxCount = 0;
}

/* RS485ͨţ밴¸ʽд ǽ USART3ΪRS485 */

/*
*********************************************************************************************************
*	  : USART3_SendBefor
*	˵: USART1 ǰ׼RS485ͨţRS485оƬΪ״̬
*			  ޸ UartVarInit()еĺָڱ g_tUart3.SendBefor = USART3_SendBefor
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void USART3_SendBefor(void)
{
	RS485_TX_EN();	/* лRS485շоƬΪģʽ */
}

/*
*********************************************************************************************************
*	  : USART3_SendOver
*	˵: USART3 һݽƺRS485ͨţRS485оƬΪ״̬
*			  ޸ UartVarInit()еĺָڱ g_tUart3.SendOver = USART3_SendOver
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void USART3_SendOver(void)
{
	RS485_RX_EN();	/* лRS485շоƬΪģʽ */
}

/*
*********************************************************************************************************
*	  : UartVarInit
*	˵: ʼصı
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
static void UartVarInit(void)
{
#if UART1_FIFO_EN == 1
	g_tUart1.uart = USART1;						/* STM32 豸 */
	g_tUart1.pTxBuf = g_TxBuf1;					/* ͻָ */
	g_tUart1.pRxBuf = g_RxBuf1;					/* ջָ */
	g_tUart1.usTxBufSize = UART1_TX_BUF_SIZE;	/* ͻС */
	g_tUart1.usRxBufSize = UART1_RX_BUF_SIZE;	/* ջС */
	g_tUart1.usTxWrite = 0;						/* FIFOд */
	g_tUart1.usTxRead = 0;						/* FIFO */
	g_tUart1.usRxWrite = 0;						/* FIFOд */
	g_tUart1.usRxRead = 0;						/* FIFO */
	g_tUart1.usRxCount = 0;						/* յݸ */
	g_tUart1.usTxCount = 0;						/* ͵ݸ */
	g_tUart1.SendBefor = 0;						/* ǰĻص */
	g_tUart1.SendOver = 0;						/* ϺĻص */
	g_tUart1.ReciveNew = 0;						/* յݺĻص */
#endif

#if UART2_FIFO_EN == 1
	g_tUart2.uart = USART2;						/* STM32 豸 */
	g_tUart2.pTxBuf = g_TxBuf2;					/* ͻָ */
	g_tUart2.pRxBuf = g_RxBuf2;					/* ջָ */
	g_tUart2.usTxBufSize = UART2_TX_BUF_SIZE;	/* ͻС */
	g_tUart2.usRxBufSize = UART2_RX_BUF_SIZE;	/* ջС */
	g_tUart2.usTxWrite = 0;						/* FIFOд */
	g_tUart2.usTxRead = 0;						/* FIFO */
	g_tUart2.usRxWrite = 0;						/* FIFOд */
	g_tUart2.usRxRead = 0;						/* FIFO */
	g_tUart2.usRxCount = 0;						/* յݸ */
	g_tUart2.usTxCount = 0;						/* ͵ݸ */	
	g_tUart2.SendBefor = 0;						/* ǰĻص */
	g_tUart2.SendOver = 0;						/* ϺĻص */
	g_tUart2.ReciveNew = 0;						/* յݺĻص */
#endif

#if UART3_FIFO_EN == 1
	g_tUart3.uart = USART3;						/* STM32 豸 */
	g_tUart3.pTxBuf = g_TxBuf3;					/* ͻָ */
	g_tUart3.pRxBuf = g_RxBuf3;					/* ջָ */
	g_tUart3.usTxBufSize = UART3_TX_BUF_SIZE;	/* ͻС */
	g_tUart3.usRxBufSize = UART3_RX_BUF_SIZE;	/* ջС */
	g_tUart3.usTxWrite = 0;						/* FIFOд */
	g_tUart3.usTxRead = 0;						/* FIFO */
	g_tUart3.usRxWrite = 0;						/* FIFOд */
	g_tUart3.usRxRead = 0;						/* FIFO */
	g_tUart3.usRxCount = 0;						/* յݸ */
	g_tUart3.usTxCount = 0;						/* ͵ݸ */	
	g_tUart3.SendBefor = USART3_SendBefor;		/* ǰĻص */
	g_tUart3.SendOver = USART3_SendOver;		/* ϺĻص */
	g_tUart3.ReciveNew = 0;						/* յݺĻص */
#endif

#if UART4_FIFO_EN == 1
	g_tUart4.uart = UART4;						/* STM32 豸 */
	g_tUart4.pTxBuf = g_TxBuf4;					/* ͻָ */
	g_tUart4.pRxBuf = g_RxBuf4;					/* ջָ */
	g_tUart4.usTxBufSize = UART4_TX_BUF_SIZE;	/* ͻС */
	g_tUart4.usRxBufSize = UART4_RX_BUF_SIZE;	/* ջС */
	g_tUart4.usTxWrite = 0;						/* FIFOд */
	g_tUart4.usTxRead = 0;						/* FIFO */
	g_tUart4.usRxWrite = 0;						/* FIFOд */
	g_tUart4.usRxRead = 0;						/* FIFO */
	g_tUart4.usRxCount = 0;						/* յݸ */
	g_tUart4.usTxCount = 0;						/* ͵ݸ */	
	g_tUart4.SendBefor = 0;						/* ǰĻص */
	g_tUart4.SendOver = 0;						/* ϺĻص */
	g_tUart4.ReciveNew = 0;						/* յݺĻص */
#endif

#if UART5_FIFO_EN == 1
	g_tUart5.uart = UART5;						/* STM32 豸 */
	g_tUart5.pTxBuf = g_TxBuf5;					/* ͻָ */
	g_tUart5.pRxBuf = g_RxBuf5;					/* ջָ */
	g_tUart5.usTxBufSize = UART5_TX_BUF_SIZE;	/* ͻС */
	g_tUart5.usRxBufSize = UART5_RX_BUF_SIZE;	/* ջС */
	g_tUart5.usTxWrite = 0;						/* FIFOд */
	g_tUart5.usTxRead = 0;						/* FIFO */
	g_tUart5.usRxWrite = 0;						/* FIFOд */
	g_tUart5.usRxRead = 0;						/* FIFO */
	g_tUart5.usRxCount = 0;						/* յݸ */
	g_tUart5.usTxCount = 0;						/* ͵ݸ */	
	g_tUart5.SendBefor = 0;						/* ǰĻص */
	g_tUart5.SendOver = 0;						/* ϺĻص */
	g_tUart5.ReciveNew = 0;						/* յݺĻص */
#endif


#if UART6_FIFO_EN == 1
	g_tUart6.uart = USART6;						/* STM32 豸 */
	g_tUart6.pTxBuf = g_TxBuf6;					/* ͻָ */
	g_tUart6.pRxBuf = g_RxBuf6;					/* ջָ */
	g_tUart6.usTxBufSize = UART6_TX_BUF_SIZE;	/* ͻС */
	g_tUart6.usRxBufSize = UART6_RX_BUF_SIZE;	/* ջС */
	g_tUart6.usTxWrite = 0;						/* FIFOд */
	g_tUart6.usTxRead = 0;						/* FIFO */
	g_tUart6.usRxWrite = 0;						/* FIFOд */
	g_tUart6.usRxRead = 0;						/* FIFO */
	g_tUart6.usRxCount = 0;						/* յݸ */
	g_tUart6.usTxCount = 0;						/* ͵ݸ */	
	g_tUart6.SendBefor = 0;						/* ǰĻص */
	g_tUart6.SendOver = 0;						/* ϺĻص */
	g_tUart6.ReciveNew = 0;						/* յݺĻص */
#endif
}

/*
*********************************************************************************************************
*	  : InitHardUart
*	˵: ôڵӲʣλֹͣλʼλУλжʹܣʺSTM32-F4
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
static void InitHardUart(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;
	USART_InitTypeDef USART_InitStructure;

#if UART1_FIFO_EN == 1		/* 1 TX = PA9   RX = PA10  TX = PB6   RX = PB7*/

	/* 1 GPIO */
	#if 1	/* TX = PA9   RX = PA10 */
		/*  GPIO ʱ */
		RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOA, ENABLE);

		/*  UART ʱ */
		RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1, ENABLE);

		/*  PA9 ӳΪ USART1_TX */
		GPIO_PinAFConfig(GPIOA, GPIO_PinSource9, GPIO_AF_USART1);

		/*  PA10 ӳΪ USART1_RX */
		GPIO_PinAFConfig(GPIOA, GPIO_PinSource10, GPIO_AF_USART1);

		/*  USART Tx Ϊù */
		GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;	/* Ϊ */
		GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;	/* ڲʹ */
		GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;	/* ģʽ */

		GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;
		GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
		GPIO_Init(GPIOA, &GPIO_InitStructure);

		/*  USART Rx Ϊù */
		GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
		GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
		GPIO_Init(GPIOA, &GPIO_InitStructure);
	#else	/* TX = PB6   RX = PB7  */
		/*  GPIO ʱ */
		RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOB, ENABLE);

		/*  UART ʱ */
		RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1, ENABLE);

		/*  PB6 ӳΪ USART1_TX */
		GPIO_PinAFConfig(GPIOB, GPIO_PinSource6, GPIO_AF_USART1);

		/*  PB7 ӳΪ USART1_RX */
		GPIO_PinAFConfig(GPIOB, GPIO_PinSource7, GPIO_AF_USART1);

		/*  USART Tx Ϊù */
		GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;	/* Ϊ */
		GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;	/* ڲʹ */
		GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;	/* ģʽ */

		GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6;
		GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
		GPIO_Init(GPIOB, &GPIO_InitStructure);

		/*  USART Rx Ϊù */
		GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
		GPIO_InitStructure.GPIO_Pin = GPIO_Pin_7;
		GPIO_Init(GPIOB, &GPIO_InitStructure);
	#endif

	/* 2 ôӲ */
	USART_InitStructure.USART_BaudRate = UART1_BAUD;	/*  */
	USART_InitStructure.USART_WordLength = USART_WordLength_8b;
	USART_InitStructure.USART_StopBits = USART_StopBits_1;
	USART_InitStructure.USART_Parity = USART_Parity_No ;
	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
	USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
	USART_Init(USART1, &USART_InitStructure);

	USART_ITConfig(USART1, USART_IT_RXNE, ENABLE);	/* ʹܽж */
	/*
		USART_ITConfig(USART1, USART_IT_TXE, ENABLE);
		ע: Ҫڴ˴򿪷ж
		жʹSendUart()
	*/
	USART_Cmd(USART1, ENABLE);		/* ʹܴ */

	/* CPUСȱݣúãֱSend1ֽڷͲȥ
		1ֽ޷ȷͳȥ */
	USART_ClearFlag(USART1, USART_FLAG_TC);     /* 巢ɱ־Transmission Complete flag */
#endif

#if UART2_FIFO_EN == 1		/* 2 TX = PD5   RX = PD6   TX = PA2 RX = PA3  */
	/* 1 GPIO */
	#if 0	/* 2 TX = PD5   RX = PD6 */
		/*  GPIO ʱ */
		RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOD, ENABLE);

		/*  UART ʱ */
		RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART2, ENABLE);

		/*  PD5 ӳΪ USART2_TX */
		GPIO_PinAFConfig(GPIOD, GPIO_PinSource5, GPIO_AF_USART2);

		/*  PD6 ӳΪ USART2_RX */
		GPIO_PinAFConfig(GPIOD, GPIO_PinSource6, GPIO_AF_USART2);

		/*  USART Tx Ϊù */
		GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;	/* Ϊ */
		GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;	/* ڲʹ */
		GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;	/* ģʽ */

		GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5;
		GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
		GPIO_Init(GPIOD, &GPIO_InitStructure);

		/*  USART Rx Ϊù */
		GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
		GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6;
		GPIO_Init(GPIOD, &GPIO_InitStructure);

	#else	/* 2   TX = PA2 RX = PA3 */
		/*  GPIO ʱ */
		RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOA, ENABLE);

		/*  UART ʱ */
		RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART2, ENABLE);

		/*  PA2 ӳΪ USART2_TX. STM32-V5УPA2 ̫ܽ */
		//GPIO_PinAFConfig(GPIOA, GPIO_PinSource2, GPIO_AF_USART2);

		/*  PA3 ӳΪ USART2_RX */
		GPIO_PinAFConfig(GPIOA, GPIO_PinSource3, GPIO_AF_USART2);

		/*  USART Tx Ϊù */
		GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;	/* Ϊ */
		GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;	/* ڲʹ */
		GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;	/* ģʽ */

		//GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;
		//GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
		//GPIO_Init(GPIOA, &GPIO_InitStructure);

		/*  USART Rx Ϊù */
		GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
		GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3;
		GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
		GPIO_Init(GPIOA, &GPIO_InitStructure);
	#endif

	/* 2 ôӲ */
	USART_InitStructure.USART_BaudRate = UART2_BAUD;	/*  */
	USART_InitStructure.USART_WordLength = USART_WordLength_8b;
	USART_InitStructure.USART_StopBits = USART_StopBits_1;
	USART_InitStructure.USART_Parity = USART_Parity_No ;
	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
	USART_InitStructure.USART_Mode = USART_Mode_Rx;		/* ѡģʽ */
	USART_Init(USART2, &USART_InitStructure);

	USART_ITConfig(USART2, USART_IT_RXNE, ENABLE);	/* ʹܽж */
	/*
		USART_ITConfig(USART1, USART_IT_TXE, ENABLE);
		ע: Ҫڴ˴򿪷ж
		жʹSendUart()
	*/
	USART_Cmd(USART2, ENABLE);		/* ʹܴ */

	/* CPUСȱݣúãֱSend1ֽڷͲȥ
		1ֽ޷ȷͳȥ */
	USART_ClearFlag(USART2, USART_FLAG_TC);     /* 巢ɱ־Transmission Complete flag */
#endif

#if UART3_FIFO_EN == 1			/* 3 TX = PB10   RX = PB11 */

	/*  PB2Ϊл RS485оƬշ״̬ */
	{
		RCC_AHB1PeriphClockCmd(RCC_RS485_TXEN, ENABLE);

		GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;		/* Ϊ */
		GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;		/* Ϊģʽ */
		GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;	/* 費ʹ */
		GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;	/* IOٶ */

		GPIO_InitStructure.GPIO_Pin = PIN_RS485_TXEN;
		GPIO_Init(PORT_RS485_TXEN, &GPIO_InitStructure);
	}

	/*  GPIO ʱ */
	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOB, ENABLE);

	/*  UART ʱ */
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART3, ENABLE);

	/*  PB10 ӳΪ USART3_TX */
	GPIO_PinAFConfig(GPIOB, GPIO_PinSource10, GPIO_AF_USART3);

	/*  PB11 ӳΪ USART3_RX */
	GPIO_PinAFConfig(GPIOB, GPIO_PinSource11, GPIO_AF_USART3);

	/*  USART Tx Ϊù */
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;	/* Ϊ */
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;	/* ڲʹ */
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;	/* ģʽ */

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOB, &GPIO_InitStructure);

	/*  USART Rx Ϊù */
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_11;
	GPIO_Init(GPIOB, &GPIO_InitStructure);

	/* 2 ôӲ */
	USART_InitStructure.USART_BaudRate = UART3_BAUD;	/*  */
	USART_InitStructure.USART_WordLength = USART_WordLength_8b;
	USART_InitStructure.USART_StopBits = USART_StopBits_1;
	USART_InitStructure.USART_Parity = USART_Parity_No ;
	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
	USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
	USART_Init(USART3, &USART_InitStructure);

	USART_ITConfig(USART3, USART_IT_RXNE, ENABLE);	/* ʹܽж */
	/*
		USART_ITConfig(USART1, USART_IT_TXE, ENABLE);
		ע: Ҫڴ˴򿪷ж
		жʹSendUart()
	*/
	USART_Cmd(USART3, ENABLE);		/* ʹܴ */

	/* CPUСȱݣúãֱSend1ֽڷͲȥ
		1ֽ޷ȷͳȥ */
	USART_ClearFlag(USART3, USART_FLAG_TC);     /* 巢ɱ־Transmission Complete flag */
#endif

#if UART4_FIFO_EN == 1			/* 4 TX = PC10   RX = PC11 */
	/* 1 GPIO */

	/*  GPIO ʱ */
	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOC, ENABLE);

	/*  UART ʱ */
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_UART4, ENABLE);

	/*  PC10 ӳΪ UART4_TX */
	GPIO_PinAFConfig(GPIOC, GPIO_PinSource10, GPIO_AF_USART1);

	/*  PC11 ӳΪ UART4_RX */
	GPIO_PinAFConfig(GPIOC, GPIO_PinSource10, GPIO_AF_USART1);

	/*  USART Tx Ϊù */
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;	/* Ϊ */
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;	/* ڲʹ */
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;	/* ģʽ */

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOC, &GPIO_InitStructure);

	/*  USART Rx Ϊù */
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_11;
	GPIO_Init(GPIOC, &GPIO_InitStructure);

	/* 2 ôӲ */
	USART_InitStructure.USART_BaudRate = UART1_BAUD;	/*  */
	USART_InitStructure.USART_WordLength = USART_WordLength_8b;
	USART_InitStructure.USART_StopBits = USART_StopBits_1;
	USART_InitStructure.USART_Parity = USART_Parity_No ;
	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
	USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
	USART_Init(UART4, &USART_InitStructure);

	USART_ITConfig(UART4, USART_IT_RXNE, ENABLE);	/* ʹܽж */
	/*
		USART_ITConfig(USART1, USART_IT_TXE, ENABLE);
		ע: Ҫڴ˴򿪷ж
		жʹSendUart()
	*/
	USART_Cmd(UART4, ENABLE);		/* ʹܴ */

	/* CPUСȱݣúãֱSend1ֽڷͲȥ
		1ֽ޷ȷͳȥ */
	USART_ClearFlag(UART4, USART_FLAG_TC);     /* 巢ɱ־Transmission Complete flag */
#endif

#if UART5_FIFO_EN == 1			/* 5 TX = PC12   RX = PD2 */
	/* 1 GPIO */

	/*  GPIO ʱ */
	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOC |RCC_AHB1Periph_GPIOD, ENABLE);

	/*  UART ʱ */
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_UART5, ENABLE);

	/*  PC12 ӳΪ UART5_TX */
	GPIO_PinAFConfig(GPIOC, GPIO_PinSource12, GPIO_AF_UART5);

	/*  PD2 ӳΪ UART5_RX */
	GPIO_PinAFConfig(GPIOD, GPIO_PinSource2, GPIO_AF_UART5);

	/*  UART Tx Ϊù */
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;	/* Ϊ */
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;	/* ڲʹ */
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;	/* ģʽ */

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOC, &GPIO_InitStructure);

	/*  UART Rx Ϊù */
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;
	GPIO_Init(GPIOD, &GPIO_InitStructure);

	/* 2 ôӲ */
	USART_InitStructure.USART_BaudRate = UART5_BAUD;	/*  */
	USART_InitStructure.USART_WordLength = USART_WordLength_8b;
	USART_InitStructure.USART_StopBits = USART_StopBits_1;
	USART_InitStructure.USART_Parity = USART_Parity_No ;
	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
	USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
	USART_Init(UART5, &USART_InitStructure);

	USART_ITConfig(UART5, USART_IT_RXNE, ENABLE);	/* ʹܽж */
	/*
		USART_ITConfig(USART1, USART_IT_TXE, ENABLE);
		ע: Ҫڴ˴򿪷ж
		жʹSendUart()
	*/
	USART_Cmd(UART5, ENABLE);		/* ʹܴ */

	/* CPUСȱݣúãֱSend1ֽڷͲȥ
		1ֽ޷ȷͳȥ */
	USART_ClearFlag(UART5, USART_FLAG_TC);     /* 巢ɱ־Transmission Complete flag */
#endif

#if UART6_FIFO_EN == 1			/* PG14/USART6_TX , PC7/USART6_RX,PG8/USART6_RTS, PG15/USART6_CTS */
	/* 1 GPIO */

	/*  GPIO ʱ */
	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOC |RCC_AHB1Periph_GPIOG, ENABLE);

	/*  UART ʱ */
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART6, ENABLE);

	/*  PG14 ӳΪ USART6_TX */
	GPIO_PinAFConfig(GPIOG, GPIO_PinSource14, GPIO_AF_USART6);

	/*  PC7 ӳΪ USART6_RX */
	GPIO_PinAFConfig(GPIOC, GPIO_PinSource7, GPIO_AF_USART6);

	/*  PG8 ӳΪ USART6_RTS */
	GPIO_PinAFConfig(GPIOG, GPIO_PinSource8, GPIO_AF_USART6);

	/*  PG15 ӳΪ USART6_CTS */
	GPIO_PinAFConfig(GPIOG, GPIO_PinSource15, GPIO_AF_USART6);

	/*  PG14/USART6_TX Ϊù */
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;	/* Ϊ */
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;	/* ڲʹ */
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;	/* ģʽ */

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_14;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOG, &GPIO_InitStructure);

	/*  PC7/USART6_RX Ϊù */
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_7;
	GPIO_Init(GPIOC, &GPIO_InitStructure);

	/*  PG8/USART6_RTS Ϊù */
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8;
	GPIO_Init(GPIOG, &GPIO_InitStructure);

	/*  PG15/USART6_CTS Ϊù */
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_15;
	GPIO_Init(GPIOG, &GPIO_InitStructure);

	/* 2 ôӲ */
	USART_InitStructure.USART_BaudRate = UART6_BAUD;	/*  */
	USART_InitStructure.USART_WordLength = USART_WordLength_8b;
	USART_InitStructure.USART_StopBits = USART_StopBits_1;
	USART_InitStructure.USART_Parity = USART_Parity_No ;
	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_RTS_CTS;	/* ѡӲ */
	USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
	USART_Init(USART6, &USART_InitStructure);

	USART_ITConfig(USART6, USART_IT_RXNE, ENABLE);	/* ʹܽж */
	/*
		USART_ITConfig(USART1, USART_IT_TXE, ENABLE);
		ע: Ҫڴ˴򿪷ж
		жʹSendUart()
	*/
	USART_Cmd(USART6, ENABLE);		/* ʹܴ */

	/* CPUСȱݣúãֱSend1ֽڷͲȥ
		1ֽ޷ȷͳȥ */
	USART_ClearFlag(USART6, USART_FLAG_TC);     /* 巢ɱ־Transmission Complete flag */
#endif
}

/*
*********************************************************************************************************
*	  : ConfigUartNVIC
*	˵: ôӲж.
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
static void ConfigUartNVIC(void)
{
	NVIC_InitTypeDef NVIC_InitStructure;

	/* Configure the NVIC Preemption Priority Bits */
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_0);

#if UART1_FIFO_EN == 1
	/* ʹܴ1ж */
	NVIC_InitStructure.NVIC_IRQChannel = USART1_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure);
#endif

#if UART2_FIFO_EN == 1
	/* ʹܴ2ж */
	NVIC_InitStructure.NVIC_IRQChannel = USART2_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure);
#endif

#if UART3_FIFO_EN == 1
	/* ʹܴ3жt */
	NVIC_InitStructure.NVIC_IRQChannel = USART3_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 2;
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure);
#endif

#if UART4_FIFO_EN == 1
	/* ʹܴ4жt */
	NVIC_InitStructure.NVIC_IRQChannel = UART4_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 3;
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure);
#endif

#if UART5_FIFO_EN == 1
	/* ʹܴ5жt */
	NVIC_InitStructure.NVIC_IRQChannel = UART5_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 4;
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure);
#endif

#if UART6_FIFO_EN == 1
	/* ʹܴ6жt */
	NVIC_InitStructure.NVIC_IRQChannel = USART6_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 5;
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure);
#endif
}

/*
*********************************************************************************************************
*	  : UartSend
*	˵: дݵUARTͻ,жϡжϴϺԶرշж
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
static void UartSend(UART_T *_pUart, uint8_t *_ucaBuf, uint16_t _usLen)
{
	uint16_t i;

	for (i = 0; i < _usLen; i++)
	{
		/* ͻѾˣȴ */		
	#if 0
		/* 
			ڵGPRSʱĴwhile ѭ
			ԭ ͵1ֽʱ _pUart->usTxWrite = 1_pUart->usTxRead = 0;
			while(1) ޷˳
		*/
		while (1)
		{
			uint16_t usRead;

			DISABLE_INT();
			usRead = _pUart->usTxRead;
			ENABLE_INT();

			if (++usRead >= _pUart->usTxBufSize)
			{
				usRead = 0;
			}

			if (usRead != _pUart->usTxWrite)
			{
				break;
			}
		}
	#else
		while (1)
		{
			uint16_t usCount;

			DISABLE_INT();
			usCount = _pUart->usTxCount;
			ENABLE_INT();

			if (usCount < _pUart->usTxBufSize)
			{
				break;
			}
		}			
	#endif

		/* 뷢ͻ */
		_pUart->pTxBuf[_pUart->usTxWrite] = _ucaBuf[i];

		DISABLE_INT();
		if (++_pUart->usTxWrite >= _pUart->usTxBufSize)
		{
			_pUart->usTxWrite = 0;
		}
		_pUart->usTxCount++;
		ENABLE_INT();
	}

	USART_ITConfig(_pUart->uart, USART_IT_TXE, ENABLE);
}

/*
*********************************************************************************************************
*	  : UartGetChar
*	˵: Ӵڽջȡ1ֽ ã
*	    : _pUart : 豸
*			  _pByte : Ŷȡݵָ
*	  ֵ: 0 ʾ  1ʾȡ
*********************************************************************************************************
*/
static uint8_t UartGetChar(UART_T *_pUart, uint8_t *_pByte)
{
	uint16_t usCount;

	/* usRxWrite жϺбдȡñʱٽ */
	DISABLE_INT();
	usCount = _pUart->usRxCount;
	ENABLE_INT();

	/* дͬ򷵻0 */
	//if (_pUart->usRxRead == usRxWrite)
	if (usCount == 0)	/* Ѿû */
	{
		return 0;
	}
	else
	{
		*_pByte = _pUart->pRxBuf[_pUart->usRxRead];		/* ӴڽFIFOȡ1 */

		/* дFIFO */
		DISABLE_INT();
		if (++_pUart->usRxRead >= _pUart->usRxBufSize)
		{
			_pUart->usRxRead = 0;
		}
		_pUart->usRxCount--;
		ENABLE_INT();
		return 1;
	}
}

/*
*********************************************************************************************************
*	  : UartIRQ
*	˵: жϷãͨôжϴ
*	    : _pUart : 豸
*	  ֵ: 
*********************************************************************************************************
*/
static void UartIRQ(UART_T *_pUart)
{
	/* ж  */
	if (USART_GetITStatus(_pUart->uart, USART_IT_RXNE) != RESET)
	{
		/* ӴڽݼĴȡݴŵFIFO */
		_pUart->pRxBuf[_pUart->usRxWrite] = USART_ReceiveData(_pUart->uart);
		if (++_pUart->usRxWrite >= _pUart->usRxBufSize)
		{
			_pUart->usRxWrite = 0;
		}
		if (_pUart->usRxCount < _pUart->usRxBufSize)
		{
			_pUart->usRxCount++;
		}

		/* ص,֪ͨӦóյ,һǷ1Ϣһ */
		//if (_pUart->usRxWrite == _pUart->usRxRead)
		if (_pUart->usRxCount == 1)
		{
			if (_pUart->ReciveNew)
			{
				_pUart->ReciveNew();
			}
		}		
	}

	/* ͻж */
	if (USART_GetITStatus(_pUart->uart, USART_IT_TXE) != RESET)
	{
		//if (_pUart->usTxRead == _pUart->usTxWrite)
		if (_pUart->usTxCount == 0)
		{
			/* ͻȡʱ ֹͻж ע⣺ʱ1ݻδϣ*/
			USART_ITConfig(_pUart->uart, USART_IT_TXE, DISABLE);

			/* ʹݷж */
			USART_ITConfig(_pUart->uart, USART_IT_TC, ENABLE);
		}
		else
		{
			/* ӷFIFOȡ1ֽд봮ڷݼĴ */
			USART_SendData(_pUart->uart, _pUart->pTxBuf[_pUart->usTxRead]);
			if (++_pUart->usTxRead >= _pUart->usTxBufSize)
			{
				_pUart->usTxRead = 0;
			}
			_pUart->usTxCount--;
		}

	}
	/* bitλȫϵж */
	else if (USART_GetITStatus(_pUart->uart, USART_IT_TC) != RESET)
	{
		//if (_pUart->usTxRead == _pUart->usTxWrite)
		if (_pUart->usTxCount == 0)
		{
			/* FIFOȫϣֹݷж */
			USART_ITConfig(_pUart->uart, USART_IT_TC, DISABLE);

			/* ص, һRS485ͨţRS485оƬΪģʽռ */
			if (_pUart->SendOver)
			{
				_pUart->SendOver();
			}
		}
		else
		{
			/* £˷֧ */
			
			/* FIFOݻδϣӷFIFOȡ1д뷢ݼĴ */
			USART_SendData(_pUart->uart, _pUart->pTxBuf[_pUart->usTxRead]);
			if (++_pUart->usTxRead >= _pUart->usTxBufSize)
			{
				_pUart->usTxRead = 0;
			}
			_pUart->usTxCount--;
		}
	}
}

/*
*********************************************************************************************************
*	  : USART1_IRQHandler  USART2_IRQHandler USART3_IRQHandler UART4_IRQHandler UART5_IRQHandler
*	˵: USARTжϷ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
#if UART1_FIFO_EN == 1
void USART1_IRQHandler(void)
{
	UartIRQ(&g_tUart1);
}
#endif

#if UART2_FIFO_EN == 1
void USART2_IRQHandler(void)
{
	UartIRQ(&g_tUart2);
}
#endif

#if UART3_FIFO_EN == 1
void USART3_IRQHandler(void)
{
	UartIRQ(&g_tUart3);
}
#endif

#if UART4_FIFO_EN == 1
void UART4_IRQHandler(void)
{
	UartIRQ(&g_tUart4);
}
#endif

#if UART5_FIFO_EN == 1
void UART5_IRQHandler(void)
{
	UartIRQ(&g_tUart5);
}
#endif

#if UART6_FIFO_EN == 1
void USART6_IRQHandler(void)
{
	UartIRQ(&g_tUart6);
}
#endif

/*
*********************************************************************************************************
*	  : fputc
*	˵: ضputcʹprintfӴ1ӡ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
int fputc(int ch, FILE *f)
{
#if 1	/* ҪprintfַͨжFIFOͳȥprintf */
	comSendChar(COM1, ch);

	return ch;
#else	/* ʽÿַ,ȴݷ */
	/* дһֽڵUSART1 */
	USART_SendData(USART1, (uint8_t) ch);

	/* ȴͽ */
	while (USART_GetFlagStatus(USART1, USART_FLAG_TC) == RESET)
	{}

	return ch;
#endif
}

/*
*********************************************************************************************************
*	  : fgetc
*	˵: ضgetcʹgetcharӴ1
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
int fgetc(FILE *f)
{

#if 1	/* ӴڽFIFOȡ1, ֻȡݲŷ */
	uint8_t ucData;

	while(comGetChar(COM1, &ucData) == 0);

	return ucData;
#else
	/* ȴ1 */
	while (USART_GetFlagStatus(USART1, USART_FLAG_RXNE) == RESET);

	return (int)USART_ReceiveData(USART1);
#endif
}

/*****************************  www.armfly.com (END OF FILE) *********************************/
