/*
*********************************************************************************************************
*
*	ģ : WM8978ƵоƬģ
*	ļ : bsp_wm8978.h
*	     : V1.0
*	˵     : WM8978ƵоƬSTM32 I2SײڰSTM32-V5ϵͨ
*
*	޸ļ¼ :
*		汾               ˵
*		V1.0    2013-02-01 armfly  ʽ
*		V1.1    2013-06-12 armfly  Line 벻ܷ⡣޸ wm8978_CfgAudioPath() 
*		V1.1    2013-07-14 armfly  Lineӿĺ wm8978_SetLineGain()
*
*	Copyright (C), 2013-2014,  www.armfly.com
*
*********************************************************************************************************
*/
#include "bsp.h"

/*
*********************************************************************************************************
*
*	Ҫʾ:
*	1wm8978_ ͷĺǲWM8978ĴWM8978ĴͨI2Cģ߽е
*	2I2S_ ͷĺǲSTM32  I2SؼĴ
*	3ʵ¼ӦãҪͬʱWM8978STM32I2S
*	4ֺõβεĶST̼У磺I2S_Standard_PhillipsI2S_Standard_MSBI2S_Standard_LSB
*			  I2S_MCLKOutput_EnableI2S_MCLKOutput_Disable
*			  I2S_AudioFreq_8KI2S_AudioFreq_16KI2S_AudioFreq_22KI2S_AudioFreq_44KI2S_AudioFreq_48
*			  I2S_Mode_MasterTxI2S_Mode_MasterRx
*	5ע pdf ָ wm8978.pdf ֲᣬwm8978deĴܶ࣬õļĴעpdfļҳ룬ڲѯ
*
*********************************************************************************************************
*/

/*
	STM32-V5--- I2SߴƵݿ
	PB12/I2S2_WS
	PB13/I2S2_CK
	PI2/I2S2ext_SD
	PC3/I2S2_SD
	PC6/I2S2_MCK

	ΪGPIO޸ static void I2S_GPIO_Config(void) 
*/

/* ڱģڲʹõľֲ */
static uint16_t wm8978_ReadReg(uint8_t _ucRegAddr);
static uint8_t wm8978_WriteReg(uint8_t _ucRegAddr, uint16_t _usValue);
static void I2S_GPIO_Config(void);
static void I2S_Mode_Config(uint16_t _usStandard, uint16_t _usWordLen, uint32_t _uiAudioFreq, uint16_t _usMode);
static void I2S_NVIC_Config(void);
static void wm8978_Reset(void);

/*
	wm8978Ĵ
	WM8978I2C߽ӿڲֶ֧ȡ˼ĴֵڴУдĴʱͬ»棬Ĵʱ
	ֱӷػеֵ
	ĴMAP WM8978.pdf ĵ67ҳĴַ7bit Ĵ9bit
*/
static uint16_t wm8978_RegCash[] = {
	0x000, 0x000, 0x000, 0x000, 0x050, 0x000, 0x140, 0x000,
	0x000, 0x000, 0x000, 0x0FF, 0x0FF, 0x000, 0x100, 0x0FF,
	0x0FF, 0x000, 0x12C, 0x02C, 0x02C, 0x02C, 0x02C, 0x000,
	0x032, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000,
	0x038, 0x00B, 0x032, 0x000, 0x008, 0x00C, 0x093, 0x0E9,
	0x000, 0x000, 0x000, 0x000, 0x003, 0x010, 0x010, 0x100,
	0x100, 0x002, 0x001, 0x001, 0x039, 0x039, 0x039, 0x039,
	0x001, 0x001
};

/*
*********************************************************************************************************
*	  : wm8978_Init
*	˵: I2C GPIOI2CϵWM8978Ƿ
*	    :  
*	  ֵ: 1 ʾʼ0ʾʼ
*********************************************************************************************************
*/
uint8_t wm8978_Init(void)
{
	uint8_t re;

	if (i2c_CheckDevice(WM8978_SLAVE_ADDRESS) == 0)	/* STM32GPIOģI2Cʱ */
	{
		re = 1;
	}
	else
	{
		re = 0;
	}
	wm8978_Reset();			/* ӲλWM8978мĴȱʡ״̬ */
	return re;
}

/*
*********************************************************************************************************
*	  : wm8978_SetEarVolume
*	˵: ޸Ķ
*	    :  _ucLeftVolume ֵ, 0-63
*			  _ucLRightVolume : ֵ,0-63
*	  ֵ: 
*********************************************************************************************************
*/
void wm8978_SetEarVolume(uint8_t _ucVolume)
{
	uint16_t regL;
	uint16_t regR;

	if (_ucVolume > 0x3F)
	{
		_ucVolume = 0x3F;
	}

	regL = _ucVolume;
	regR = _ucVolume;

	/*
		R52	LOUT1 Volume control
		R53	ROUT1 Volume control
	*/
	/* ȸֵ */
	wm8978_WriteReg(52, regL | 0x00);

	/* ͬ */
	wm8978_WriteReg(53, regR | 0x100);	/* 0x180ʾ Ϊ0ʱٸ£ֵġա */
}

/*
*********************************************************************************************************
*	  : wm8978_SetSpkVolume
*	˵: ޸
*	    :  _ucLeftVolume ֵ, 0-63
*			  _ucLRightVolume : ֵ,0-63
*	  ֵ: 
*********************************************************************************************************
*/
void wm8978_SetSpkVolume(uint8_t _ucVolume)
{
	uint16_t regL;
	uint16_t regR;

	if (_ucVolume > 0x3F)
	{
		_ucVolume = 0x3F;
	}

	regL = _ucVolume;
	regR = _ucVolume;

	/*
		R54	LOUT2 (SPK) Volume control
		R55	ROUT2 (SPK) Volume control
	*/
	/* ȸֵ */
	wm8978_WriteReg(54, regL | 0x00);

	/* ͬ */
	wm8978_WriteReg(55, regR | 0x100);	/* Ϊ0ʱٸ£ֵġա */
}

/*
*********************************************************************************************************
*	  : wm8978_ReadEarVolume
*	˵: ضͨ.
*	    :  
*	  ֵ: ǰֵ
*********************************************************************************************************
*/
uint8_t wm8978_ReadEarVolume(void)
{
	return (uint8_t)(wm8978_ReadReg(52) & 0x3F );
}

/*
*********************************************************************************************************
*	  : wm8978_ReadSpkVolume
*	˵: ͨ.
*	    :  
*	  ֵ: ǰֵ
*********************************************************************************************************
*/
uint8_t wm8978_ReadSpkVolume(void)
{
	return (uint8_t)(wm8978_ReadReg(54) & 0x3F );
}

/*
*********************************************************************************************************
*	  : wm8978_OutMute
*	˵: .
*	    :  _ucMute 1Ǿ0ǲ.
*	  ֵ: ǰֵ
*********************************************************************************************************
*/
void wm8978_OutMute(uint8_t _ucMute)
{
	uint16_t usRegValue;

	if (_ucMute == 1) /*  */
	{
		usRegValue = wm8978_ReadReg(52); /* Left Mixer Control */
		usRegValue |= (1u << 6);
		wm8978_WriteReg(52, usRegValue);

		usRegValue = wm8978_ReadReg(53); /* Left Mixer Control */
		usRegValue |= (1u << 6);
		wm8978_WriteReg(53, usRegValue);

		usRegValue = wm8978_ReadReg(54); /* Right Mixer Control */
		usRegValue |= (1u << 6);
		wm8978_WriteReg(54, usRegValue);

		usRegValue = wm8978_ReadReg(55); /* Right Mixer Control */
		usRegValue |= (1u << 6);
		wm8978_WriteReg(55, usRegValue);
	}
	else	/* ȡ */
	{
		usRegValue = wm8978_ReadReg(52);
		usRegValue &= ~(1u << 6);
		wm8978_WriteReg(52, usRegValue);

		usRegValue = wm8978_ReadReg(53); /* Left Mixer Control */
		usRegValue &= ~(1u << 6);
		wm8978_WriteReg(53, usRegValue);

		usRegValue = wm8978_ReadReg(54);
		usRegValue &= ~(1u << 6);
		wm8978_WriteReg(54, usRegValue);

		usRegValue = wm8978_ReadReg(55); /* Left Mixer Control */
		usRegValue &= ~(1u << 6);
		wm8978_WriteReg(55, usRegValue);
	}
}

/*
*********************************************************************************************************
*	  : wm8978_SetMicGain
*	˵: MIC
*	    :  _ucGain ֵ, 0-63
*	  ֵ: 
*********************************************************************************************************
*/
void wm8978_SetMicGain(uint8_t _ucGain)
{
	if (_ucGain > GAIN_MAX)
	{
		_ucGain = GAIN_MAX;
	}

	/* PGA   R45 R46   pdf 19ҳ
		Bit8	INPPGAUPDATE
		Bit7	INPPGAZCL		ٸ
		Bit6	INPPGAMUTEL		PGA
		Bit5:0	ֵ0100000dB
	*/
	wm8978_WriteReg(45, _ucGain);
	wm8978_WriteReg(46, _ucGain | (1 << 8));
}

/*
*********************************************************************************************************
*	  : wm8978_SetLineGain
*	˵: Lineͨ
*	    :  _ucGain ֵ, 0-7. 70С ˥ɷŴ
*	  ֵ: 
*********************************************************************************************************
*/
void wm8978_SetLineGain(uint8_t _ucGain)
{
	uint16_t usRegValue;

	if (_ucGain > 7)
	{
		_ucGain = 7;
	}

	/*
		Mic ŵ PGABOOSTL  PGABOOSTR 
		Aux ŵ AUXL2BOOSTVO[2:0]  AUXR2BOOSTVO[2:0] 
		Line ŵ LIP2BOOSTVOL[2:0]  RIP2BOOSTVOL[2:0] 
	*/
	/*	pdf 21ҳR47R48, MIC ƼĴ
		R47 (R48ͬ)
		B8		PGABOOSTL	= 1,   0ʾMICźֱͨ棬1ʾMICź+20dB棨ͨԾٵ·
		B7		= 0 
		B6:4	L2_2BOOSTVOL = x 0ʾֹ1-7ʾ-12dB ~ +6dB  ˥ҲԷŴ
		B3		= 0 
		B2:0`	AUXL2BOOSTVOL = x0ʾֹ1-7ʾ-12dB ~ +6dB  ˥ҲԷŴ
	*/

	usRegValue = wm8978_ReadReg(47);
	usRegValue &= 0x8F;/* Bit6:40   1000 1111*/
	usRegValue |= (_ucGain << 4);
	wm8978_WriteReg(47, usRegValue);	/* дƼĴ */

	usRegValue = wm8978_ReadReg(48);
	usRegValue &= 0x8F;/* Bit6:40   1000 1111*/
	usRegValue |= (_ucGain << 4);
	wm8978_WriteReg(48, usRegValue);	/* дƼĴ */
}

/*
*********************************************************************************************************
*	  : wm8978_PowerDown
*	˵: رwm8978͹ģʽ
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void wm8978_PowerDown(void)
{
	wm8978_Reset();			/* ӲλWM8978мĴȱʡ״̬ */
}

/*
*********************************************************************************************************
*	  : wm8978_CfgAudioIF
*	˵: WM8978Ƶӿ(I2S)
*	    :
*			  _usStandard : ӿڱ׼I2S_Standard_Phillips, I2S_Standard_MSB  I2S_Standard_LSB
*			  _ucWordLen : ֳ162432  õ20bitʽ
*			  _usMode : CPU I2SĹģʽI2S_Mode_MasterTxI2S_Mode_MasterRx
*						Ӳ֧ I2S_Mode_SlaveTxI2S_Mode_SlaveRx ģʽҪWM8978
*						ⲿ
*	  ֵ: 
*********************************************************************************************************
*/
void wm8978_CfgAudioIF(uint16_t _usStandard, uint8_t _ucWordLen)
{
	uint16_t usReg;

	/* pdf 67ҳĴб */

	/*	REG R4, ƵӿڿƼĴ
		B8		BCP	 = X, BCLKԣ0ʾ1ʾ
		B7		LRCP = x, LRCʱӼԣ0ʾ1ʾ
		B6:5	WL = x ֳ00=16bit01=20bit10=24bit11=32bit Ҷģʽֻܲ24bit)
		B4:3	FMT = xƵݸʽ00=Ҷ룬01=룬10=I2Sʽ11=PCM
		B2		DACLRSWAP = x, DACݳLRCʱӵ߻ұ
		B1 		ADCLRSWAP = xADCݳLRCʱӵ߻ұ
		B0		MONO	= 00ʾ1ʾЧ
	*/
	usReg = 0;
	if (_usStandard == I2S_Standard_Phillips)	/* I2Sֱ׼ */
	{
		usReg |= (2 << 3);
	}
	else if (_usStandard == I2S_Standard_MSB)	/* MSB׼() */
	{
		usReg |= (1 << 3);
	}
	else if (_usStandard == I2S_Standard_LSB)	/* LSB׼(Ҷ) */
	{
		usReg |= (0 << 3);
	}
	else	/* PCM׼(16λͨ֡ϴ֡ͬ16λ֡չΪ32λͨ֡) */
	{
		usReg |= (3 << 3);;
	}

	if (_ucWordLen == 24)
	{
		usReg |= (2 << 5);
	}
	else if (_ucWordLen == 32)
	{
		usReg |= (3 << 5);
	}
	else
	{
		usReg |= (0 << 5);		/* 16bit */
	}
	wm8978_WriteReg(4, usReg);

	/* R5  pdf 57ҳ */


	/*
		R6ʱӲƼĴ
		MS = 0,  WM8978ʱӣMCUṩMCLKʱ
	*/
	wm8978_WriteReg(6, 0x000);
}

/*
*********************************************************************************************************
*	  : wm8978_ReadReg
*	˵: cashжضwm8978Ĵ
*	    :  _ucRegAddr  Ĵַ
*	  ֵ: 
*********************************************************************************************************
*/
static uint16_t wm8978_ReadReg(uint8_t _ucRegAddr)
{
	return wm8978_RegCash[_ucRegAddr];
}

/*
*********************************************************************************************************
*	  : wm8978_WriteReg
*	˵: дwm8978Ĵ
*	    :  _ucRegAddr  Ĵַ
*			  _usValue Ĵֵ
*	  ֵ: 
*********************************************************************************************************
*/
static uint8_t wm8978_WriteReg(uint8_t _ucRegAddr, uint16_t _usValue)
{
	uint8_t ucAck;

	/* ʼλ */
	i2c_Start();

	/* 豸ַ+дbit0 = w 1 = r) bit7 ȴ */
	i2c_SendByte(WM8978_SLAVE_ADDRESS | I2C_WR);

	/* ACK */
	ucAck = i2c_WaitAck();
	if (ucAck == 1)
	{
		return 0;
	}

	/* Ϳֽ1 */
	i2c_SendByte(((_ucRegAddr << 1) & 0xFE) | ((_usValue >> 8) & 0x1));

	/* ACK */
	ucAck = i2c_WaitAck();
	if (ucAck == 1)
	{
		return 0;
	}

	/* Ϳֽ2 */
	i2c_SendByte(_usValue & 0xFF);

	/* ACK */
	ucAck = i2c_WaitAck();
	if (ucAck == 1)
	{
		return 0;
	}

	/* STOP */
	i2c_Stop();

	wm8978_RegCash[_ucRegAddr] = _usValue;
	return 1;
}

/*
*********************************************************************************************************
*	  : wm8978_CfgInOut
*	˵: wm8978Ƶͨ
*	    :
*			_InPath : Ƶͨ
*			_OutPath : Ƶͨ
*	  ֵ: 
*********************************************************************************************************
*/
void wm8978_CfgAudioPath(uint16_t _InPath, uint16_t _OutPath)
{
	uint16_t usReg;

	/* 鿴WM8978ֲ REGISTER MAP ½ڣ 67ҳ */

	if ((_InPath == IN_PATH_OFF) && (_OutPath == OUT_PATH_OFF))
	{
		wm8978_PowerDown();
		return;
	}

	/* --------------------------- 1ͨüĴ -----------------------*/
	/*
		R1 Ĵ Power manage 1
		Bit8    BUFDCOPEN,  Output stage 1.5xAVDD/2 driver enable
 		Bit7    OUT4MIXEN, OUT4 mixer enable
		Bit6    OUT3MIXEN, OUT3 mixer enable
		Bit5    PLLEN	.
		Bit4    MICBEN	,Microphone Bias Enable (MICƫõ·ʹ)
		Bit3    BIASEN	,Analogue amplifier bias control Ϊ1ģŴŹ
		Bit2    BUFIOEN , Unused input/output tie off buffer enable
		Bit1:0  VMIDSEL, Ϊ00ֵģŴŹ
	*/
	usReg = (1 << 3) | (3 << 0);
	if (_OutPath & OUT3_4_ON) 	/* OUT3OUT4ʹGSMģ */
	{
		usReg |= ((1 << 7) | (1 << 6));
	}
	if ((_InPath & MIC_LEFT_ON) || (_InPath & MIC_RIGHT_ON))
	{
		usReg |= (1 << 4);
	}
	wm8978_WriteReg(1, usReg);	/* дĴ */

	/*
		R2 Ĵ Power manage 2
		Bit8	ROUT1EN,	ROUT1 output enable ʹ
		Bit7	LOUT1EN,	LOUT1 output enable ʹ
		Bit6	SLEEP, 		0 = Normal device operation   1 = Residual current reduced in device standby mode
		Bit5	BOOSTENR,	Right channel Input BOOST enable ͨԾٵ·ʹ. õPGAŴʱʹ
		Bit4	BOOSTENL,	Left channel Input BOOST enable
		Bit3	INPGAENR,	Right channel input PGA enable PGAʹ
		Bit2	INPGAENL,	Left channel input PGA enable
		Bit1	ADCENR,		Enable ADC right channel
		Bit0	ADCENL,		Enable ADC left channel
	*/
	usReg = 0;
	if (_OutPath & EAR_LEFT_ON)
	{
		usReg |= (1 << 7);
	}
	if (_OutPath & EAR_RIGHT_ON)
	{
		usReg |= (1 << 8);
	}
	if (_InPath & MIC_LEFT_ON)
	{
		usReg |= ((1 << 4) | (1 << 2));
	}
	if (_InPath & MIC_RIGHT_ON)
	{
		usReg |= ((1 << 5) | (1 << 3));
	}
	if (_InPath & LINE_ON)
	{
		usReg |= ((1 << 4) | (1 << 5));
	}
	if (_InPath & MIC_RIGHT_ON)
	{
		usReg |= ((1 << 5) | (1 << 3));
	}
	if (_InPath & ADC_ON)
	{
		usReg |= ((1 << 1) | (1 << 0));
	}
	wm8978_WriteReg(2, usReg);	/* дĴ */

	/*
		R3 Ĵ Power manage 3
		Bit8	OUT4EN,		OUT4 enable
		Bit7	OUT3EN,		OUT3 enable
		Bit6	LOUT2EN,	LOUT2 output enable
		Bit5	ROUT2EN,	ROUT2 output enable
		Bit4	0,
		Bit3	RMIXEN,		Right mixer enable
		Bit2	LMIXEN,		Left mixer enable
		Bit1	DACENR,		Right channel DAC enable
		Bit0	DACENL,		Left channel DAC enable
	*/
	usReg = 0;
	if (_OutPath & OUT3_4_ON)
	{
		usReg |= ((1 << 8) | (1 << 7));
	}
	if (_OutPath & SPK_ON)
	{
		usReg |= ((1 << 6) | (1 << 5));
	}
	if (_OutPath != OUT_PATH_OFF)
	{
		usReg |= ((1 << 3) | (1 << 2));
	}
	if (_InPath & DAC_ON)
	{
		usReg |= ((1 << 1) | (1 << 0));
	}
	wm8978_WriteReg(3, usReg);	/* дĴ */

	/*
		R44 Ĵ Input ctrl

		Bit8	MBVSEL, 		Microphone Bias Voltage Control   0 = 0.9 * AVDD   1 = 0.6 * AVDD
		Bit7	0
		Bit6	R2_2INPPGA,		Connect R2 pin to right channel input PGA positive terminal
		Bit5	RIN2INPPGA,		Connect RIN pin to right channel input PGA negative terminal
		Bit4	RIP2INPPGA,		Connect RIP pin to right channel input PGA amplifier positive terminal
		Bit3	0
		Bit2	L2_2INPPGA,		Connect L2 pin to left channel input PGA positive terminal
		Bit1	LIN2INPPGA,		Connect LIN pin to left channel input PGA negative terminal
		Bit0	LIP2INPPGA,		Connect LIP pin to left channel input PGA amplifier positive terminal
	*/
	usReg = 0 << 8;
	if (_InPath & LINE_ON)
	{
		usReg |= ((1 << 6) | (1 << 2));
	}
	if (_InPath & MIC_RIGHT_ON)
	{
		usReg |= ((1 << 5) | (1 << 4));
	}
	if (_InPath & MIC_LEFT_ON)
	{
		usReg |= ((1 << 1) | (1 << 0));
	}
	wm8978_WriteReg(44, usReg);	/* дĴ */


	/*
		R14 Ĵ ADC Control
		øͨ˲ѡģ pdf 2425ҳ,
		Bit8 	HPFEN,	High Pass Filter Enableͨ˲ʹܣ0ʾֹ1ʾʹ
		BIt7 	HPFAPP,	Select audio mode or application mode ѡƵģʽӦģʽ0ʾƵģʽ
		Bit6:4	HPFCUTApplication mode cut-off frequency  000-111ѡӦģʽĽֹƵ
		Bit3 	ADCOSR,	ADC oversample rate select: 0=64x (lower power) 1=128x (best performance)
		Bit2   	0
		Bit1 	ADC right channel polarity adjust:  0=normal  1=inverted
		Bit0 	ADC left channel polarity adjust:  0=normal 1=inverted
	*/
	if (_InPath & ADC_ON)
	{
		usReg = (1 << 3) | (0 << 8) | (4 << 0);		/* ֹADCͨ˲, ýƵ */
	}
	else
	{
		usReg = 0;
	}
	wm8978_WriteReg(14, usReg);	/* дĴ */

	/* ݲ˲notch filterҪƻͲХ.  ʱر
		R27R28R29R30 ڿ޲˲pdf 26ҳ
		R7 Bit7 NFEN = 0 ʾֹ1ʾʹ
	*/
	if (_InPath & ADC_ON)
	{
		usReg = (0 << 7);
		wm8978_WriteReg(27, usReg);	/* дĴ */
		usReg = 0;
		wm8978_WriteReg(28, usReg);	/* дĴ,0ΪѾֹҲɲ */
		wm8978_WriteReg(29, usReg);	/* дĴ,0ΪѾֹҲɲ */
		wm8978_WriteReg(30, usReg);	/* дĴ,0ΪѾֹҲɲ */
	}

	/* Զ ALC, R32  - 34  pdf 19ҳ */
	{
		usReg = 0;		/* ֹԶ */
		wm8978_WriteReg(32, usReg);
		wm8978_WriteReg(33, usReg);
		wm8978_WriteReg(34, usReg);
	}

	/*  R35  ALC Noise Gate Control
		Bit3	NGATEN, Noise gate function enable
		Bit2:0	Noise gate threshold:
	*/
	usReg = (3 << 1) | (7 << 0);		/* ֹԶ */
	wm8978_WriteReg(35, usReg);

	/*
		Mic ŵ PGABOOSTL  PGABOOSTR 
		Aux ŵ AUXL2BOOSTVO[2:0]  AUXR2BOOSTVO[2:0] 
		Line ŵ LIP2BOOSTVOL[2:0]  RIP2BOOSTVOL[2:0] 
	*/
	/*	pdf 21ҳR47R48, MIC ƼĴ
		R47 (R48ͬ)
		B8		PGABOOSTL	= 1,   0ʾMICźֱͨ棬1ʾMICź+20dB棨ͨԾٵ·
		B7		= 0 
		B6:4	L2_2BOOSTVOL = x 0ʾֹ1-7ʾ-12dB ~ +6dB  ˥ҲԷŴ
		B3		= 0 
		B2:0`	AUXL2BOOSTVOL = x0ʾֹ1-7ʾ-12dB ~ +6dB  ˥ҲԷŴ
	*/
	usReg = 0;
	if ((_InPath & MIC_LEFT_ON) || (_InPath & MIC_RIGHT_ON))
	{
		usReg |= (1 << 8);	/* MICȡ+20dB */
	}
	if (_InPath & AUX_ON)
	{
		usReg |= (3 << 0);	/* Aux̶ȡ3ûе */
	}
	if (_InPath & LINE_ON)
	{
		usReg |= (3 << 4);	/* Line̶ȡ3ûе */
	}
	wm8978_WriteReg(47, usReg);	/* дƼĴ */
	wm8978_WriteReg(48, usReg);	/* дƼĴ */

	/* ADCƣpdf 27ҳ
		R15 ADCR16ADC
		Bit8 	ADCVU  = 1 ʱŸ£ͬADC
		Bit7:0 	ѡ 0000 0000 = 
						   0000 0001 = -127dB
						   0000 0010 = -12.5dB  0.5dB 
						   1111 1111 = 0dB  ˥
	*/
	usReg = 0xFF;
	wm8978_WriteReg(15, usReg);	/* ѡ0dBȻ */
	usReg = 0x1FF;
	wm8978_WriteReg(16, usReg);	/* ͬ */

	/* ͨ wm8978_SetMicGain mic PGA */

	/*	R43 Ĵ  AUXR C ROUT2 BEEP Mixer Function
		B8:6 = 0

		B5	 MUTERPGA2INV,	Mute input to INVROUT2 mixer
		B4	 INVROUT2,  Invert ROUT2 output 
		B3:1 BEEPVOL = 7;	AUXR input to ROUT2 inverter gain
		B0	 BEEPEN = 1;	Enable AUXR beep input

	*/
	usReg = 0;
	if (_OutPath & SPK_ON)
	{
		usReg |= (1 << 4);	/* ROUT2 ,  */
	}
	if (_InPath & AUX_ON)
	{
		usReg |= ((7 << 1) | (1 << 0));
	}
	wm8978_WriteReg(43, usReg);

	/* R49  Output ctrl
		B8:7	0
		B6		DACL2RMIX,	Left DAC output to right output mixer
		B5		DACR2LMIX,	Right DAC output to left output
		B4		OUT4BOOST,	0 = OUT4 output gain = -1; DC = AVDD / 21 = OUT4 output gain = +1.5DC = 1.5 x AVDD / 2
		B3		OUT3BOOST,	0 = OUT3 output gain = -1; DC = AVDD / 21 = OUT3 output gain = +1.5DC = 1.5 x AVDD / 2
		B2		SPKBOOST,	0 = Speaker gain = -1;  DC = AVDD / 2 ; 1 = Speaker gain = +1.5; DC = 1.5 x AVDD / 2
		B1		TSDEN,   Thermal Shutdown Enable  ȱʹܣȱʡ1
		B0		VROI,	Disabled Outputs to VREF Resistance
	*/
	usReg = 0;
	if (_InPath & DAC_ON)
	{
		usReg |= ((1 << 6) | (1 << 5));
	}
	if (_OutPath & SPK_ON)
	{
		usReg |=  ((1 << 2) | (1 << 1));	/* SPK 1.5x,  ȱʹ */
	}
	if (_OutPath & OUT3_4_ON)
	{
		usReg |=  ((1 << 4) | (1 << 3));	/* BOOT3  BOOT4  1.5x */
	}
	wm8978_WriteReg(49, usReg);

	/*	REG 50    (5051üĴһ) pdf 40ҳ
		B8:6	AUXLMIXVOL = 111	AUXFMź
		B5		AUXL2LMIX = 1		Left Auxilliary input to left channel
		B4:2	BYPLMIXVOL			
		B1		BYPL2LMIX = 0;		Left bypass path (from the left channel input boost output) to left output mixer
		B0		DACL2LMIX = 1;		Left DAC output to left output mixer
	*/
	usReg = 0;
	if (_InPath & AUX_ON)
	{
		usReg |= ((7 << 6) | (1 << 5));
	}
	if ((_InPath & LINE_ON) || (_InPath & MIC_LEFT_ON) || (_InPath & MIC_RIGHT_ON))
	{
		usReg |= ((7 << 2) | (1 << 1));
	}
	if (_InPath & DAC_ON)
	{
		usReg |= (1 << 0);
	}
	wm8978_WriteReg(50, usReg);
	wm8978_WriteReg(51, usReg);

	/*	R56 Ĵ   OUT3 mixer ctrl
		B8:7	0
		B6		OUT3MUTE,  	0 = Output stage outputs OUT3 mixer;  1 = Output stage muted C drives out VMID.
		B5:4	0
		B3		BYPL2OUT3,	OUT4 mixer output to OUT3  ()
		B4		0
		B2		LMIX2OUT3,	Left ADC input to OUT3
		B1		LDAC2OUT3,	Left DAC mixer to OUT3
		B0		LDAC2OUT3,	Left DAC output to OUT3
	*/
	usReg = 0;
	if (_OutPath & OUT3_4_ON)
	{
		usReg |= (1 << 3);
	}
	wm8978_WriteReg(56, usReg);

	/* R57 Ĵ		OUT4 (MONO) mixer ctrl
		B8:7	0
		B6		OUT4MUTE,	0 = Output stage outputs OUT4 mixer  1 = Output stage muted C drives outVMID.
		B5		HALFSIG,	0 = OUT4 normal output	1 = OUT4 attenuated by 6dB
		B4		LMIX2OUT4,	Left DAC mixer to OUT4
		B3		LDAC2UT4,	Left DAC to OUT4
		B2		BYPR2OUT4,	Right ADC input to OUT4
		B1		RMIX2OUT4,	Right DAC mixer to OUT4
		B0		RDAC2OUT4,	Right DAC output to OUT4
	*/
	usReg = 0;
	if (_OutPath & OUT3_4_ON)
	{
		usReg |= ((1 << 4) |  (1 << 1));
	}
	wm8978_WriteReg(57, usReg);


	/* R11, 12 Ĵ DAC
		R11		Left DAC Digital Volume
		R12		Right DAC Digital Volume
	*/
	if (_InPath & DAC_ON)
	{
		wm8978_WriteReg(11, 255);
		wm8978_WriteReg(12, 255 | 0x100);
	}
	else
	{
		wm8978_WriteReg(11, 0);
		wm8978_WriteReg(12, 0 | 0x100);
	}

	/*	R10 Ĵ DAC Control
		B8	0
		B7	0
		B6	SOFTMUTE,	Softmute enable:
		B5	0
		B4	0
		B3	DACOSR128,	DAC oversampling rate: 0=64x (lowest power) 1=128x (best performance)
		B2	AMUTE,		Automute enable
		B1	DACPOLR,	Right DAC output polarity
		B0	DACPOLL,	Left DAC output polarity:
	*/
	if (_InPath & DAC_ON)
	{
		wm8978_WriteReg(10, 0);
	}
	;
}

/*
*********************************************************************************************************
*	  : wm8978_NotchFilter
*	˵: ݲ˲notch filterҪƻͲХ
*	    :  NFA0[13:0] and NFA1[13:0]
*	  ֵ: 
*********************************************************************************************************
*/
void wm8978_NotchFilter(uint16_t _NFA0, uint16_t _NFA1)
{
	uint16_t usReg;

	/*  page 26
		A programmable notch filter is provided. This filter has a variable centre frequency and bandwidth,
		programmable via two coefficients, a0 and a1. a0 and a1 are represented by the register bits
		NFA0[13:0] and NFA1[13:0]. Because these coefficient values require four register writes to setup
		there is an NFU (Notch Filter Update) flag which should be set only when all four registers are setup.
	*/
	usReg = (1 << 7) | (_NFA0 & 0x3F);
	wm8978_WriteReg(27, usReg);	/* дĴ */

	usReg = ((_NFA0 >> 7) & 0x3F);
	wm8978_WriteReg(28, usReg);	/* дĴ */

	usReg = (_NFA1 & 0x3F);
	wm8978_WriteReg(29, usReg);	/* дĴ */

	usReg = (1 << 8) | ((_NFA1 >> 7) & 0x3F);
	wm8978_WriteReg(30, usReg);	/* дĴ */
}

/*
*********************************************************************************************************
*	  : wm8978_CtrlGPIO1
*	˵: WM8978GPIO101
*	    :  _ucValue GPIO1ֵ01
*	  ֵ: 
*********************************************************************************************************
*/
void wm8978_CtrlGPIO1(uint8_t _ucValue)
{
	uint16_t usRegValue;

	/* R8 pdf 62ҳ */
	if (_ucValue == 0) /* 0 */
	{
		usRegValue = 6; /* B2:0 = 110 */
	}
	else
	{
		usRegValue = 7; /* B2:0 = 111 */
	}
	wm8978_WriteReg(8, usRegValue);
}

/*
*********************************************************************************************************
*	  : wm8978_Reset
*	˵: λwm8978еļĴֵָȱʡֵ
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
static void wm8978_Reset(void)
{
	/* wm8978Ĵȱʡֵ */
	const uint16_t reg_default[] = {
	0x000, 0x000, 0x000, 0x000, 0x050, 0x000, 0x140, 0x000,
	0x000, 0x000, 0x000, 0x0FF, 0x0FF, 0x000, 0x100, 0x0FF,
	0x0FF, 0x000, 0x12C, 0x02C, 0x02C, 0x02C, 0x02C, 0x000,
	0x032, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000,
	0x038, 0x00B, 0x032, 0x000, 0x008, 0x00C, 0x093, 0x0E9,
	0x000, 0x000, 0x000, 0x000, 0x003, 0x010, 0x010, 0x100,
	0x100, 0x002, 0x001, 0x001, 0x039, 0x039, 0x039, 0x039,
	0x001, 0x001
	};
	uint8_t i;

	wm8978_WriteReg(0x00, 0);

	for (i = 0; i < sizeof(reg_default) / 2; i++)
	{
		wm8978_RegCash[i] = reg_default[i];
	}
}

/*
*********************************************************************************************************
*	                     ĴǺSTM32 I2SӲص
*********************************************************************************************************
*/

/*
*********************************************************************************************************
*	  : I2S_CODEC_Init
*	˵: GPIOźжͨcodecӦ
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void I2S_CODEC_Init(void)
{
	/* I2Sжͨ */
	I2S_NVIC_Config();

	/* I2S2 GPIO */
	I2S_GPIO_Config();

	/* ֹI2S2 TXEж(ͻ)Ҫʱٴ */
	SPI_I2S_ITConfig(SPI2, SPI_I2S_IT_TXE, DISABLE);

	/* ֹI2S2 RXNEж(ղ)Ҫʱٴ */
	SPI_I2S_ITConfig(I2S2ext, SPI_I2S_IT_RXNE, DISABLE);
}

/*
*********************************************************************************************************
*	  : I2S_StartPlay
*	˵: I2SģʽI2Sͻжϣʼ
*	    :  _usStandard : ӿڱ׼I2S_Standard_Phillips, I2S_Standard_MSB  I2S_Standard_LSB
*			  _usMCLKOutput : ʱI2S_MCLKOutput_Enable or I2S_MCLKOutput_Disable
*			  _uiAudioFreq : ƵʣI2S_AudioFreq_8KI2S_AudioFreq_16KI2S_AudioFreq_22K
*							I2S_AudioFreq_44KI2S_AudioFreq_48
*	  ֵ: 
*********************************************************************************************************
*/
void I2S_StartPlay(uint16_t _usStandard, uint16_t _usWordLen,  uint32_t _uiAudioFreq)
{
	/* I2SΪģʽSTM32ṩʱӣI2SݿǷͷ() */
	I2S_Mode_Config(_usStandard, _usWordLen, _uiAudioFreq, I2S_Mode_MasterTx);

	SPI_I2S_ITConfig(SPI2, SPI_I2S_IT_TXE, ENABLE);		/* ʹܷж */
}

/*
*********************************************************************************************************
*	  : I2S_StartRecord
*	˵: I2SģʽI2Sջжϣʼ¼ڵñǰWM8978¼ͨ
*	    :  _usStandard : ӿڱ׼I2S_Standard_Phillips, I2S_Standard_MSB  I2S_Standard_LSB
*			  _usMCLKOutput : ʱI2S_MCLKOutput_Enable or I2S_MCLKOutput_Disable
*			  _uiAudioFreq : ƵʣI2S_AudioFreq_8KI2S_AudioFreq_16KI2S_AudioFreq_22K
*							I2S_AudioFreq_44KI2S_AudioFreq_48
*	  ֵ: 
*********************************************************************************************************
*/
void I2S_StartRecord(uint16_t _usStandard, uint16_t _usWordLen, uint32_t _uiAudioFreq)
{
	/* I2SΪģʽSTM32ṩʱӣI2SݿǷͷ() */
	I2S_Mode_Config(_usStandard, _usWordLen, _uiAudioFreq, I2S_Mode_MasterTx);
	SPI_I2S_ITConfig(I2S2ext, SPI_I2S_IT_RXNE, ENABLE);		/* ʹܽж */

	SPI_I2S_ITConfig(SPI2, SPI_I2S_IT_TXE, ENABLE);		/* ʹܷж */
	SPI_I2S_SendData(SPI2, 0);
}

/*
*********************************************************************************************************
*	  : I2S_Stop
*	˵: ֹͣI2S
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void I2S_Stop(void)
{
	/* ֹI2S2 TXEж(ͻ)Ҫʱٴ */
	SPI_I2S_ITConfig(SPI2, SPI_I2S_IT_TXE, DISABLE);

	/* ֹI2S2 RXNEж(ղ)Ҫʱٴ */
	SPI_I2S_ITConfig(I2S2ext, SPI_I2S_IT_RXNE, DISABLE);

	/*  SPI2/I2S2  */
	I2S_Cmd(SPI2, DISABLE);

	/* ر I2S2 APB1 ʱ */
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_SPI2, ENABLE);
}


/*
*********************************************************************************************************
*	  : I2S_GPIO_Config
*	˵: GPIOcodecӦ
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
static void I2S_GPIO_Config(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;

	/*
		STM32-V5--- I2SߴƵݿ
		PB12/I2S2_WS
		PB13/I2S2_CK
		PI2/I2S2ext_SD
		PC3/I2S2_SD
		PC6/I2S2_MCK
	*/
	/* ʹSPI2ʱ */
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_SPI2, ENABLE);

	/* Enable GPIOI, GPIOB, GPIOC clock */
	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOB | RCC_AHB1Periph_GPIOC | RCC_AHB1Periph_GPIOI, ENABLE);

	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12 | GPIO_Pin_13;
	GPIO_Init(GPIOB, &GPIO_InitStructure);

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3 | GPIO_Pin_6;
	GPIO_Init(GPIOC, &GPIO_InitStructure);

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;
	GPIO_Init(GPIOI, &GPIO_InitStructure);

	/* Connect pins to I2S peripheral  */
	GPIO_PinAFConfig(GPIOB, GPIO_PinSource12, GPIO_AF_SPI2);
	GPIO_PinAFConfig(GPIOB, GPIO_PinSource13, GPIO_AF_SPI2);
	GPIO_PinAFConfig(GPIOI, GPIO_PinSource2, GPIO_AF_SPI3);	/* ע⣺ PI2Ҫ SPI3 */
	GPIO_PinAFConfig(GPIOC, GPIO_PinSource3, GPIO_AF_SPI2);
	GPIO_PinAFConfig(GPIOC, GPIO_PinSource6, GPIO_AF_SPI2);
}

/*
*********************************************************************************************************
*	  : I2S_Config
*	˵: STM32I2S蹤ģʽ
*	    :  _usStandard : ӿڱ׼I2S_Standard_Phillips, I2S_Standard_MSB  I2S_Standard_LSB
*			  _usMCLKOutput : ʱI2S_MCLKOutput_Enable or I2S_MCLKOutput_Disable
*			  _usAudioFreq : ƵʣI2S_AudioFreq_8KI2S_AudioFreq_16KI2S_AudioFreq_22K
*							I2S_AudioFreq_44KI2S_AudioFreq_48
*			  _usMode : CPU I2SĹģʽI2S_Mode_MasterTxI2S_Mode_MasterRx
*						Ӳ֧ I2S_Mode_SlaveTxI2S_Mode_SlaveRx ģʽҪWM8978
*						ⲿ
*	  ֵ: 
*********************************************************************************************************
*/
static void I2S_Mode_Config(uint16_t _usStandard, uint16_t _usWordLen, uint32_t _uiAudioFreq, uint16_t _usMode)
{
	I2S_InitTypeDef I2S_InitStructure;

	if ((_usMode == I2S_Mode_SlaveTx) && (_usMode == I2S_Mode_SlaveRx))
	{
		/* 岻֧2ģʽ */
		return;
	}

	/*
		For I2S mode, make sure that either:
			- I2S PLL is configured using the functions RCC_I2SCLKConfig(RCC_I2S2CLKSource_PLLI2S),
			RCC_PLLI2SCmd(ENABLE) and RCC_GetFlagStatus(RCC_FLAG_PLLI2SRDY).
	*/
	{
		uint32_t n = 0;
		FlagStatus status = RESET;

		RCC_I2SCLKConfig(RCC_I2S2CLKSource_PLLI2S);
		RCC_PLLI2SCmd(ENABLE);

		for (n = 0; n < 500; n++)
		{
			status = RCC_GetFlagStatus(RCC_FLAG_PLLI2SRDY);
			if (status == 1)
			{
				break;
			}
		}
	}

	/*  I2S2 APB1 ʱ */
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_SPI2, ENABLE);

	/* λ SPI2 赽ȱʡ״̬ */
	SPI_I2S_DeInit(SPI2);

	/* I2S2  */
	//if (_usMode == I2S_Mode_MasterTx)
	{
		I2S_StructInit(&I2S_InitStructure);
		I2S_InitStructure.I2S_Mode = I2S_Mode_MasterTx;			/* I2Sģʽ */
		I2S_InitStructure.I2S_Standard = _usStandard;			/* ӿڱ׼ */
		I2S_InitStructure.I2S_DataFormat = _usWordLen;			/* ݸʽ16bit */
		I2S_InitStructure.I2S_MCLKOutput = I2S_MCLKOutput_Enable;	/* ʱģʽ */
		I2S_InitStructure.I2S_AudioFreq = _uiAudioFreq;			/* ƵƵ */
		I2S_InitStructure.I2S_CPOL = I2S_CPOL_Low;
		I2S_Init(SPI2, &I2S_InitStructure);

		/* Configure the I2Sx_ext (the second instance) in Slave Receiver Mode */
		I2S_FullDuplexConfig(I2S2ext, &I2S_InitStructure);

		/* ʹ SPI2/I2S2  */
		I2S_Cmd(SPI2, ENABLE);

		/* Enable the I2Sx_ext peripheral for Full Duplex mode */
		I2S_Cmd(I2S2ext, ENABLE);
	}

	/* ֹI2S2 TXEж(ͻ)Ҫʱٴ */
	SPI_I2S_ITConfig(SPI2, SPI_I2S_IT_TXE, DISABLE);

	/* ֹI2S2 RXNEж(ղ)Ҫʱٴ */
	SPI_I2S_ITConfig(I2S2ext, SPI_I2S_IT_RXNE, DISABLE);

#if 0		/* һδڲI2S˫书 */
	while (1)
	{
		static uint16_t usData;

		if (SPI_I2S_GetFlagStatus(SPI2, SPI_I2S_FLAG_TXE) == SET)
		{
			SPI_I2S_SendData(SPI2, 0x55);
		}

		if (SPI_I2S_GetFlagStatus(I2S2ext, SPI_I2S_FLAG_RXNE) == SET)
		{
			usData = SPI_I2S_ReceiveData(I2S2ext);

			printf("%02X ", usData);
		}
	}
#endif
}

/*
*********************************************************************************************************
*	  : I2S_NVIC_Config
*	˵: I2S NVICͨ(жģʽ)жϷvoid SPI2_IRQHandler(void) stm32f10x_it.c
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
static void I2S_NVIC_Config(void)
{
	NVIC_InitTypeDef NVIC_InitStructure;

	/* SPI2 IRQ ͨ */
	NVIC_InitStructure.NVIC_IRQChannel = SPI2_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure);
}

/*****************************  www.armfly.com (END OF FILE) *********************************/
